SystemOrganization addCategory: #'Orca-Cache'!
SystemOrganization addCategory: #'Orca-Server'!
SystemOrganization addCategory: #'Orca-Applications'!
SystemOrganization addCategory: #'Orca-Examples-ClassBrowser'!
SystemOrganization addCategory: #'Orca-Examples-Workspace'!
SystemOrganization addCategory: #'Orca-Widgets'!
SystemOrganization addCategory: #'Orca-Examples-BallGame'!
SystemOrganization addCategory: #'Orca-Stubs'!
SystemOrganization addCategory: #'Orca-Tests'!
SystemOrganization addCategory: #'Orca-Translator'!
SystemOrganization addCategory: #'Orca-Examples-System-Status'!
SystemOrganization addCategory: #'Orca-Installer'!
SystemOrganization addCategory: #'Orca-RemoteObjects'!

!Character methodsFor: '*Orca' stamp: 'ag 4/6/2011 15:52'!
definitionLine
	
	^ OrcaSqueakAstToJsAst charFunction asString, '(', (OrcaAbstractPrinter asJSString: self asString), ')'! !

Object subclass: #AnObsoleteAnObsoleteAnObsoletea subclass of Object
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'nil'!

AnObsoleteAnObsoleteAnObsoletea subclass of Object class
	instanceVariableNames: 'subclasses name classPool sharedPools environment category'!

AnObsoleteAnObsoleteAnObsoletea subclass of Object class
	instanceVariableNames: 'subclasses name classPool sharedPools environment category'!

!Object methodsFor: '*Orca' stamp: 'hk 4/5/2011 12:51'!
clientSideResposibility

	self error: thisContext sender selector printString, ' is only implemented on client side' ! !

Object subclass: #OrcaAbstractCodeFactory
	instanceVariableNames: 'codeCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

OrcaAbstractCodeFactory class
	instanceVariableNames: 'instance'!

!OrcaAbstractCodeFactory commentStamp: 'ag 12/16/2010 12:46' prior: 0!
S2JCodeFactory readAllCodeInImage.

S2JCodeFactory clearCache.

S2JCodeFactory codeCache size. 84964. 64386. " 62492 !!!! ".

S2JCodeFactory codeFor: 'a doit-snippet squeak code'.

S2JCodeFactory  codeForClass: Object.

S2JCodeFactory codeForMethod: #asString of: Object.
!

OrcaAbstractCodeFactory class
	instanceVariableNames: 'instance'!

!OrcaAbstractCodeFactory class methodsFor: 'cache' stamp: 'ag 3/28/2011 10:26'!
clearCaches
	
	self subclassesDo: [ :cl | cl clearCache ].! !

!OrcaAbstractCodeFactory class methodsFor: 'converting' stamp: 'ag 1/5/2011 22:12'!
converterClass
	
	self subclassResponsibility! !

!OrcaAbstractCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/16/2010 11:44'!
destroyInstance
	
	instance := nil.! !

!OrcaAbstractCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/13/2010 15:43'!
doesNotUnderstand: aMessage
	"removes need to call instance every time the code-factory is accessed"
	
	^ self instance perform: aMessage selector withArguments: aMessage arguments! !

!OrcaAbstractCodeFactory class methodsFor: 'configuration' stamp: 'lw 3/28/2011 13:25'!
doesNotUnderstandClass

	^ '_DoesNotUnderstandClass_'! !

!OrcaAbstractCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/16/2010 11:09'!
instance
	
	instance ifNil: [ instance := self new ].
	^ instance! !

!OrcaAbstractCodeFactory methodsFor: 'private' stamp: 'LT 3/16/2011 12:32:24.791'!
cacheCodeFor: anObject producedBy: aBlock
	
	^ (self cacheObjectFor: anObject producedBy: aBlock) javaScriptCode! !

!OrcaAbstractCodeFactory methodsFor: 'private' stamp: 'ag 4/6/2011 15:52'!
cacheObjectFor: anObject producedBy: aBlock
	"cacheObject* returns the value in the dictionary, not the javascript-code (this is done by cacheCodeFor*)"
	
	| result |
	result := self codeCache at: anObject ifAbsent: [ nil ].
	result
		ifNil: [
			result := aBlock value.
			[ result update ] on: Error do: [
				result := OrcaCompilationError from: anObject inFactory: self. result update ].
			self codeCache at: anObject put: result ]
		ifNotNil: [
			result hasChanged ifTrue: [ result update ]].
	^ result! !

!OrcaAbstractCodeFactory methodsFor: 'private' stamp: 'ag 4/6/2011 15:52'!
cacheObjectForClass: aClassOrClassname
	"cacheObject* returns the value in the dictionary, not the javascript-code (this is done by cacheCodeFor*)"
	
	| cl |
	cl := self class converterClass classNamed: aClassOrClassname.
	^ self
		cacheObjectFor: cl
		producedBy: [ OrcaTranslatedClass from: cl inFactory: self ]! !

!OrcaAbstractCodeFactory methodsFor: 'private' stamp: 'ag 4/6/2011 15:52'!
cacheObjectForMethod: aCompiledMethod
	"cacheObject* returns the value in the dictionary, not the javascript-code (this is done by cacheCodeFor*)"
	
	^ self
		cacheObjectFor: aCompiledMethod
		producedBy: [
			OrcaTranslatedMethod from: aCompiledMethod inFactory: self ]! !

!OrcaAbstractCodeFactory methodsFor: 'cache' stamp: 'LT 3/16/2011 12:24:21.722'!
clearCache
	
	self codeCache removeAll.! !

!OrcaAbstractCodeFactory methodsFor: 'accessing' stamp: 'ag 12/13/2010 14:30'!
codeCache
	^ codeCache! !

!OrcaAbstractCodeFactory methodsFor: 'accessing' stamp: 'ag 12/13/2010 14:30'!
codeCache: anObject
	codeCache := anObject! !

!OrcaAbstractCodeFactory methodsFor: 'javascript code' stamp: 'ag 4/6/2011 15:52'!
codeFor: aString
	"A simple DoIt-code-snippet"
	
	^ self
		cacheCodeFor: aString
		producedBy: [ OrcaTranslatedDoIt from: aString inFactory: self ]! !

!OrcaAbstractCodeFactory methodsFor: 'javascript code' stamp: 'LT 3/16/2011 12:32:24.802'!
codeForClass: aClassOrClassName
	"A JS-Code-String representing the whole class. Without a DoIt code-snippet etc."
	
	^ (self cacheObjectForClass: aClassOrClassName) javaScriptCode! !

!OrcaAbstractCodeFactory methodsFor: 'javascript code' stamp: 'ag 4/6/2011 15:52'!
codeForClasses: anArrayOfClasses
	"An JS-code-string representing all classes in anArrayOfClasses"
	
	^ self
		cacheCodeFor: anArrayOfClasses
		producedBy: [ OrcaTranslatedClasses from: anArrayOfClasses inFactory: self ]! !

!OrcaAbstractCodeFactory methodsFor: 'javascript code' stamp: 'LT 3/16/2011 12:32:24.814'!
codeForCompiledMethod: aCompiledMethod
	"An association from the function-name to the function-declaration-code"
	
	^ (self cacheObjectForMethod: aCompiledMethod) javaScriptCode! !

!OrcaAbstractCodeFactory methodsFor: 'javascript code' stamp: 'ag 1/5/2011 20:13'!
codeForMethod: aMethodSelector of: aClassOrClassName
	
	^ self codeForCompiledMethod:
		(self class converterClass method: aMethodSelector of: aClassOrClassName)! !

!OrcaAbstractCodeFactory methodsFor: 'private' stamp: 'ag 12/16/2010 11:47'!
compareCacheKey: o1 to: o2
	"CompiledMethods are considered equal, if they represent the same selector in the same class.
	Even after recompilation of a method, the old instance of CompiledMethod will be kept in the dictionary."
	
	o1 class = o2 class ifFalse: [ ^ false ].
	^ o1 class = CompiledMethod
		ifTrue: [ o1 methodClass = o2 methodClass and: [ o1 selector = o2 selector ] ]
		ifFalse: [ o1 = o2 ]! !

!OrcaAbstractCodeFactory methodsFor: 'accessing-derived' stamp: 'lw 3/28/2011 13:47'!
converterClass

	^ self class converterClass! !

!OrcaAbstractCodeFactory methodsFor: 'private' stamp: 'ag 1/3/2011 22:19'!
hashCodeFor: anObject
	
	^ anObject class = CompiledMethod
		ifTrue: [ 7 * anObject methodClass hash + anObject selector hash]
		ifFalse: [ anObject hash ]! !

!OrcaAbstractCodeFactory methodsFor: 'initialization' stamp: 'LT 3/16/2011 12:24:15.75'!
initialize
	
	super initialize.
	self codeCache: PluggableDictionary new.
	self codeCache
		equalBlock: [ :o1 :o2 | self compareCacheKey: o1 to: o2 ];
		hashBlock: [ :object | self hashCodeFor: object ].! !

!OrcaAbstractCodeFactory methodsFor: 'cache' stamp: 'ag 2/1/2011 14:04'!
invalidateMethod: aSelector of: anObject
	
	^ self invalidateObject: (self class converterClass method: aSelector of: anObject)! !

!OrcaAbstractCodeFactory methodsFor: 'cache' stamp: 'ag 2/1/2011 13:51'!
invalidateObject: anObject
	
	^ self codeCache removeKey: anObject! !

!OrcaAbstractCodeFactory methodsFor: 'cache' stamp: 'ag 2/1/2011 13:51'!
isObjectCached: anObject
	
	^ self codeCache includesKey: anObject! !

!OrcaAbstractCodeFactory methodsFor: 'javascript code' stamp: 'ag 1/9/2011 13:58'!
printCodeFor: aCachedObject to: aFilename
	"Print the code for an object, that is already in the cache, to a new (or overridden) file aFilename.
	Return nil, if object already in cache, return the printed code if successfull."
	
	^ self class converterClass
		print: (self cacheCodeFor: aCachedObject producedBy: [ ^ nil ])
		to: aFilename! !

!OrcaAbstractCodeFactory methodsFor: 'javascript code' stamp: 'ag 1/6/2011 21:03'!
readAllCodeInImage
	"Read each method in the image. This will not throw an error, just skip methods, that cannot be read."
	
	self class converterClass allMethodsDoAndReport: [ :eachMethod |
		self codeForCompiledMethod: eachMethod ].! !

OrcaAbstractCodeFactory subclass: #OrcaCodeFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OrcaCodeFactory commentStamp: 'ag 12/16/2010 12:46' prior: 0!
S2JCodeFactory readAllCodeInImage.

S2JCodeFactory clearCache.

S2JCodeFactory codeCache size. 84964. 64386. " 62492 !!!! ".

S2JCodeFactory codeFor: 'a doit-snippet squeak code'.

S2JCodeFactory  codeForClass: Object.

S2JCodeFactory codeForMethod: #asString of: Object.
!

!OrcaCodeFactory class methodsFor: 'converting' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaPrinter! !

OrcaAbstractCodeFactory subclass: #OrcaPrettyCodeFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OrcaPrettyCodeFactory class methodsFor: 'converting' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaPrettyPrinter! !

Object subclass: #OrcaClient
	instanceVariableNames: 'revision application serverObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaClient class methodsFor: 'configuration' stamp: 'SW 1/25/2011 12:00'!
defaultRevision

	^ 1! !

!OrcaClient methodsFor: 'convenience' stamp: 'SW 1/17/2011 12:25'!
adaptRevision

	self revision: self application repository revision.! !

!OrcaClient methodsFor: 'accessing' stamp: 'LT 1/17/2011 12:16:26.766'!
application
	^ application! !

!OrcaClient methodsFor: 'accessing' stamp: 'LT 1/17/2011 12:16:26.778'!
application: anObject
	application := anObject! !

!OrcaClient methodsFor: 'client handling' stamp: 'SW 1/17/2011 15:35'!
identifier

	self subclassResponsibility ! !

!OrcaClient methodsFor: 'convenience' stamp: 'SW 1/17/2011 12:25'!
increaseRevision

	self revision: (self revision + 1).
! !

!OrcaClient methodsFor: 'initialization' stamp: 'lw 4/5/2011 11:50'!
initialize

	self revision: self class defaultRevision.
	self serverObjects: Dictionary new.! !

!OrcaClient methodsFor: 'initialization' stamp: 'SW 1/17/2011 12:42'!
isAMethodInvokation: aMessage
	 	
	^ aMessage beginsWith: 'INVOKE: '! !

!OrcaClient methodsFor: 'initialization' stamp: 'HK 1/5/2011 16:52'!
isAlive 

	self subclassResponsibility.! !

!OrcaClient methodsFor: 'convenience' stamp: 'SW 1/18/2011 15:35'!
isBehind

	^ self revision < self application repository revision ! !

!OrcaClient methodsFor: 'convenience' stamp: 'SW 1/18/2011 15:36'!
isBehindFor: aRepository

	^ self revision < aRepository revision.! !

!OrcaClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:17'!
isCometClient

	^ self subclassResponsibility.! !

!OrcaClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:17'!
isWebSocketClient

	^ self subclassResponsibility.! !

!OrcaClient methodsFor: 'initialization' stamp: 'SW 1/18/2011 14:56'!
receive: aMessage
	"Send aMessage from server to client. The client should receive that message."
	
	 ^ self subclassResponsibility ! !

!OrcaClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 22:35'!
revision
	^ revision! !

!OrcaClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 22:35'!
revision: anObject
	revision := anObject! !

!OrcaClient methodsFor: 'initialization' stamp: 'SW 1/18/2011 11:23'!
sent: aMessage

	"Send aMessage from client to server. The server should receive that message."
	
	 ^ self subclassResponsibility ! !

!OrcaClient methodsFor: 'accessing' stamp: 'lw 4/5/2011 11:50'!
serverObjects
	^ serverObjects! !

!OrcaClient methodsFor: 'accessing' stamp: 'lw 4/5/2011 11:50'!
serverObjects: anObject
	serverObjects := anObject! !

!OrcaClient methodsFor: 'client handling' stamp: 'LT 1/17/2011 12:13:49.516'!
update

	self subclassResponsibility! !

OrcaClient subclass: #OrcaCometClient
	instanceVariableNames: 'identifier timeStampOfLatestRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaCometClient class methodsFor: 'configuration' stamp: 'SW 1/25/2011 12:16'!
HTTPStatusCodeTimeOut
	
	^ 408! !

!OrcaCometClient class methodsFor: 'configuration' stamp: 'lw 1/25/2011 17:24'!
defaultMaximumAge

	^ Duration minutes: 10 ! !

!OrcaCometClient class methodsFor: 'configuration' stamp: 'SW 1/18/2011 15:40'!
defaultMillisecondsToWait

	^ 500! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 16:47'!
checkLivelinessDelayed

	[ (Delay forDuration: self class defaultMaximumAge) wait. 
	self isAlive ifFalse: [
		self application removeClient: self ]] fork.! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 14:34'!
identifier
	^ identifier! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 14:34'!
identifier: anObject
	identifier := anObject! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/25/2011 11:14'!
initialize 
	
	super initialize.
	self timeStampOfLatestRequest: TimeStamp now! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 16:11'!
isAlive

	^ (TimeStamp now - self timeStampOfLatestRequest < self class defaultMaximumAge )! !

!OrcaCometClient methodsFor: 'convenience' stamp: 'SW 1/25/2011 11:46'!
isCometClient

	^ true! !

!OrcaCometClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isWebSocketClient

	^ false.! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 15:57'!
receive: aMessage


! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 16:03'!
sent: aMessage

	self timeStampOfLatestRequest: TimeStamp now.
	self application processClientData: aMessage! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 15:59'!
timeStampOfLatestRequest
	^ timeStampOfLatestRequest! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 15:59'!
timeStampOfLatestRequest: anObject
	timeStampOfLatestRequest := anObject! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/25/2011 12:16'!
update

	self timeStampOfLatestRequest: TimeStamp now.
	[ self isBehind ] whileFalse:
		[ self isAlive ifFalse:
			[ self application removeClient: self.
			^ self application answerWithStatusCode: self class HTTPStatusCodeTimeOut ]. 
		self wait ].
	self checkLivelinessDelayed.	
	^ self application answerNewContentTo: self! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 14:57'!
wait

	self waitForMilliseconds: self class defaultMillisecondsToWait.! !

!OrcaCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 14:57'!
waitForMilliseconds: milliseconds

	(Delay forMilliseconds: milliseconds) wait.! !

OrcaClient subclass: #OrcaWebSocketClient
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaWebSocketClient class methodsFor: 'instance creation' stamp: 'HK 12/15/2010 21:46'!
newWithSocket: aWebSocket

	^ self basicNew socket: aWebSocket; initialize.! !

!OrcaWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/17/2011 15:34'!
close

	self isAlive ifTrue: [ self socket close ].
	self application  removeClient: self.! !

!OrcaWebSocketClient methodsFor: 'configuration' stamp: 'ag 4/6/2011 18:11'!
defaultReceiveBlock

	
	^ [ :message |
		self receivePost: message.
		"OrcaDispatcher updateContentWith: message.
		OrcaWebSocketHandler updateAllClientsExcept: self "		
		].! !

!OrcaWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/17/2011 15:35'!
identifier
	
	 ^ 'WebSocket'! !

!OrcaWebSocketClient methodsFor: 'initialization' stamp: 'SW 1/18/2011 11:23'!
initialize

	super initialize.
	self socket receiveBlock: [:aMessage | self sent: aMessage ]! !

!OrcaWebSocketClient methodsFor: 'convenience' stamp: 'HK 1/5/2011 16:53'!
isAlive
	
	^ self socket isOpen and: [ self socket connection stream notNil ].! !

!OrcaWebSocketClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isCometClient

	^ false.! !

!OrcaWebSocketClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isWebSocketClient

	^ true.! !

!OrcaWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/31/2011 10:12'!
receive: aMessage

	[ self socket send: aMessage asString ] on: Error do: [ self application removeClient: self ].! !

!OrcaWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/18/2011 15:01'!
sent: aMessage

	self application processClientData: aMessage! !

!OrcaWebSocketClient methodsFor: 'accessing' stamp: 'HK 12/14/2010 10:20'!
socket
	^ socket! !

!OrcaWebSocketClient methodsFor: 'accessing' stamp: 'HK 12/14/2010 10:20'!
socket: anObject
	socket := anObject! !

!OrcaWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/18/2011 11:03'!
update

	 [ self isBehind ] whileTrue: [self increaseRevision. 
		self receive: (self application repository contentAtRevision: self revision) ]
		! !

Object subclass: #OrcaContentRepository
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaContentRepository methodsFor: 'management' stamp: 'ag 1/12/2011 19:54'!
addContent: javascriptCode
	
	^ self repository add: javascriptCode! !

!OrcaContentRepository methodsFor: 'management' stamp: 'ag 1/12/2011 19:53'!
contentAtRevision: aRevision

	^ self repository
		at: aRevision
		ifAbsent: [ nil ]! !

!OrcaContentRepository methodsFor: 'management' stamp: 'ag 1/12/2011 19:54'!
initialize
	
	self
		repository: OrderedCollection new;
		addContent: ''.! !

!OrcaContentRepository methodsFor: 'management' stamp: 'SW 1/18/2011 15:36'!
latestContent
	
	^ self contentAtRevision: self revision.! !

!OrcaContentRepository methodsFor: 'accessing' stamp: 'HK 1/11/2011 16:44'!
repository
	^ repository! !

!OrcaContentRepository methodsFor: 'accessing' stamp: 'HK 1/11/2011 16:44'!
repository: anObject
	repository := anObject! !

!OrcaContentRepository methodsFor: 'management' stamp: 'SW 1/18/2011 15:36'!
revision
	
	^ self repository size! !

Object subclass: #OrcaInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Installer'!

!OrcaInstaller class methodsFor: 'configuration' stamp: 'ag 4/6/2011 15:52'!
enableDebugging

	Utilities debugSwazooErrors: true.
	OrcaTranslatedClass enableAllPrintUpdates.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 13:21'!
install

	self
		installPrerequisites;
		installDependencies;
		refetchPackages;
		setupPreferences;
		setupFramework.! !

!OrcaInstaller class methodsFor: 'addons' stamp: 'hk 3/29/2011 13:21'!
installAddons

	"self
		installRefactoringBrowser;
		installSwaLint;
		installShout;
		installOCompletion."! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 10:23'!
installCryptography

	Gofer new
		squeaksource: 'Cryptography';
		package: 'Cryptography';
		load.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'srv 4/5/2011 15:18'!
installDependencies

	self
		installSport;
		installGrease;
		installOMeta;
		installSwazoo;
		installCryptography;
		installOmniBrowser;
		installJson.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 09:59'!
installGofer
	
	self
		loadPackages: { 'Gofer'. 'Gofer-Core'. 'Gofer-Tests' }
		inRepository: (MCHttpRepository
			location: 'http://source.lukas-renggli.ch/gofer'
			user: ''
			password: '').! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'srv 4/5/2011 15:11'!
installGrease

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfGrease';
		load.
		
	(Smalltalk at: #ConfigurationOfGrease) loadLatestVersion.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 10:23'!
installJson

	Gofer new
		squeaksource: 'JSON';
		package: 'JSON';
		load.! !

!OrcaInstaller class methodsFor: 'addons' stamp: 'hk 3/28/2011 11:05'!
installOCompletion

	Gofer new
		squeaksource: 'OCompletion';
		package: 'Ocompletion';
		load.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 10:48'!
installOMeta

	Gofer new
		squeaksource: 'OMeta';
		package: 'OMeta2-Preload';
		load.
	
	Gofer new
		squeaksource: 'OMeta';
		package: 'OMeta2-Postload';
		fetch.! !

!OrcaInstaller class methodsFor: 'addons' stamp: 'srv 4/5/2011 15:10'!
installOmniBrowser

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfOmniBrowser';
		load.
		
	(Smalltalk at: #ConfigurationOfOmniBrowser) project latestVersion load.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 09:59'!
installPrerequisites

	self installGofer.! !

!OrcaInstaller class methodsFor: 'addons' stamp: 'hk 3/29/2011 13:18'!
installRefactoringBrowser

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfRefactoringBrowser';
		load.
		
	ConfigurationOfRefactoringBrowser project latestVersion load.! !

!OrcaInstaller class methodsFor: 'addons' stamp: 'hk 3/29/2011 13:17'!
installShout

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfShout';
		load.
		
	ConfigurationOfShout project latestVersion load.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 10:23'!
installSport

	Gofer new
		squeaksource: 'SPort';
		package: 'Sport';
		load.! !

!OrcaInstaller class methodsFor: 'addons' stamp: 'hk 3/29/2011 13:03'!
installSwaLint

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfSwaLint';
		load.
		
	ConfigurationOfSwaLint load.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 10:22'!
installSwazoo

	Gofer new
		squeaksource: 'Swazoo';
		package: 'Swazoo';
		version: 'Swazoo-2.3beta2.2';
		load.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 09:59'!
loadPackages: aStringCollection inRepository: anMCRepository
	
	| repo index versionList |
	repo := MCFileRepositoryInspector
		repository: anMCRepository
		workingCopy: nil.
	repo packageSelection: 0.
	versionList := repo versionList.
	index := 1.
	[ (aStringCollection anySatisfy: [ :each | (versionList at: index) asString beginsWith: each asString ])
		or: [ index >= repo versionList size ] ] whileFalse: [ index := index + 1 ].
	repo versionSelection: index.
	repo load.! !

!OrcaInstaller class methodsFor: 'update' stamp: 'hk 3/29/2011 10:05'!
refetchPackages
	
	self
		loadPackages: { 'Squeak2JS' }
		inRepository: self repository.! !

!OrcaInstaller class methodsFor: 'configuration' stamp: 'ag 4/6/2011 15:52'!
repository

	^ OrcaMonticelloStatistics workingCopy repositoryGroup repositories detect:
		[ :first | first isKindOf: MCHttpRepository ]! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'ag 4/6/2011 15:52'!
setupDispatcher

	OrcaDispatcher
		install;
		start.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'ag 4/6/2011 15:52'!
setupFileDirectory

	| chooser directory |
	chooser := FileChooser new.
	directory := chooser
		initializeAsSystemWindow;
		open;
		directory.
	OrcaFileRequestHandler rootDirectory: directory pathName.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 12:07'!
setupFramework

	self
		setupMimeDatabase;
		setupFileDirectory;
		setupDispatcher;
		enableDebugging.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 17:01'!
setupMimeDatabase

	MIMEDocument resetMIMEdatabase.! !

!OrcaInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 16:18'!
setupPreferences

	SystemBrowser default: (Smalltalk at: #OBSystemBrowserAdaptor).

	Preferences
		enable: #swapMouseButtons;
		enable: #infiniteUndo;
		enable: #multipleTextUndo.! !

!OrcaInstaller class methodsFor: 'update' stamp: 'hk 3/28/2011 11:16'!
updateGofer

	Gofer upgrade.! !

OrcaInstaller subclass: #OrcaSilentInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Installer'!

!OrcaSilentInstaller class methodsFor: 'setup' stamp: 'robi 4/5/2011 18:41'!
setupFileDirectory
	" by not setting a file directory, orca uses the default ressources directory"
! !

Object subclass: #OrcaNodeNilObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaNodeNilObject methodsFor: 'nil object selector handling' stamp: 'lw 4/6/2011 09:25'!
add: anObject
	" to ensure not looking up the selector in the superclasses even without doing nothing"! !

!OrcaNodeNilObject methodsFor: 'nil object selector handling' stamp: 'lw 4/6/2011 09:25'!
addAllWhitoutNils: anObject
	" to ensure not looking up the selector in the superclasses even without doing nothing"! !

!OrcaNodeNilObject methodsFor: 'nil object selector handling' stamp: 'ag 4/6/2011 18:05'!
doesNotUnderstand: aMessage
	"This class implements part of the OrcaNode-interface (ignoring implications)"
	
	(OrcaNode canUnderstand: aMessage selector) ifFalse: [ super doesNotUnderstand: aMessage ]! !

Object subclass: #OrcaSerializationTestObject
	instanceVariableNames: 'otherObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaSerializationTestObject methodsFor: 'accessing' stamp: 'ag 3/1/2011 16:50'!
otherObject
	^ otherObject! !

!OrcaSerializationTestObject methodsFor: 'accessing' stamp: 'ag 3/1/2011 16:50'!
otherObject: anObject
	otherObject := anObject! !

Object subclass: #OrcaServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Stubs'!

Object subclass: #OrcaShape
	instanceVariableNames: 'canvas graphics color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaShape subclass: #OrcaCircle
	instanceVariableNames: 'position radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaCircle subclass: #OrcaBall
	instanceVariableNames: 'speed direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

!OrcaBall methodsFor: 'logic' stamp: 'ag 4/5/2011 10:28'!
bounceIfNeeded
	
	(self position x > self canvas width or: 
	[self position x < 0])
		ifTrue: [
			self direction: 
				(self direction x * -1) @ self direction y ].
	
	(self position y > self canvas height or: 
	[self position y < 0])
		ifTrue: [
			self direction: 
				self direction x @ (self direction y * -1) ].! !

!OrcaBall methodsFor: 'accessing' stamp: 'sec 1/5/2011 20:48'!
direction
	^ direction! !

!OrcaBall methodsFor: 'accessing' stamp: 'sec 1/5/2011 20:48'!
direction: anObject
	direction := anObject! !

!OrcaBall methodsFor: 'initialize-release' stamp: 'ag 1/24/2011 17:12'!
initialize
	
	super initialize.
	self speed: 2.
	self direction: 1@1.! !

!OrcaBall methodsFor: 'accessing' stamp: 'sec 1/5/2011 20:48'!
speed
	^ speed! !

!OrcaBall methodsFor: 'accessing' stamp: 'lw 2/2/2011 23:31'!
speed: anObject

	speed := anObject
! !

!OrcaBall methodsFor: 'logic' stamp: 'ag 3/1/2011 11:18'!
step
	
	super step.
	self position: self position + (self direction * self speed).
	self bounceIfNeeded.! !

!OrcaCircle methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:27'!
drawOn: aGraphics
	"CTK library: http://canvastoolkit.codeplex.com/"
	
	aGraphics setColor value: self color.
	aGraphics fillCircle
		value: self position x
		value: self position y
		value: self radius.! !

!OrcaCircle methodsFor: 'initialization' stamp: 'LT 2/21/2011 15:30:24.69'!
initialize
	
	super initialize.
	self
		color: '#ff0000';
		radius: 10;
		position: 1@1.! !

!OrcaCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.683'!
position
	^ position! !

!OrcaCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.695'!
position: anObject
	position := anObject! !

!OrcaCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.704'!
radius
	^ radius! !

!OrcaCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.712'!
radius: anObject
	radius := anObject! !

!OrcaCircle methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:28'!
step
	
	self drawOn: self graphics.! !

!OrcaShape methodsFor: 'accessing' stamp: 'sec 12/22/2010 12:03'!
canvas
	^ canvas! !

!OrcaShape methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:33:58.38'!
canvas: anObject
	canvas := anObject! !

!OrcaShape methodsFor: 'accessing' stamp: 'ag 1/12/2011 10:51'!
color
	^ color! !

!OrcaShape methodsFor: 'accessing' stamp: 'ag 1/12/2011 10:51'!
color: anObject
	color := anObject! !

!OrcaShape methodsFor: 'accessing' stamp: 'ag 4/5/2011 10:27'!
graphics
	^ graphics! !

!OrcaShape methodsFor: 'accessing' stamp: 'ag 4/5/2011 10:27'!
graphics: anObject
	graphics := anObject! !

OrcaShape subclass: #OrcaWorld
	instanceVariableNames: 'bounds elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

OrcaWorld subclass: #OrcaBallGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

!OrcaBallGame commentStamp: 'sec 1/4/2011 10:22' prior: 0!
usage:
S2JCodeFactory clearCache.
S2JBouncingBallsApp startWebApp.!

!OrcaBallGame class methodsFor: 'start' stamp: 'ag 1/24/2011 20:42'!
start
	
	^ self new run! !

!OrcaBallGame methodsFor: 'graphics' stamp: 'ag 4/6/2011 15:52'!
addBall
	
	^ self elements
		add: 
			(OrcaBall new
				canvas: self canvas;
				graphics: self graphics;
				yourself)! !

!OrcaBallGame methodsFor: 'initialization' stamp: 'ag 3/29/2011 14:07'!
initialize
	
	super initialize.
	self addBall.! !

!OrcaWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.324'!
bounds
	^ bounds! !

!OrcaWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.336'!
bounds: anObject
	bounds := anObject! !

!OrcaWorld methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:29'!
clear
	
	self graphics setColor value: self color.
	self graphics fillRect
			value: self bounds origin x
			value: self bounds origin y
			value: self bounds corner x
			value: self bounds corner y.! !

!OrcaWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.346'!
elements
	^ elements! !

!OrcaWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.352'!
elements: anObject
	elements := anObject! !

!OrcaWorld methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:23'!
initialize
	
	super initialize.
	self color: '#0000ff'.
	
	self
		canvas: (Js Document getElementById value: #ballCanvas);
		elements: OrderedCollection new;
		bounds: (Rectangle origin: (0@0) corner: (self canvas width @ self canvas height));
		graphics: (Js Global ctk Graphics jsNew: self canvas);
		clear.! !

!OrcaWorld methodsFor: 'graphics' stamp: 'ag 3/29/2011 13:40'!
run
	
	Js Global setInterval
		value: [ self step ]
		value: 3.! !

!OrcaWorld methodsFor: 'graphics' stamp: 'ag 1/12/2011 10:55'!
step
	
	self clear.
	self elements do: [ :each | each step].! !

Object subclass: #OrcaSlotObject
	instanceVariableNames: 'slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Stubs'!

!OrcaSlotObject class methodsFor: 'instance creation' stamp: 'ag 3/31/2011 13:29'!
newFrom: anArray
	
	^ self new
			slots: anArray;
			yourself! !

!OrcaSlotObject methodsFor: 'accessing' stamp: 'ag 3/31/2011 13:24'!
definitionLine
	
	^ '{}'! !

!OrcaSlotObject methodsFor: 'accessing' stamp: 'ag 4/11/2011 16:23'!
fillInstVars: codeLines guardedBy: alreadySerialized
	"This classes instance variables are ignored, the slots are the only thing, that counts."
	
	self slots do: [ :slot | | slotvalue | 
		slotvalue := slot value.
		slotvalue serializeToJavaScript: codeLines guardedBy: alreadySerialized.
		codeLines addLast: 
			(alreadySerialized at: self), '.', slot key, 
			'=', (alreadySerialized at: slotvalue) ].
	codeLines addLast: OrcaSqueakAstToJsAst unboxSlotObjectFunction, '(', (alreadySerialized at: self), ')'.! !

!OrcaSlotObject methodsFor: 'initializing' stamp: 'sw 3/31/2011 11:06'!
initialize

	super initialize.
	self slots: Array new.! !

!OrcaSlotObject methodsFor: 'accessing' stamp: 'sw 3/31/2011 11:06'!
slots
	^ slots! !

!OrcaSlotObject methodsFor: 'accessing' stamp: 'sw 3/31/2011 11:06'!
slots: anObject
	slots := anObject! !

Object subclass: #OrcaTranslatedObject
	instanceVariableNames: 'squeakObject javaScriptCode codeFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

OrcaTranslatedObject subclass: #OrcaCompilationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OrcaCompilationError class methodsFor: 'instance creation' stamp: 'ag 3/29/2011 11:23'!
from: anObject inFactory: aFactory
	
	Transcript cr; show: 'Compilation error. Failed on: ', anObject asString.
	^ super from: anObject inFactory: aFactory! !

!OrcaCompilationError methodsFor: 'converting' stamp: 'sec 2/21/2011 18:57'!
doUpdate

	self error: 'Cannot translate: ', self squeakObject asString.! !

!OrcaCompilationError methodsFor: 'converting' stamp: 'sec 2/21/2011 18:56'!
hasChanged

	^true! !

OrcaTranslatedObject subclass: #OrcaTranslatedClass
	instanceVariableNames: 'instMethods classMethods instVars superclass classInstVars classVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OrcaTranslatedClass methodsFor: 'converting' stamp: 'ag 1/5/2011 22:01'!
allMethodsOf: aSourceClass
	
	^ aSourceClass methodDict values collect: [ :method | 
		self codeFactory cacheObjectForMethod: method ]! !

!OrcaTranslatedClass methodsFor: 'accessing-derived' stamp: 'lw 3/28/2011 17:59'!
calledFunctions 

	^ self instMethods, self classMethods 
		inject: Dictionary new 
		into: [ :aDictionary :aMethod | aDictionary union: aMethod calledFunctions ].! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classInstVars
	
	^ classInstVars! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classInstVars: anObject
	
	classInstVars := anObject! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classMethods
	
	^ classMethods! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classMethods: anObject
	
	classMethods := anObject! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classVars
	
	^ classVars! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:59'!
classVars: anObject
	
	classVars := anObject! !

!OrcaTranslatedClass methodsFor: 'converting' stamp: 'ag 4/6/2011 18:09'!
doUpdate
	"First memorize the fields, then do the actual conversion. Errors during the conversion will happen only once,
	the old version of the javascriptObject will be kept if that happens.
	TODO Bad: this is kind of the same code like in OrcaAbstractPrinter class >> convertClass:to:retrievingFrom: and #hasChanged in this class"
	
	self
		superclass: self squeakObject superclass name;
		instMethods: (self allMethodsOf: self squeakObject);
		classMethods: (self allMethodsOf: self squeakObject class);
		instVars: self squeakObject instVarNames;
		classInstVars: self squeakObject class instVarNames;
		classVars: self squeakObject classVarNames;
		javaScriptCode: (
			self converterClass
				convertClass: self squeakObject
				retrievingFrom: [ :method | "Here the CodeFactory is plugged to the Printer"
					self codeFactory codeForCompiledMethod: method ]).! !

!OrcaTranslatedClass methodsFor: 'converting' stamp: 'ag 1/10/2011 19:36'!
hasChanged
	
	^ 
	((self haveMethodsChanged: self instMethods from: self squeakObject)
	or: [ self haveMethodsChanged: self classMethods from: self squeakObject class ]
	or: [ self superclass ~= self squeakObject superclass name ]
	or: [ self instVars ~= self squeakObject instVarNames ]
	or: [ self classInstVars ~= self squeakObject class instVarNames ])
	or: [ self classVars ~= self squeakObject classVarNames ]! !

!OrcaTranslatedClass methodsFor: 'converting' stamp: 'ag 4/6/2011 18:10'!
haveMethodsChanged: originalMethods from: originalClass
	"Check #hasChanged on each OrcaTranslatedMethod and check, whether there are more methods in the class now."
	
	^ originalMethods isNil or: 
		[ (originalMethods anySatisfy: [ :method | 
			(self codeFactory isObjectCached: method squeakObject) not or: 
			[ method hasChanged ] ]) or:
		[ originalClass methodDict size ~= originalMethods size ]]! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:57'!
instMethods
	
	^ instMethods! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:57'!
instMethods: anObject
	
	instMethods := anObject! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
instVars
	
	^ instVars! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
instVars: anObject
	
	instVars := anObject! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
superclass
	
	^ superclass! !

!OrcaTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
superclass: aString
	
	superclass := aString! !

!OrcaTranslatedClass methodsFor: 'converting' stamp: 'ag 1/6/2011 16:24'!
updateMessage
	
	^ 'class ', self squeakObject name! !

OrcaTranslatedObject subclass: #OrcaTranslatedClasses
	instanceVariableNames: 'translatedClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OrcaTranslatedClasses methodsFor: 'converting' stamp: 'lw 3/28/2011 14:46'!
addDoesNotUnderstandClass

	self javaScriptCode: (self converterClass doesNotUndestandClasswithMethods: self calledFunctions), ';
', self javaScriptCode.! !

!OrcaTranslatedClasses methodsFor: 'accessing-derived' stamp: 'lw 3/28/2011 18:03'!
calledFunctions 

	^ self translatedClasses 
		inject: Dictionary new 
		into: [ :aDictionary :aMethod | aDictionary union: aMethod calledFunctions ].! !

!OrcaTranslatedClasses methodsFor: 'converting' stamp: 'lw 3/28/2011 13:25'!
doUpdate
	"Call convertClasses: of the converterClass and memorize the result. Plug the codeFactory to the converterClass (via the block).
	Actually, the compiledClasses should always stay the same objects, but just in case we refill the Set.
	Might happen, that one single object is removed from the cache."
	
	self translatedClasses removeAll.
	self javaScriptCode: (
		self converterClass
			convertClasses: self squeakObject
			retrievingFrom: [ :class | "Here the CodeFactory is plugged to the Printer"
				self translatedClasses add: (self codeFactory cacheObjectForClass: class).
				self codeFactory codeForClass: class ]).
	(self squeakObject includes: ProtoObject) 
		ifTrue: [ self addDoesNotUnderstandClass ]! !

!OrcaTranslatedClasses methodsFor: 'converting' stamp: 'lw 3/28/2011 12:31'!
hasChanged
	
	^ self translatedClasses isNil or:
		[ self translatedClasses anySatisfy: [ :each |
			(self codeFactory isObjectCached: each squeakObject) not
			or: [ each hasChanged ] ]]! !

!OrcaTranslatedClasses methodsFor: 'initialization' stamp: 'lw 3/28/2011 12:32'!
initialize
	
	super initialize.
	self translatedClasses: Set new.! !

!OrcaTranslatedClasses methodsFor: 'accessing' stamp: 'lw 3/28/2011 12:31'!
translatedClasses
	^ translatedClasses! !

!OrcaTranslatedClasses methodsFor: 'accessing' stamp: 'lw 3/28/2011 12:32'!
translatedClasses: aSet
	translatedClasses := aSet! !

!OrcaTranslatedClasses methodsFor: 'converting' stamp: 'ag 1/6/2011 16:25'!
updateMessage
	
	^ 'classes ', self squeakObject asString.! !

OrcaTranslatedObject subclass: #OrcaTranslatedDoIt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OrcaTranslatedDoIt methodsFor: 'converting' stamp: 'LT 3/16/2011 12:31:57.566'!
doUpdate
	
	self javaScriptCode: 
		(self converterClass convertDoIt: self squeakObject).! !

!OrcaTranslatedDoIt methodsFor: 'converting' stamp: 'ag 12/14/2010 00:33'!
hasChanged
	"DoIt-code does not change"
	
	^ false! !

OrcaTranslatedObject subclass: #OrcaTranslatedMethod
	instanceVariableNames: 'calledFunctions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OrcaTranslatedMethod methodsFor: 'accessing' stamp: 'LT 3/16/2011 12:34:23.999'!
calledFunctions
	^ calledFunctions! !

!OrcaTranslatedMethod methodsFor: 'accessing' stamp: 'LT 3/16/2011 12:34:24.011'!
calledFunctions: anObject
	calledFunctions := anObject! !

!OrcaTranslatedMethod methodsFor: 'converting' stamp: 'ag 1/19/2011 15:58'!
currentSqueakObject
	
	^ self converterClass
		method: self squeakObject selector
		of: self squeakObject methodClass
		ifAbsent: [ nil ]! !

!OrcaTranslatedMethod methodsFor: 'converting' stamp: 'lw 3/28/2011 16:45'!
doUpdate
	"Additionally to converting the current code, store the current instance of CompiledMethod"
	
	| calledFunctionsToResult |
	self squeakObject: self currentSqueakObject.
	calledFunctionsToResult := self converterClass convertTranslatedMethod: self.
	self javaScriptCode: calledFunctionsToResult value.
	self calledFunctions: calledFunctionsToResult key.! !

!OrcaTranslatedMethod methodsFor: 'converting' stamp: 'ag 12/17/2010 00:15'!
hasChanged
	"This is the main point of cache-validation. The instance-equality of the CompiledMethod is used.
	If the method-code changed, the method is recompiled. If the method is recompiled, there will be a new instance of CompiledMethod."
	
	^ (self squeakObject == self currentSqueakObject) not! !

!OrcaTranslatedMethod methodsFor: 'converting' stamp: 'ag 1/6/2011 16:27'!
updateMessage
	
	^ 'method ', self squeakObject methodClass name, ' >> ', self squeakObject selector! !

!OrcaTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 4/6/2011 15:52'!
disableAllPrintUpdates
	
	OrcaTranslatedObject withAllSubclassesDo: [ :eachClass |
		eachClass enablePrintUpdates ].! !

!OrcaTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 1/6/2011 16:31'!
disablePrintUpdates
	
	Smalltalk
		at: self updatesKey
		put: false.! !

!OrcaTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 4/6/2011 15:52'!
enableAllPrintUpdates
	
	OrcaTranslatedObject withAllSubclassesDo: [ :eachClass |
		eachClass enablePrintUpdates ].! !

!OrcaTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 1/6/2011 16:32'!
enablePrintUpdates
	
	Smalltalk
		at: self updatesKey
		put: true.! !

!OrcaTranslatedObject class methodsFor: 'instance creation' stamp: 'ag 3/29/2011 11:23'!
from: aSqueakObject inFactory: aCodeFactory
	
	^ self new
		squeakObject: aSqueakObject;
		codeFactory: aCodeFactory;
		yourself! !

!OrcaTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 1/6/2011 16:32'!
printUpdates
	
	^ (Smalltalk
		at: self updatesKey
		ifAbsent: [ nil ])
			== true! !

!OrcaTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 4/6/2011 17:59'!
updatesKey
	"The key used in the global Smalltalk dictionary to store the per-class setting to print updates."
	
	^ ('OrcaPrintCacheUpdates-', self name) asSymbol! !

!OrcaTranslatedObject methodsFor: 'accessing' stamp: 'ag 1/5/2011 21:44'!
codeFactory
	
	^ codeFactory! !

!OrcaTranslatedObject methodsFor: 'accessing' stamp: 'ag 1/5/2011 21:44'!
codeFactory: aCodeFactory
	
	codeFactory := aCodeFactory! !

!OrcaTranslatedObject methodsFor: 'converting' stamp: 'lw 3/28/2011 13:49'!
converterClass
	"Convenience for subclasses"
	
	^ self codeFactory converterClass! !

!OrcaTranslatedObject methodsFor: 'converting' stamp: 'ag 1/6/2011 11:21'!
doUpdate
	"Update converted contents from the current state of the squeak-object."
	
	self subclassResponsibility! !

!OrcaTranslatedObject methodsFor: 'converting' stamp: 'ag 12/13/2010 22:41'!
hasChanged
	"Return true, if the source squeak-object has changed, since it has last been updated."
	
	self subclassResponsibility! !

!OrcaTranslatedObject methodsFor: 'accessing' stamp: 'LT 3/16/2011 12:32:24.779'!
javaScriptCode
	
	^ javaScriptCode! !

!OrcaTranslatedObject methodsFor: 'accessing' stamp: 'LT 3/16/2011 12:31:57.533'!
javaScriptCode: anObject
	
	javaScriptCode := anObject! !

!OrcaTranslatedObject methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:34'!
squeakObject
	
	^ squeakObject! !

!OrcaTranslatedObject methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:34'!
squeakObject: anObject
	
	squeakObject := anObject! !

!OrcaTranslatedObject methodsFor: 'converting' stamp: 'ag 1/6/2011 16:24'!
update
	"To track the updates easily, they are printed to Transript, if activated"
	
	| message |
	message := self updateMessage.
	(message notNil and: [self class printUpdates]) ifTrue: [
		Transcript cr; show: 'Updating ', message].
	^ self doUpdate! !

!OrcaTranslatedObject methodsFor: 'converting' stamp: 'ag 1/6/2011 16:23'!
updateMessage
	"Return something else than nil to print it to Transcript on updates."
	
	^ nil! !

Object subclass: #OrcaWidget
	instanceVariableNames: 'node children extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaWidget subclass: #OrcaAccordion
	instanceVariableNames: 'autoHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaAccordion class methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:58'!
defaultCssId

	 ^ 'accordion'! !

!OrcaAccordion class methodsFor: 'configuration' stamp: 'hk 3/8/2011 10:08'!
hasAutoHeight

	^ false! !

!OrcaAccordion methodsFor: 'accessing' stamp: 'ag 4/6/2011 15:52'!
add: aWidget named: aString
	
	| link heading container |
	link := OrcaAnchor named: aString.
	heading := OrcaHeading new add: link; yourself.
	container := (OrcaContainer vertical) add: aWidget.
	self
		add: heading;
		add: container.! !

!OrcaAccordion methodsFor: 'accessing' stamp: 'hk 3/8/2011 10:07'!
autoHeight
	^ autoHeight! !

!OrcaAccordion methodsFor: 'accessing' stamp: 'hk 3/8/2011 10:07'!
autoHeight: anObject
	autoHeight := anObject! !

!OrcaAccordion methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
enableAccordion
	
	(Js @ ('#', self class defaultCssId)) accordion value: self parameters.! !

!OrcaAccordion methodsFor: 'initialization' stamp: 'hk 3/8/2011 10:08'!
initialize 

	super initialize.
	self autoHeight: self class hasAutoHeight.
	self cssId: self class defaultCssId.! !

!OrcaAccordion methodsFor: 'initialization' stamp: 'hk 3/8/2011 09:49'!
onLoad

	self enableAccordion.
	super onLoad.! !

!OrcaAccordion methodsFor: 'initialization' stamp: 'hk 3/8/2011 10:10'!
parameters

	^ { #autoHeight -> self autoHeight . #navigation -> true } asObject! !

OrcaWidget subclass: #OrcaChart
	instanceVariableNames: 'chart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaChart class methodsFor: 'configuration' stamp: 'hk 3/9/2011 10:38'!
defaultCssId

	^ self subclassResponsibility! !

!OrcaChart methodsFor: 'accessing' stamp: 'hk 3/7/2011 22:48'!
chart
	^ chart! !

!OrcaChart methodsFor: 'accessing' stamp: 'hk 3/7/2011 22:48'!
chart: anObject
	chart := anObject! !

!OrcaChart methodsFor: 'initialization' stamp: 'hk 3/9/2011 11:01'!
initialize 

	super initialize.
	self
		cssId: self class defaultCssId;
		width: '100%';
		height: '400px'.! !

!OrcaChart methodsFor: 'initialization' stamp: 'ag 4/5/2011 15:59'!
initializeWithData: json

	self chart loadJSON value: json.! !

!OrcaChart methodsFor: 'rendering' stamp: 'LT 4/4/2011 15:04:18.9'!
onShowTip: aTip for: anElement
	| label value |
		
	label := anElement name.
	value := anElement value.
	aTip innerHTML: label, ': ', value.
	aTip style backgroundColor: 'white'.! !

!OrcaChart methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:41'!
parameters

	^ self subclassResponsibility! !

OrcaChart subclass: #OrcaStackedChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

OrcaStackedChart subclass: #OrcaAreaChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaAreaChart class methodsFor: 'configuration' stamp: 'hk 3/7/2011 22:25'!
defaultCssId

	^ 'area'! !

!OrcaAreaChart methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:44'!
initializeWithData: json

	self chart: (Js jit AreaChart jsNew: self parameters).
	super initializeWithData: json.! !

!OrcaAreaChart methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
onLoad

	| escapedJson json |
	escapedJson := [ OrcaMonticelloStatistics jsonDataAt: #commitsByWeek ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

OrcaStackedChart subclass: #OrcaBarChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaBarChart class methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:45'!
defaultCssId

	^ 'bar'! !

!OrcaBarChart methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:44'!
initializeWithData: json
	
	self chart: (Js jit BarChart jsNew: self parameters).
	super initializeWithData: json.! !

!OrcaBarChart methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
onLoad

	| escapedJson json |
	escapedJson := [ OrcaMonticelloStatistics jsonDataAt: #commitsByWeekDay ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

!OrcaBarChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 16:56:40.684'!
parameters

	^ super parameters
		orientation: 'vertical';
		barsOffset: 20;
		yourself! !

OrcaBarChart subclass: #OrcaCommitsByHour
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaCommitsByHour class methodsFor: 'configuration' stamp: 'SW 3/16/2011 16:18'!
defaultCssId

	^ 'commitsByHour'! !

!OrcaCommitsByHour methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
onLoad

	| escapedJson json |
	escapedJson := [ OrcaMonticelloStatistics jsonDataAt: #commitsByHour ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

!OrcaStackedChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:21:19.284'!
label

	^  {#type -> 'HTML'.
		#size -> 13.
		#family -> 'Arial'.
		#color -> 'black' } asObject! !

!OrcaStackedChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:05:32.517'!
parameters

	^ {#injectInto -> self class defaultCssId.
		#animate -> true.
		#Margin -> { #top -> 5 . #left -> 5 . #right -> 5 . #bottom -> 5 } asObject.
		#labelOffset -> 10.
		#showAggregates -> true.
		#showLabels -> true.
		#type -> 'stacked:gradient'.
		#Label -> self label.
		#Tips -> self tips.
		#filterOnClick -> true.
		#restoreOnRightClick -> true} asObject
		
! !

!OrcaStackedChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:06:28.541'!
tips

	^ {#enable -> true.
	    #onShow -> [ :tip :element | self onShowTip: tip for: element ] } asObject! !

OrcaChart subclass: #OrcaTreeGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:49'!
classMethodsOf: aClass
	
	^ aClass class methodDict! !

!OrcaTreeGraph class methodsFor: 'configuration' stamp: 'SW 2/23/2011 11:47'!
defaultCssId 

	^ 'treegraph'! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:49'!
instanceMethodsOf: aClass

	^ aClass methodDict! !

!OrcaTreeGraph class methodsFor: 'json' stamp: 'ag 4/6/2011 15:52'!
jsonData

	^ '(', (Json render: (self treeFor: OrcaBasicApp)), ')'! !

!OrcaTreeGraph class methodsFor: 'configuration' stamp: 'SW 2/23/2011 12:32'!
jsonObjectFrom: aString

	^ JsonObject new
		at: #id put: aString;
		at: #name put: aString;
		yourself.
	! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:49'!
linesOfCodeForClass: aClass

	| sum |
	sum := 0.
	(self methodsOf: aClass) do: [ :each |
		sum := sum + (self linesOfCodeForMethod: each value) ].
	^ sum! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
linesOfCodeForClassNamed: aString

	| class |
	Transcript show: aString.
	class := Smalltalk classNamed: aString.
	^ class
		ifNil: [ 0 ]
		ifNotNil: [ self linesOfCodeForClass: class]! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
linesOfCodeForMethod: aMethod

	^ aMethod decompileString lineCount! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
methodsOf: aClass

	| methods |
	methods := self instanceMethodsOf: aClass.
	methods addAll: (self classMethodsOf: aClass).
	^ methods! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
metricsForClassNamed: aString

	| class |
	Transcript show: aString.
	class := Smalltalk classNamed: aString.
	^ OrderedCollection
		with: (self linesOfCodeForClass: class)
		with: (self numberOfMethodsOf: class)! !

!OrcaTreeGraph class methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:13:56.332'!
node	

	^ {#overridable -> true.
		#type -> 'rectangle'.
		#color -> '#CDEB8B'.
		#width -> 200.
		#height -> 30.
		#lineWidth -> 5.
		#align -> 'center'.
		#CanvasStyles -> { #strokeStyle -> '#ffc' . #lineWidth -> 2 } asObject.
		} asObject! !

!OrcaTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
numberOfMethodsOf: aClass

	^ (self methodsOf: aClass) size
! !

!OrcaTreeGraph class methodsFor: 'configuration' stamp: 'ag 4/5/2011 17:44'!
transition 
	
	^ Js jit Trans Quart easeInOut! !

!OrcaTreeGraph class methodsFor: 'json' stamp: 'ag 4/6/2011 15:52'!
treeFor: aClass

	| jsonObject  collection |
	jsonObject := OrcaTreeGraph jsonObjectFrom: aClass name.
	aClass subclasses ifNotEmpty:
		[ collection := OrderedCollection new.
		aClass subclassesDo: [ :each |
			collection add: (self treeFor: each) ].
		jsonObject at: #children put: (Array newFrom: collection) ].
	^ jsonObject.! !

!OrcaTreeGraph methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:45'!
initializeWithData: json

	self chart: (Js jit ST jsNew: self parameters).
	super initializeWithData: json.
	self chart compute value.
	self chart onClick value: self chart root.! !

!OrcaTreeGraph methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
metricsDialogNamed: aString with: aCollection

	| loc nom linesPerMethod |
	loc := aCollection first.
	nom := aCollection second.
	linesPerMethod := (loc / nom) roundTo: 0.1.
	
	^ OrcaDialog new
		title: aString;
		text: 'LoC: ', loc asString, ', NoM: ', nom asString, ', L/M: ', linesPerMethod asString;
		yourself! !

!OrcaTreeGraph methodsFor: 'configuration' stamp: 'LT 4/4/2011 15:12:18.211'!
onBeforePlotNode: aNode

	| textLength width |
	textLength := Js Global number value: (aNode id length).
	width := textLength * 12.
	"perform since we can not use a $ in a selector directly yet"
	aNode data perform: #'$width:' with: width.
	aNode data perform: #'$height:' with: 25.! !

!OrcaTreeGraph methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:19:39.391'!
onClick: aNode

	self chart onClick value: aNode id.! !

!OrcaTreeGraph methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:07:49.179'!
onCreateLabel: aLabel for: aNode
	
	aLabel id: (aNode id).
	aLabel innerHTML: (aNode name).
	aLabel onclick: [ self onClick: aNode ].
	
	aLabel style
		cursor: 'pointer';
		font: '10px';
		padding: '5px';
		width: '190px';
		height: '20px';
		border: '1px solid #888'! !

!OrcaTreeGraph methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
onLoad

	| escapedJson json |
	escapedJson := [ OrcaTreeGraph jsonData ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

!OrcaTreeGraph methodsFor: 'configuration' stamp: 'ag 4/5/2011 16:48'!
parameters

	^ {#orientation -> 'left'.
	      #injectInto -> self class defaultCssId.
		#duration -> 300.
		#transition -> self class transition.
		#levelDistance -> 50.
		#offsetX -> 0.
		#Navigation -> { #enable ->  true. #panning -> true } asObject.
		#Node -> self class node.
		#Edge -> { #type ->  'arrow' . #overridable -> true . #color -> 'lightblue' } asObject.	
		#onCreateLabel -> [ :label :mynode | self onCreateLabel: label for: mynode ] 
		} asObject! !

!OrcaTreeGraph methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
showDialogFor: aNode

	| className metrics |
	className := (Js Global string value: (aNode name)).
	metrics := [ :name | OrcaTreeGraph metricsForClassNamed: name ]
		onServer value: className.
	(self metricsDialogNamed: className with: metrics)
		addToWorld;
		initializeDialog.! !

OrcaWidget subclass: #OrcaClassBrowser
	instanceVariableNames: 'packageList protocolList classList methodList saveButton codeBox sideSelector spinner searchBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaClassBrowser class methodsFor: 'configuration' stamp: 'hk 3/9/2011 12:38'!
defaultCssId

	^ 'browser'! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addElements

	| lists classContainer all window |
	classContainer := (OrcaContainer vertical
		add: self classList;
		add: self sideSelector).

	lists := (OrcaContainer horizontal
		add: self packageList;
		add: classContainer;
		add: self protocolList;
		add: self methodList;
		yourself).
	all := OrcaContainer vertical
		add: self searchBox;
		add: lists;
		add: self codeBox;
		add: self saveButton;
		yourself.
	
	window := (OrcaWindow newTitled: 'Class Browser') add: all.
	
	self
		add: window;
		addToWorld.
		
	self spinner addToWorld.! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'ag 1/17/2011 18:18'!
classList
	^ classList! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'robi 1/17/2011 19:17'!
classList: anObject
	classList := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 15:33:01.404'!
codeBox

	^ codeBox! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'ag 4/6/2011 17:57'!
codeBox: anOrcaCodeBox

	codeBox := anOrcaCodeBox! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createButtons

	self saveButton: (OrcaSaveButton newOn: self).! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createPanes
	
	self codeBox: (OrcaCodeBox newOn: self).
	self methodList: (OrcaMethodPane newOn: self).
	self protocolList: (OrcaProtocolPane newOn: self).
	self classList: ((OrcaClassPane newOn: self) extent: 200 @ 260).
	self packageList: (OrcaPackagePane newOn: self).
	self sideSelector: (OrcaSideSelector newOn: self).! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createSearchBox

	self searchBox: (OrcaSmartSearch newOn: self).! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createSpinner
	
	self spinner: OrcaLoader new.				! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:26'!
initialize

	super initialize.
	self
		cssId: self class defaultCssId;
		createSpinner;
		createSearchBox;
		createButtons;
		createPanes; 
		addElements.! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'ag 1/17/2011 18:18'!
methodList
	^ methodList! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'ag 1/17/2011 18:18'!
methodList: anObject
	methodList := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/24/2011 14:20:34.638'!
packageList
	^ packageList! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/24/2011 14:20:34.649'!
packageList: anObject
	packageList := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 14:12'!
protocolList
	^ protocolList! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 14:12'!
protocolList: anObject
	protocolList := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:43:15.463'!
saveButton
	^ saveButton! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:43:15.474'!
saveButton: anObject
	saveButton := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 2/23/2011 15:42:05.456'!
searchBox
	^ searchBox! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'LT 2/23/2011 15:42:05.464'!
searchBox: anObject
	searchBox := anObject! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 14:29:01.489'!
selectCategory: aString

	self protocolList select: aString.
	self methodList updateForClass: (self classList selectedClassName) in: aString.! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 11:09:13.282'!
selectClass: aString

	self classList 
		select: aString;
		updateForClass.! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 10:47:19.703'!
selectPackage: aString

	self packageList select: aString.
	self classList updateForPackage: aString.! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 15:18:09.263'!
selectSelector: aString

	self methodList select: aString.
	self codeBox updateFor: aString of: self classList selectedClassName.! !

!OrcaClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 15:03:07.737'!
selectSide: isClassSide

	isClassSide
		ifTrue: [self sideSelector switchToClassside]
		ifFalse: [self sideSelector switchToInstanceside]! !

!OrcaClassBrowser methodsFor: 'initialization' stamp: 'LT 1/26/2011 16:54:08.361'!
showSide 

	self protocolList update.
	self codeBox displayClassDefinition.! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 18:05'!
sideSelector
	^ sideSelector! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 18:05'!
sideSelector: anObject
	sideSelector := anObject! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'SW 1/31/2011 13:03'!
spinner
	^ spinner! !

!OrcaClassBrowser methodsFor: 'accessing' stamp: 'SW 1/31/2011 13:03'!
spinner: anObject
	spinner := anObject! !

OrcaWidget subclass: #OrcaConfirm
	instanceVariableNames: 'message block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaConfirm class methodsFor: 'configuration' stamp: 'hk 3/21/2011 14:09'!
defaultMessage

	^ 'Are you sure?'! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 13:27'!
block
	^ block! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 13:27'!
block: anObject
	block := anObject! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 4/5/2011 14:59'!
confirm

	| isConfirmed |
	isConfirmed := Js Global confirm value: self message.
	isConfirmed ifTrue: [ self block value ].! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 14:10'!
message
	message ifNil: [ message := self class defaultMessage ].
	^ message! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 13:27'!
message: anObject
	message := anObject! !

OrcaWidget subclass: #OrcaContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaContainer class methodsFor: 'instance creation' stamp: 'ag 4/6/2011 15:52'!
horizontal

	^ OrcaHorizontalContainer new! !

!OrcaContainer class methodsFor: 'configuration' stamp: 'hk 1/24/2011 10:43'!
htmlElementType

	^ 'div'! !

!OrcaContainer class methodsFor: 'configuration' stamp: 'ag 4/6/2011 15:52'!
start

	OrcaTabHost new
		add: (OrcaTextArea new) named: 'TextArea A';
		add: (OrcaTextArea new) named: 'TextArea B';
		addToWorld.! !

!OrcaContainer class methodsFor: 'instance creation' stamp: 'ag 4/6/2011 15:52'!
vertical

	^ OrcaVerticalContainer new! !

!OrcaContainer methodsFor: 'rendering' stamp: 'hk 3/8/2011 11:20'!
add: element

	super add: element.
	element beRelative! !

OrcaContainer subclass: #OrcaHorizontalContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaHorizontalContainer methodsFor: 'initialization' stamp: 'hk 1/31/2011 15:09'!
initialize
	
	super initialize.
	self cssClass: 'horizontal'.
! !

OrcaContainer subclass: #OrcaVerticalContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaVerticalContainer methodsFor: 'initialization' stamp: 'sw 4/5/2011 13:34'!
initialize
	
	super initialize.
	self cssClass: 'vertical'. ! !

OrcaWidget subclass: #OrcaControls
	instanceVariableNames: 'restartButton clearCacheButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaControls methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addElements

	| panel |
	panel := OrcaVerticalContainer new
		add: self restartButton;
		add: self clearCacheButton.
	self add: panel.! !

!OrcaControls methodsFor: 'initialization' stamp: 'ag 4/6/2011 18:07'!
addTexts
	
	self add: (OrcaHeading new
		text: 'Here you can control the Orca Engine!! Please be aware of delays when forcing restart or clearing the cache!!';
			yourself).! !

!OrcaControls methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
clearCacheButton
	^ clearCacheButton! !

!OrcaControls methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
clearCacheButton: anObject
	clearCacheButton := anObject! !

!OrcaControls methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createButtons
	
	self restartButton: (
		OrcaButton new
			text: 'Force restart of WebServer';
			onClickDo: [ :event | OrcaDispatcher forcedRestart ] onServer).
	
	self	 clearCacheButton: (
		OrcaButton new
			text: 'Clear Cache of Translator';
			onClickDo: [ :event |
				OrcaConfirm new 
					block: [ OrcaPrettyCodeFactory clearCache ] onServer;
					confirm ];
			yourself).! !

!OrcaControls methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:36'!
initialize 
	
	super initialize.
	self
		createButtons;
		addTexts;
		addElements.! !

!OrcaControls methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
restartButton
	^ restartButton! !

!OrcaControls methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
restartButton: anObject
	restartButton := anObject! !

OrcaWidget subclass: #OrcaDialog
	instanceVariableNames: 'paragraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaDialog class methodsFor: 'configuration' stamp: 'hk 2/28/2011 15:01'!
defaultCssId

	^ 'dialog'! !

!OrcaDialog methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initialize
	
	super initialize.
	self cssId: self class defaultCssId.
	self paragraph: OrcaParagraph new.
	self add: self paragraph.
! !

!OrcaDialog methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
initializeDialog

	(Js @ ('#', self class defaultCssId)) dialog
		value: self parameters.! !

!OrcaDialog methodsFor: 'initialization' stamp: 'hk 3/6/2011 22:14'!
onLoad

	self initializeDialog.
	super onLoad.! !

!OrcaDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 14:59'!
paragraph
	^ paragraph! !

!OrcaDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 14:59'!
paragraph: anObject
	paragraph := anObject! !

!OrcaDialog methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:17:11.31'!
parameters

	^ { #autoOpen -> true.
		#show -> 'clip'.
		#hide -> 'clip' } asObject
! !

!OrcaDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 15:00'!
text

	^ self paragraph text! !

!OrcaDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 15:00'!
text: aString

	self paragraph text: aString.! !

!OrcaDialog methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:25:30.699'!
title
	
	^ self node title! !

!OrcaDialog methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:25:22.373'!
title: aString

	self node title: aString.! !

OrcaWidget subclass: #OrcaImage
	instanceVariableNames: 'source description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaImage class methodsFor: 'configuration' stamp: 'SW 1/31/2011 12:40'!
htmlElementType

	^ 'img'! !

!OrcaImage methodsFor: 'accessing' stamp: 'SW 1/31/2011 12:41'!
description
	^ description! !

!OrcaImage methodsFor: 'accessing' stamp: 'sw 3/29/2011 13:49'!
description: anObject

	description := anObject.
	self node alt: anObject.
	! !

!OrcaImage methodsFor: 'initialization' stamp: 'hk 2/1/2011 12:29'!
initialize 
	
	super initialize.
	self
		source: '';
		description: ''.! !

!OrcaImage methodsFor: 'accessing' stamp: 'SW 1/31/2011 12:41'!
source
	^ source! !

!OrcaImage methodsFor: 'accessing' stamp: 'sw 3/29/2011 13:49'!
source: anObject

	source := anObject.
	self node src: anObject.! !

OrcaWidget subclass: #OrcaInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaInput subclass: #OrcaButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaButton methodsFor: 'initialization' stamp: 'sw 3/29/2011 14:25'!
initialize 
	
	super initialize.
	self node type: 'button'! !

OrcaButton subclass: #OrcajQueryButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcajQueryButton subclass: #OrcaSaveButton
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaSaveButton class methodsFor: 'instance creation' stamp: 'LT 1/26/2011 10:40:51.535'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaSaveButton methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:41:10.614'!
browser
	^ browser! !

!OrcaSaveButton methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:41:10.624'!
browser: anObject
	browser := anObject! !

!OrcaSaveButton methodsFor: 'save source' stamp: 'sec 3/23/2011 18:38'!
compileSource: source of: className 

	[ :cls :src | (Smalltalk classNamed: cls) compile: src ] onServer 
		value: className 
		value: source.! !

!OrcaSaveButton methodsFor: 'save source' stamp: 'LT 2/23/2011 13:51:50.717'!
evaluateClassDefinition: aString

	[ :def | Compiler evaluate: def ] onServer value: aString.! !

!OrcaSaveButton methodsFor: 'initialization' stamp: 'hk 3/23/2011 14:04'!
initialize

	super initialize.
	self
		text: 'Save';
		onClickDo: [ self save ].! !

!OrcaSaveButton methodsFor: 'save source' stamp: 'LT 4/4/2011 15:12:53.677'!
isInputValidWith: source and: className

	| errorText |
	errorText := ''.
	"does anyone know how to do newline in JS?"
	source isEmpty ifTrue: [errorText := 'No source input.', [ String cr ] onServer value].
	className isEmpty ifTrue: [errorText := errorText, 'No class selected.'].
	errorText isEmpty ifFalse: [Js Global js alert: errorText].
	^ errorText isEmpty! !

!OrcaSaveButton methodsFor: 'save source' stamp: 'LT 2/23/2011 14:20:13.047'!
save

	| source |
	source := self browser codeBox text.
	(self browser methodList currentSelection isEmpty)  
		ifTrue: [self evaluateClassDefinition: source]
		ifFalse: 
			[ |className|
			className := self browser classList selectedClassName.
			(self isInputValidWith: source and: className)
				ifTrue: [ self compileSource: source of: className]]
	! !

!OrcajQueryButton methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:29'!
onLoad
	
	(Js @ 'input:button') button value.! !

!OrcaInput class methodsFor: 'instance creation' stamp: 'LT 2/23/2011 15:38:05.444'!
doing: aBlock withText: aString
	
	^ self new
		onClickDo: aBlock;
		text: aString;
		yourself! !

!OrcaInput class methodsFor: 'configuration' stamp: 'LT 2/23/2011 15:32:03.601'!
htmlElementType
	
	^ 'input'! !

!OrcaInput class methodsFor: 'instance creation' stamp: 'hk 3/28/2011 15:33'!
onClick: aBlock
	
	^ self new onClickDo: aBlock; yourself! !

!OrcaInput methodsFor: 'rendering' stamp: 'sw 3/30/2011 15:00'!
disable
	
	self node disabled: true! !

!OrcaInput methodsFor: 'rendering' stamp: 'sw 3/30/2011 15:00'!
enable
	
	self node disabled: false! !

!OrcaInput methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:28'!
onClickDo: aBlockClosure

	self node onclick: aBlockClosure.! !

!OrcaInput methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:30:12.227'!
text
	
	^ self node value
	! !

!OrcaInput methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:27'!
text: aString
	
	self node value: aString
	! !

OrcaInput subclass: #OrcaSmartSearch
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaSmartSearch class methodsFor: 'searching' stamp: 'LT 3/1/2011 14:49:51.707'!
classNameFor: aMethodReference

	| classname |
	classname := aMethodReference classSymbol asString.
	(aMethodReference classIsMeta) ifTrue: [ classname := classname, ' class' ].
	^ classname! !

!OrcaSmartSearch class methodsFor: 'instance creation' stamp: 'LT 2/24/2011 21:20:33.501'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaSmartSearch class methodsFor: 'searching' stamp: 'sw 3/31/2011 10:16'!
search: aString
	
	| searchString |
	searchString := aString trimBoth.
	^ (searchString first isUppercase) 
		ifTrue: [self searchForClass: searchString]
		ifFalse: [self searchForSelector: searchString]! !

!OrcaSmartSearch class methodsFor: 'searching' stamp: 'sw 3/31/2011 14:28'!
searchForClass: aString

	^ Smalltalk allClasses 
			select: [ :each | each name includesSubstring: aString caseSensitive: false]
			thenCollect: [ :each | 
				{#label -> each name.
				#value -> each name.
				#package -> each category. 
				#class -> each name. 
				#selector -> nil.
				#category -> nil.
				#classside -> false} asObject ]! !

!OrcaSmartSearch class methodsFor: 'searching' stamp: 'lw 3/1/2011 18:54'!
searchForSelector: aString
	^ (SystemNavigation new allImplementorsOf: aString asSymbol) asArray
		collect: [ :each | 
			| className methodName |
			className := self classNameFor: each.
			methodName := (className , '>>' , each methodSymbol asString).
			{#label -> methodName.
			#value -> methodName.
			#package -> (Smalltalk classNamed: each classSymbol) category.
			#class -> each classSymbol.
			#selector -> each methodSymbol.
			#category -> ((Smalltalk classNamed: className) organization categoryOfElement: each methodSymbol).
			#classside -> each classIsMeta} asObject ]! !

!OrcaSmartSearch methodsFor: 'accessing' stamp: 'LT 2/24/2011 21:24:26.831'!
browser
	^ browser! !

!OrcaSmartSearch methodsFor: 'accessing' stamp: 'LT 2/24/2011 21:24:26.844'!
browser: anObject
	browser := anObject! !

!OrcaSmartSearch methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
enableAutocomplete

	| widget |
	self cssId: 'smartSearch'.
	widget := Js @ '#smartSearch'.
	widget autocomplete
		value:
			{
			(#appendTo -> ('#', OrcaWindow defaultCssId)).
			(#select -> [ :event :ui | self handleSelection: ui ]) .
			(#source
				-> [ :request :response | 
					| matches |
					matches := [ :input | OrcaSmartSearch search: input ] onServer value: (request term).
					response value: matches asArray ]).
			(#minLength -> 3).
			(#delay -> 500)} asObject! !

!OrcaSmartSearch methodsFor: 'initialization' stamp: 'hk 4/5/2011 11:55'!
handleSelection: ui

	self browser
		selectPackage: ui item package;
		selectSide: ui item classside;
		selectClass: ui item class.
	(self isSearchForSelector: ui)
		ifFalse: [ 
			(self browser)
				selectCategory: ui item category;
				selectSelector: ui item selector ].! !

!OrcaSmartSearch methodsFor: 'initialization' stamp: 'hk 4/5/2011 12:00'!
isSearchForSelector: ui

	^ ui item selector isNil! !

!OrcaSmartSearch methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:25'!
onLoad 

	self enableAutocomplete.
	super onLoad.! !

OrcaWidget subclass: #OrcaListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaListItem class methodsFor: 'configuration' stamp: 'SW 2/21/2011 14:03'!
htmlElementType

	^ 'li'! !

OrcaListItem subclass: #OrcaTab
	instanceVariableNames: 'associatedWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTab class methodsFor: 'instance creation' stamp: 'ag 4/6/2011 15:52'!
newFor: aWidget named: aString
	
	^ self new
		associatedWidget: aWidget;
		add: (OrcaAnchor referencing: aWidget named: aString);
		yourself! !

!OrcaTab methodsFor: 'accessing' stamp: 'SW 3/16/2011 11:01'!
associatedWidget
	^ associatedWidget! !

!OrcaTab methodsFor: 'accessing' stamp: 'SW 3/16/2011 11:01'!
associatedWidget: anObject
	associatedWidget := anObject! !

OrcaWidget subclass: #OrcaLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaLoader class methodsFor: 'configuration' stamp: 'hk 2/1/2011 15:27'!
defaultImage

	^ 'http://localhost:8887/play/file/images/loader.gif'! !

!OrcaLoader class methodsFor: 'configuration' stamp: 'hk 2/1/2011 12:31'!
htmlElementType

	^ 'div'! !

!OrcaLoader methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initialize

	| image |
	super initialize.
	
	image := OrcaImage new
		source: self class defaultImage;
	 	description: 'Loading'.
	self cssClass: 'loader'.
	self add: (OrcaParagraph new add: image; yourself).
	self hide.! !

!OrcaLoader methodsFor: 'initialization' stamp: 'sw 3/29/2011 14:51'!
show 

	self node style display: 'table'.! !

OrcaWidget subclass: #OrcaMonticelloStatistics
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:50'!
afternoonCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 12 ]
		and: [ each time hours < 18 ]]! !

!OrcaMonticelloStatistics class methodsFor: 'accessing' stamp: 'hk 3/9/2011 10:40'!
cache
	Cache ifNil: [ Cache := Dictionary new ].
	^ Cache! !

!OrcaMonticelloStatistics class methodsFor: 'accessing' stamp: 'hk 3/9/2011 10:39'!
cache: anObject
	Cache := anObject! !

!OrcaMonticelloStatistics class methodsFor: 'caching' stamp: 'hk 3/9/2011 10:53'!
cache: data as: aKey

	self cache
		at: aKey
		put: (self latestRevision -> data).! !

!OrcaMonticelloStatistics class methodsFor: 'caching' stamp: 'hk 3/22/2011 20:48'!
calculateAndCacheFor: aKey

	| data |
	aKey = #commitsByWeek ifTrue: [ data := self commitsByWeek ].
	aKey = #commitsByWeekDay ifTrue: [ data := self commitsByWeekDay ].
	aKey = #commitsByHour ifTrue: [ data := self commitsByHour ].
	self cache: data as: aKey.
	^ data! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 18:30'!
commitsAtHour: anHour

	^ self versionInfos select:
		[ :each |
			each time notNil and:
				[ each time hour = anHour ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/6/2011 15:52'!
commitsByHour

	| values |
	values := OrderedCollection new.
	
	0 to: 23 do: [ :hour | | amount record |
		amount := (OrcaMonticelloStatistics commitsAtHour: hour) size.
		record := self jsonObjectLabeled: hour withValues: { amount }.
		values add: record ].
	
	^ self jsonObjectLabeled: { 'hour' . 'amount'} withValues: values! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 23:03'!
commitsByTimeSpan: aTimeSpan

	| result date |
	result := OrderedCollection new.
	date := self firstDate - 1 day.
	[ date <= Date today ] whileTrue:
		[ date := date + aTimeSpan.
		result add: (date -> ((self commitsUntil: date) size)) ].
	^ result! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'SW 3/16/2011 14:42'!
commitsByWeek

	| values increment sum |
	values := OrderedCollection new.
	sum := 0.
	(self commitsByTimeSpan: 1 week) do: [ :each | | date record |
		date := each key asString.
		increment := each value - sum.
		record := self jsonObjectLabeled: date withValues: { sum . increment }.
		sum := each value.
		values add: record ].
	
	^ self jsonObjectLabeled: { 'previous commits' . 'increment'} withValues: values! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 12:00'!
commitsByWeekDay

	| values |
	values := OrderedCollection new.
	self dayNames do: [ :each | | daily morning afternoon evening nightly record |
		daily := self commitsOnWeekDay: each.
		morning := (self morningCommitsOf: daily) size.
		afternoon := (self afternoonCommitsOf: daily) size.
		evening := (self eveningCommitsOf: daily) size.
		nightly := (self nightlyCommitsOf: daily) size.
		record := self jsonObjectLabeled: each withValues: { morning . afternoon .evening . nightly }.
		values add: record ].
	
	^ self jsonObjectLabeled: { 'morning' . 'afternoon' . 'evening' . 'nightly' } withValues: values! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:49'!
commitsOnWeekDay: aWeekDay

	 ^ self versionInfos select:
		[ :each |
			each time notNil and:
				[ each date weekday = aWeekDay ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'ag 4/6/2011 15:52'!
commitsUntil: aDate

	^ OrcaMonticelloStatistics versionInfos select: [ :each | each date <= aDate ]! !

!OrcaMonticelloStatistics class methodsFor: 'configuration' stamp: 'hk 3/9/2011 12:08'!
dayNames

	| nonIsoCompliantWeek sunday |
	nonIsoCompliantWeek := Week dayNames.
	sunday := nonIsoCompliantWeek first.
	^ (nonIsoCompliantWeek
		copyWithout: sunday)
		copyWith: sunday! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:58'!
eveningCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 18 ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 18:03'!
extractRevisionFrom: aVersionInfo

	| versionName segments revision |
	versionName := aVersionInfo name.
	segments := versionName subStrings: '.'.
	(segments size < 2) ifTrue: [ ^ nil ].
	revision := segments last trimLeft: [ :char | char isDigit not ].
	^ revision asNumber! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:46'!
filterCommits: versionInfos with: aBlock

	^ versionInfos select: aBlock! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 21:54'!
firstDate

	^ (self versionInfos at: 1) date! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 18:08'!
insert: aVersionInfo into: aDictionary

	aDictionary
		at: (self extractRevisionFrom: aVersionInfo)
		put: aVersionInfo.! !

!OrcaMonticelloStatistics class methodsFor: 'caching' stamp: 'hk 3/9/2011 10:50'!
isCached: aKey

	(self cache includesKey: aKey)
		ifFalse: [ ^ false ]
		ifTrue:
			[ | association |
			association := self cache at: aKey.
			^ association key == self latestRevision ]! !

!OrcaMonticelloStatistics class methodsFor: 'rendering' stamp: 'SW 3/16/2011 13:50'!
jsonDataAt: aKey

	| data |
	(self isCached: aKey)
		ifTrue: [ data := (self cache at: aKey) value ]
		ifFalse: [ data := self calculateAndCacheFor: aKey ].

	^ '(', (Json render: data), ')'
	
! !

!OrcaMonticelloStatistics class methodsFor: 'rendering' stamp: 'SW 3/16/2011 14:43'!
jsonObjectLabeled: aLabel withValues: values

	^ JsonObject new
		at: #label put: aLabel;
		at: #values put: values;
		yourself! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 17:59'!
latestRevision

	^ self extractRevisionFrom: self latestVersionInfo! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 17:34'!
latestVersionInfo

	^ self workingCopy ancestry ancestors first! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:48'!
morningCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 6 ]
		and: [ each time hours < 12 ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:50'!
nightlyCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 0 ]
		and: [ each time hours < 6 ]]! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 17:32'!
package

	^ MCPackage allInstances detect: [ :first | first name = self packageName ]
! !

!OrcaMonticelloStatistics class methodsFor: 'configuration' stamp: 'hk 3/7/2011 17:33'!
packageName

	^ 'Squeak2JS'! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 18:10'!
versionInfos

	| current result |
	result := Dictionary new.
	current := self latestVersionInfo.
	self insert: current into: result.
	[ current ancestors notEmpty ] whileTrue: [
		current := current ancestors first.
		self insert: current into: result. ].
	^ result! !

!OrcaMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 17:33'!
workingCopy

	^ self package workingCopy
! !

!OrcaMonticelloStatistics methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addCommitDistribution

	| heading |
	
	heading := (OrcaHeading new text: 'Weekly commits per day').
	heading marginTop: 70.
	self add: heading .
	self add: OrcaBarChart new.
	

		
	! !

!OrcaMonticelloStatistics methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addCommitsByHour

	| heading |
	
	heading := (OrcaHeading new text: 'Commits per hour').
	heading marginTop: 70.
	self add: heading .
	self add: OrcaCommitsByHour new.
	

		
	! !

!OrcaMonticelloStatistics methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addOverviewOfCommits

	self add: (OrcaHeading new text: 'Overview of commits').
	self add: OrcaAreaChart new.
	
		
! !

!OrcaMonticelloStatistics methodsFor: 'initialization' stamp: 'SW 3/16/2011 16:17'!
initialize

	super initialize.	
	
	self
		addOverviewOfCommits;
		addCommitDistribution;
		addCommitsByHour.! !

OrcaWidget subclass: #OrcaNamedWidget
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaNamedWidget methodsFor: 'accessing' stamp: 'hk 2/1/2011 14:18'!
name
	^ name! !

!OrcaNamedWidget methodsFor: 'accessing' stamp: 'hk 2/1/2011 14:18'!
name: anObject
	name := anObject! !

OrcaNamedWidget subclass: #OrcaRadioButton
	instanceVariableNames: 'caption value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaRadioButton class methodsFor: 'configuration' stamp: 'hk 2/1/2011 10:51'!
htmlElementType

	^ 'input'! !

!OrcaRadioButton class methodsFor: 'instance creation' stamp: 'hk 3/6/2011 22:29'!
withCaption: aCaption andValue: aValue

	^ self new
		caption: aCaption;
		value: aValue;
		cssId: aValue;
		refreshMarkup! !

!OrcaRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:54'!
caption
	^ caption! !

!OrcaRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:54'!
caption: anObject
	caption := anObject! !

!OrcaRadioButton methodsFor: 'convenience' stamp: 'sw 3/29/2011 15:51'!
check

	self node checked: 'checked'.! !

!OrcaRadioButton methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:51'!
initialize 

	super initialize.
	self node type: 'radio'.! !

!OrcaRadioButton methodsFor: 'convenience' stamp: 'sw 3/29/2011 15:51'!
isChecked

	^ self node checked! !

!OrcaRadioButton methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:52'!
refreshMarkup

	self node value: self value.
	self node name: self name.! !

!OrcaRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:56'!
value
	^ value! !

!OrcaRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:56'!
value: anObject
	value := anObject! !

OrcaNamedWidget subclass: #OrcaRadioGroup
	instanceVariableNames: 'radioButtons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaRadioGroup subclass: #OrcaButtonSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaButtonSet class methodsFor: 'configuration' stamp: 'hk 3/6/2011 22:45'!
defaultCssId

	^ 'buttonSet'! !

!OrcaButtonSet methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
enableButtonSet
	
	(Js @ ('#', self class defaultCssId)) buttonset value! !

!OrcaButtonSet methodsFor: 'initialization' stamp: 'hk 3/6/2011 22:49'!
initialize

	super initialize.
	self cssId: self class defaultCssId.! !

!OrcaButtonSet methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:24'!
onLoad

	self enableButtonSet.! !

OrcaButtonSet subclass: #OrcaSideSelector
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaSideSelector class methodsFor: 'defaults' stamp: 'hk 3/9/2011 14:56'!
classside

	^ 'class'! !

!OrcaSideSelector class methodsFor: 'defaults' stamp: 'LT 3/1/2011 15:02:14.51'!
instanceside

	^ 'instance'! !

!OrcaSideSelector class methodsFor: 'instance creation' stamp: 'sec 1/26/2011 14:33'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaSideSelector methodsFor: 'accessing' stamp: 'sec 1/25/2011 17:52'!
browser
	^ browser! !

!OrcaSideSelector methodsFor: 'accessing' stamp: 'sec 1/25/2011 17:52'!
browser: anObject
	browser := anObject! !

!OrcaSideSelector methodsFor: 'initialization' stamp: 'hk 3/9/2011 15:01'!
initialize

	super initialize.
	self name: 'side-selector'.
	self addButtonNamed: self class instanceside.
	self addButtonNamed: self class classside.
	self onChange: [ self browser showSide ].! !

!OrcaSideSelector methodsFor: 'initialization' stamp: 'sw 4/4/2011 15:16'!
switchToClassside 

	self select: self class classside ! !

!OrcaSideSelector methodsFor: 'initialization' stamp: 'sw 4/4/2011 15:16'!
switchToInstanceside 

	self select: self class instanceside! !

!OrcaRadioGroup class methodsFor: 'configuration' stamp: 'hk 2/1/2011 10:49'!
htmlElementType

	^ 'div'! !

!OrcaRadioGroup class methodsFor: 'instance creation' stamp: 'hk 2/1/2011 11:10'!
newNamed: aName

	^ self new name: aName! !

!OrcaRadioGroup methodsFor: 'rendering' stamp: 'hk 3/9/2011 14:52'!
add: aRadioButton

	self children ifEmpty: [ aRadioButton check ].
	self addLabelFor: aRadioButton.
	aRadioButton
		name: self name;
		refreshMarkup.
	super add: aRadioButton.
	self radioButtons add: aRadioButton.! !

!OrcaRadioGroup methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
addButtonNamed: aString

	self add: (OrcaRadioButton withCaption: aString andValue: aString).! !

!OrcaRadioGroup methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
addLabelFor: aRadioButton

	| label |
	label := OrcaLabel for: aRadioButton.
	super add: label.! !

!OrcaRadioGroup methodsFor: 'accessing' stamp: 'ag 4/5/2011 17:59'!
currentSelection

	^ ((Js @ '.radio') find value: ':checked') first value! !

!OrcaRadioGroup methodsFor: 'initialization' stamp: 'hk 3/9/2011 14:49'!
initialize

	super initialize.
	self cssClass: 'radio'.
	self radioButtons: OrderedCollection new.! !

!OrcaRadioGroup methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:52'!
onChange: aBlock

	self radioButtons do: [ :each | each node onclick: aBlock ].! !

!OrcaRadioGroup methodsFor: 'accessing' stamp: 'hk 3/9/2011 14:48'!
radioButtons
	^ radioButtons! !

!OrcaRadioGroup methodsFor: 'accessing' stamp: 'hk 3/9/2011 14:48'!
radioButtons: anObject
	radioButtons := anObject! !

!OrcaRadioGroup methodsFor: 'accessing' stamp: 'sw 4/4/2011 16:44'!
select: aString

	self radioButtons do: [:each |
		each value = aString 
			ifTrue: [ each check ]
		]! !

OrcaWidget subclass: #OrcaSelectList
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaSelectList subclass: #OrcaBrowserPane
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaBrowserPane class methodsFor: 'instance creation' stamp: 'sec 1/25/2011 16:07'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaBrowserPane methodsFor: 'accessing' stamp: 'sec 1/25/2011 15:29'!
browser
	^ browser! !

!OrcaBrowserPane methodsFor: 'accessing' stamp: 'sec 1/25/2011 15:29'!
browser: anObject
	browser := anObject! !

!OrcaBrowserPane methodsFor: 'initialization' stamp: 'sec 1/25/2011 15:53'!
initialize
	
	super initialize.
	self
		position: 0 @ 0;
		extent: 200 @ 300.! !

!OrcaBrowserPane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:40'!
update
	
	self clear.! !

OrcaBrowserPane subclass: #OrcaClassPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaClassPane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:29'!
clear

	super clear.
	self browser protocolList clear.! !

!OrcaClassPane methodsFor: 'rendering' stamp: 'sw 3/30/2011 16:56'!
selectedClassName

	| className |
	className := self currentSelection.
	(self browser sideSelector currentSelection = 'class') ifTrue: [className := className, ' class'].
	^ className! !

!OrcaClassPane methodsFor: 'rendering' stamp: 'sw 4/5/2011 09:17'!
updateForClass

	self browser protocolList update.
	self browser codeBox displayClassDefinition! !

!OrcaClassPane methodsFor: 'rendering' stamp: 'sw 3/30/2011 16:15'!
updateForPackage: aPackageName
	
	| packageClassNames |
	self browser spinner show.
	self browser saveButton disable.
	self update.
	packageClassNames := [ :name | Smalltalk allClasses 
			select: [ :each | each category asString = name ]
			thenCollect: [ :eachClass | eachClass name asString ] ]
		onServer value: aPackageName.
	packageClassNames do: 
		[ :each | self
			addString: each 
			onClickDo: 
				[ self updateForClass ]].
	self browser spinner hide.! !

OrcaBrowserPane subclass: #OrcaMethodPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaMethodPane methodsFor: 'rendering' stamp: 'LT 1/26/2011 10:54:45.028'!
clear

	super clear.
	self browser codeBox clear.! !

!OrcaMethodPane methodsFor: 'rendering' stamp: 'LT 2/23/2011 14:43:30.445'!
updateForClass: aClassName in: aProtocolName

	|selectors|
	self browser spinner show.
	self update.
	self browser saveButton disable.
	selectors := [ :className :category || selectorNames class |
			class := Smalltalk classNamed: className.
			selectorNames := class organization
				listAtCategoryNamed: category.
			selectorNames collect: [ :each | each asString ]
		] onServer value: aClassName value: aProtocolName.
	selectors do: [ :selector |
			self
				addString: selector asString
				onClickDo: [ self browser codeBox updateFor: selector of: aClassName]].
	self browser spinner hide.! !

OrcaBrowserPane subclass: #OrcaPackagePane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaPackagePane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:53'!
clear

	super clear.
	self browser classList clear.! !

!OrcaPackagePane methodsFor: 'initialization' stamp: 'sec 1/25/2011 15:27'!
initialize

	super initialize.
	self update.! !

!OrcaPackagePane methodsFor: 'rendering' stamp: 'LT 2/23/2011 14:44:24.622'!
update
	
	| allCategoryNames |
	self browser spinner show.
	super update.
	allCategoryNames := [ Smalltalk organization categories
			collect: [ :each | each asString ] ]
		onServer value.
	allCategoryNames do: 
		[ :each | 
			self
				addString: each
				onClickDo: [ self browser classList updateForPackage: each ]].
	self browser spinner hide.			! !

OrcaBrowserPane subclass: #OrcaProtocolPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaProtocolPane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:29'!
clear

	super clear.
	self browser methodList clear.! !

!OrcaProtocolPane methodsFor: 'rendering' stamp: 'sw 3/31/2011 09:02'!
update
	
	| allCategoryNames className |
	self browser spinner show.
	super update.	
	className := self browser classList selectedClassName.
	allCategoryNames := [ :class  |
			(Smalltalk classNamed: class) 
				organization categories 
				collect: [ :each | each asString ] ]
		onServer value: className.
	allCategoryNames do: 
		[ :eachCategory | 
			self
				addString: eachCategory
				onClickDo: [ self browser methodList updateForClass: className in: eachCategory ]].
	self browser spinner hide.! !

!OrcaSelectList class methodsFor: 'configuration' stamp: 'lw 1/13/2011 10:38'!
htmlElementType
	^ 'select'! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'ag 1/18/2011 14:36'!
addOption: aString
	
	^ self addOption: aString value: aString onClickDo: []! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'robi 1/17/2011 19:39'!
addOption: aString value: aValueString
	
	^ self addOption: aString value: aValueString defaultSelected: false selected: false! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
addOption: anOption value: aValue defaultSelected: isDefaultSelected selected: isSelected
	"Just to have the full HTML-Option-API reflected here."
	
	^self add: (OrcaListOption new text: anOption; yourself).! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:48'!
addOption: aString value: anotherString onClickDo: aBlock
	
	| anOption |
	anOption := self addOption: aString value: anotherString defaultSelected: false selected: false.
	anOption node onclick: [aBlock value: aString].
	^anOption! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'LT 1/18/2011 21:13:49.638'!
addString: aString

	^ self addString: aString onClickDo: []! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'sec 2/25/2011 22:29'!
addString: aString onClickDo: aBlock

	^self addOption: aString value: aString onClickDo: aBlock! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:48'!
collapse

	self node size: '1'.
	self node height: '20px'.! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'sw 3/30/2011 17:12'!
currentSelection

	^ self node value! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'ag 4/6/2011 18:03'!
fillWith: anOrderedCollection
	
"	| text |
	text := anArrayString.
	OrcaText new 
		addToWorld;
		text: text;
		position: 10 @ 200."! !

!OrcaSelectList methodsFor: 'initialization' stamp: 'sw 3/30/2011 13:13'!
initialize
	
	super initialize.
	self node size: 2! !

!OrcaSelectList methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:50'!
onChange: aBlock

	self node onchange: aBlock! !

!OrcaSelectList methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:49'!
options

	^ self node getElementsByTagName value: 'option'! !

!OrcaSelectList methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:47'!
select: aString

	self options do: [ :each | (aString = (each text))  ifTrue: [ each selected: true ]]! !

OrcaWidget subclass: #OrcaSystemStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaSystemStatus methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addGraph

	self add: OrcaTreeGraph new.! !

!OrcaSystemStatus methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addTexts
	
	self add: (OrcaHeading new text: 'Application hierarchy').! !

!OrcaSystemStatus methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:45'!
initialize 
	
	super initialize.
	self
		addTexts;
		addGraph.! !

OrcaWidget subclass: #OrcaSystemStatusTabHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaSystemStatusTabHolder methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addTabs

	| tabs |
	tabs := OrcaTabHost new
		add: (OrcaMonticelloStatistics new) named: 'Monticello Statistics';
		add: (OrcaSystemStatus new) named: 'Class hierachy';
		add: (OrcaControls new) named: 'System control'.
	self add: tabs.! !

!OrcaSystemStatusTabHolder methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:40'!
initialize 
	
	super initialize.
	self addTabs.
! !

OrcaWidget subclass: #OrcaTabHost
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTabHost class methodsFor: 'configuration' stamp: 'SW 2/21/2011 11:15'!
defaultCssId

	 ^ 'tabs'! !

!OrcaTabHost methodsFor: 'accessing' stamp: 'ag 4/6/2011 15:52'!
add: aWidget named: aString
	
	self ensureIdOf: aWidget.
	self tabs add: (OrcaTab newFor: aWidget named: aString).
	self add: aWidget.! !

!OrcaTabHost methodsFor: 'accessing' stamp: 'hk 4/5/2011 16:51'!
ensureIdOf: aWidget

	aWidget cssId ifEmpty:
		[ | number |
		number := self children size.
		aWidget cssId: self class defaultCssId, '-', number asString. ]! !

!OrcaTabHost methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initialize 

	super initialize.
	self tabs: OrcaUnorderedList new.
	self add: self tabs.
	self cssId: self class defaultCssId.
! !

!OrcaTabHost methodsFor: 'initialization' stamp: 'ag 4/6/2011 13:09'!
initializeTabs

	Js Global setTimeout
		value: [ (Js @ ('#', self class defaultCssId)) tabs value ] "Cannot give the tabs function directly, must encapsulate into extra anonymous block."
		value: 500.! !

!OrcaTabHost methodsFor: 'initialization' stamp: 'hk 3/6/2011 22:12'!
onLoad

	self initializeTabs.
	super onLoad.! !

!OrcaTabHost methodsFor: 'accessing' stamp: 'SW 2/21/2011 11:07'!
tabs
	^ tabs! !

!OrcaTabHost methodsFor: 'accessing' stamp: 'SW 2/21/2011 11:07'!
tabs: anObject
	tabs := anObject! !

OrcaWidget subclass: #OrcaTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTable class methodsFor: 'configuration' stamp: 'SW 2/8/2011 10:37'!
htmlElementType
	
	^ 'table'! !

!OrcaTable methodsFor: 'accessing' stamp: 'ag 4/6/2011 15:52'!
addRowWith: aString
	self add: (OrcaTableRow new put: aString).
! !

!OrcaTable methodsFor: 'accessing' stamp: 'ag 4/6/2011 15:52'!
addRowWith: aString with: anotherString

	| row |
	row:=(OrcaTableRow new) 
			put: aString;
			put: anotherString.			
		
	self add: row.
! !

OrcaWidget subclass: #OrcaTableRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTableRow class methodsFor: 'configuration' stamp: 'SW 2/8/2011 10:40'!
htmlElementType
	
	^ 'tr'! !

!OrcaTableRow methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
put: aString
	
	self add: (OrcaTableCell new text: aString)! !

OrcaWidget subclass: #OrcaText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaText subclass: #OrcaAnchor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaAnchor class methodsFor: 'configuration' stamp: 'SW 2/21/2011 11:41'!
htmlElementType 
	
	^ 'a'! !

!OrcaAnchor class methodsFor: 'instance creation' stamp: 'hk 3/8/2011 09:57'!
named: aName

	^ self new
		text: aName;
		target: '#';
		yourself 
! !

!OrcaAnchor class methodsFor: 'instance creation' stamp: 'SW 2/21/2011 14:16'!
referencing: aTarget named: aName

	^ self new
		text: aName;
		target: aTarget;
		yourself 
! !

!OrcaAnchor methodsFor: 'accessing' stamp: 'ag 4/5/2011 17:51'!
target: aTarget

	aTarget isString 
		ifTrue: [ self node href: aTarget ]
		ifFalse: [ self node href: '#', aTarget cssId ].! !

OrcaText subclass: #OrcaHeading
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaHeading class methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:53'!
htmlElementType

	^ 'h3'! !

OrcaText subclass: #OrcaLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaLabel class methodsFor: 'instance creation' stamp: 'hk 3/6/2011 22:26'!
for: aRadioButton

	^ self new
		text: aRadioButton caption;
		htmlFor: aRadioButton! !

!OrcaLabel class methodsFor: 'configuration' stamp: 'hk 2/1/2011 14:31'!
htmlElementType

	^ 'label'! !

!OrcaLabel methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:40'!
htmlFor: aRadioButton

	self node htmlFor: aRadioButton cssId.! !

OrcaText subclass: #OrcaListOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaListOption class methodsFor: 'configuration' stamp: 'LT 1/18/2011 22:11:51.562'!
htmlElementType
	^'option'! !

!OrcaListOption methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:41'!
initialize

"	self node: (Option jsNew : { ''. ''. false. false })."
	super initialize ! !

!OrcaListOption methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:25'!
text: aString
	
	self node innerHTML: aString.
	self node value: aString.
	^self! !

OrcaText subclass: #OrcaParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaParagraph class methodsFor: 'configuration' stamp: 'hk 2/1/2011 15:41'!
htmlElementType
	
	^ 'p'! !

OrcaText subclass: #OrcaTableCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTableCell class methodsFor: 'configuration' stamp: 'SW 2/8/2011 10:40'!
htmlElementType
	
	^ 'td'! !

!OrcaText methodsFor: 'rendering' stamp: 'hk 2/28/2011 15:40'!
clear

	super clear.
	self text: ''! !

!OrcaText methodsFor: 'initialization' stamp: 'hk 4/4/2011 10:25'!
initialize
	
	super initialize.
	self text: ''.! !

!OrcaText methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:39'!
text

	^ self node value! !

!OrcaText methodsFor: 'accessing' stamp: 'hk 4/4/2011 15:13'!
text: aString
	
	self node innerHTML: aString.
	self node value: aString.! !

OrcaText subclass: #OrcaTextArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaTextArea subclass: #OrcaTabbyTextArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTabbyTextArea class methodsFor: 'configuration' stamp: 'hk 4/4/2011 16:44'!
scriptSource

	^ 'http://teddevito.com/demos/js/jquery.textarea.js'! !

!OrcaTabbyTextArea methodsFor: 'initialization' stamp: 'hk 4/4/2011 16:45'!
initialize

	| script |
	super initialize.
	script := Js Document createElement value: 'script'.
	script
		src: self class scriptSource;
		type: 'text/javascript'.
	self node appendChild value: script.! !

!OrcaTabbyTextArea methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
onLoad
	
	self withDisposableId: [ (Js @ ('#', self cssId)) tabby value ].! !

!OrcaTextArea class methodsFor: 'configuration' stamp: 'robi 1/17/2011 19:41'!
htmlElementType
	
	^ 'textarea'! !

!OrcaTextArea class methodsFor: 'instance creation' stamp: 'hk 1/26/2011 11:26'!
with: aString

	^ self new text: aString; yourself! !

!OrcaTextArea methodsFor: 'rendering' stamp: 'hk 4/4/2011 15:12'!
beReadOnly

	self node setAttribute value: 'readonly' value: 'readonly'.! !

OrcaWidget subclass: #OrcaUnorderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaUnorderedList class methodsFor: 'configuration' stamp: 'SW 2/21/2011 11:32'!
htmlElementType 

	^ 'ul'! !

!OrcaWidget class methodsFor: 'configuration' stamp: 'SW 2/7/2011 14:46'!
htmlElementType
	
	^ 'div'! !

!OrcaWidget class methodsFor: 'configuration' stamp: 'robi 1/26/2011 12:00'!
start
	" this method will only be invoked in case you use your widget as a start app"
	^ self new addToWorld! !

!OrcaWidget methodsFor: 'rendering' stamp: 'hk 3/30/2011 11:30'!
add: anObject

	self children add: anObject.
	self node appendChild value: anObject node.
	^ anObject! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:18'!
addAll: aCollection

	aCollection do: [ :each | self add: each ].! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 17:11'!
addToWorld
	"Add this widget to a root-div-element."
		
	(Js Document getElementById value: 'container')
		appendChild value: self node.
	self onLoad.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:33'!
beRelative

	self node style position: 'relative'.
	self node style top: '0'.
	self node style left: '0'! !

!OrcaWidget methodsFor: 'accessing' stamp: 'LT 1/18/2011 21:53:58.821'!
children
	^ children! !

!OrcaWidget methodsFor: 'accessing' stamp: 'LT 1/18/2011 21:53:58.832'!
children: anObject
	children := anObject! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/31/2011 14:51'!
clear
	
	self children do: [ :each | self node removeChild value:  (each node ) ].
	self children removeAll.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:14'!
cssClass: aString

	self node className: aString! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 13:51'!
cssId

	^ self node id
	! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/30/2011 13:07'!
cssId: aString

	self node id: aString! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:29'!
extent
	
	^ Point x: (self node width) y: (self node height)! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:32'!
extent: anObject
	
	extent := anObject.
	self node style height: anObject y asString , 'px'. 
	self node style width: anObject x asString , 'px'! !

!OrcaWidget methodsFor: 'convenience' stamp: 'hk 4/5/2011 12:52'!
generateCssId

	self clientSideResposibility.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:36'!
height: aHeight
	
	self node style height: aHeight.! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:23'!
hide 

	self node style display: 'none'! !

!OrcaWidget methodsFor: 'initialization' stamp: 'sw 3/29/2011 14:11'!
initialize
	
	self
		node: (Js Document createElement value: self class htmlElementType);
		children: OrderedCollection new.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:37'!
marginBottom: aHeight
	
	self node style marginBottom: aHeight asString, 'px'! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:37'!
marginTop: aHeight
	
	self node style marginTop: aHeight asString, 'px'! !

!OrcaWidget methodsFor: 'accessing' stamp: 'lw 1/13/2011 10:35'!
node
	^ node! !

!OrcaWidget methodsFor: 'accessing' stamp: 'ag 1/18/2011 09:45'!
node: anObject
	"Must not be set after initialization"
	
	node := anObject! !

!OrcaWidget methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:21'!
onLoad

	self children ifNil: [ ^ self ].
	self children do: [ :each | each onLoad ].! !

!OrcaWidget methodsFor: 'accessing' stamp: 'hk 2/1/2011 11:31'!
pathFor: aFile

	^ self app uniquePath, '/', aFile! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:38'!
position: anObject
	
	self node style position: 'absolute'.
	self node style top: anObject y asString, 'px'.
	self node style left: anObject x asString , 'px'.! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:38'!
show 

	self node style display: 'block'.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:38'!
width: aWidth
	
	self node style width: aWidth.! !

!OrcaWidget methodsFor: 'convenience' stamp: 'hk 4/5/2011 10:53'!
withDisposableId: aBlock

	| oldId |
	oldId := self cssId.
	self cssId: self generateCssId.
	aBlock value.
	self cssId: oldId.! !

OrcaWidget subclass: #OrcaWindow
	instanceVariableNames: 'title content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaWindow class methodsFor: 'configuration' stamp: 'hk 3/7/2011 15:30'!
defaultCssClasses

	^ 'ui-dialog ui-widget ui-widget-content ui-corner-all ui-draggable'! !

!OrcaWindow class methodsFor: 'configuration' stamp: 'hk 3/4/2011 12:55'!
defaultCssId

	^ 'window'! !

!OrcaWindow class methodsFor: 'configuration' stamp: 'hk 3/4/2011 13:16'!
defaultEffect

	^ 'blind'! !

!OrcaWindow class methodsFor: 'instance creation' stamp: 'hk 3/4/2011 11:57'!
newTitled: aString

	^ self basicNew title: aString; initialize! !

!OrcaWindow methodsFor: 'rendering' stamp: 'hk 3/8/2011 11:12'!
add: aWidget

	self content add: aWidget.! !

!OrcaWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 13:19'!
content
	^ content! !

!OrcaWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 13:19'!
content: anObject
	content := anObject! !

!OrcaWindow methodsFor: 'initialization' stamp: 'sw 4/6/2011 08:45'!
initialize

	super initialize.
	self
		cssClass: self class defaultCssClasses;
		cssId: self class defaultCssId;
		width: 'auto'.
	self
		initializeContentArea;
		initializeTitleBar.
! !

!OrcaWindow methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initializeContentArea

	self content: (OrcaText new cssClass: 'ui-widget-content'; yourself).
	super add: self content.! !

!OrcaWindow methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initializeTitleBar

	| titleBar |
	titleBar := OrcaText new
		text: self title;
		cssClass: 'ui-dialog-titlebar ui-widget-header ui-corner-all ui-helper-clearfix'.
	titleBar add: ((OrcaButton doing: [ self toggle ] withText: 'toggle') cssClass: 'ui-icon ui-icon-triangle-2-n-s').
	self add: titleBar! !

!OrcaWindow methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
makeDraggable

	(Js @ ('#',  self class defaultCssId)) draggable value! !

!OrcaWindow methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:23'!
onLoad

	self makeDraggable.
	self content onLoad.! !

!OrcaWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 11:49'!
title
	^ title! !

!OrcaWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 11:49'!
title: anObject
	title := anObject! !

!OrcaWindow methodsFor: 'animation' stamp: 'ag 4/5/2011 17:39'!
toggle
	
	(Js @ '#window .ui-widget-content') toggle
		value: self class defaultEffect
		value: {} asObject
		value: 500.! !

OrcaWidget subclass: #OrcaWorkspace
	instanceVariableNames: 'smalltalkCodeBox javascriptCodeBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Workspace'!

OrcaWorkspace subclass: #OrcaCodeBox
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaCodeBox class methodsFor: 'instance creation' stamp: 'LT 1/26/2011 17:04:37.953'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OrcaCodeBox methodsFor: 'accessing' stamp: 'LT 1/26/2011 17:04:49.802'!
browser
	^ browser! !

!OrcaCodeBox methodsFor: 'accessing' stamp: 'LT 1/26/2011 17:04:49.812'!
browser: anObject
	browser := anObject! !

!OrcaCodeBox methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createButtonsForInput: aNode

	^ OrcaContainer horizontal! !

!OrcaCodeBox methodsFor: 'rendering' stamp: 'LT 2/23/2011 13:55:43.357'!
displayClassDefinition

	| definition className |
	self browser saveButton enable.
	className := self browser classList selectedClassName.
	className isEmpty
		ifFalse: 
			[definition := [ :cls | (Smalltalk classNamed: cls) definition ] onServer value: className.
			self text: definition]! !

!OrcaCodeBox methodsFor: 'initialization' stamp: 'hk 1/26/2011 17:02'!
initialize 

	super initialize.
	self
		extent: 800 @ 300;
		yourself.! !

!OrcaCodeBox methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
translate: aSmalltalkSnippet

	^
	[ :smalltalkCode | | assoc |
		[ assoc := OrcaPrettyPrinter convertMethod: smalltalkCode. assoc key, ' = ', assoc value ] on: Error do: [ '' ]
		] onServer value: aSmalltalkSnippet.! !

!OrcaCodeBox methodsFor: 'rendering' stamp: 'LT 3/1/2011 16:17:26.873'!
updateFor: aMethodname of: aClassname

	self browser spinner show.
	self clear.
	self browser saveButton enable.
	self text: (
		[ :methodName :classname |
		((Smalltalk classNamed: classname) methodDict at: methodName asSymbol) getSource asString ]
			onServer
				value: aMethodname
				value: aClassname).
	self browser spinner hide.! !

!OrcaWorkspace class methodsFor: 'configuration' stamp: 'hk 4/4/2011 14:40'!
emptyBoxString

	^ 'nothing yet'! !

!OrcaWorkspace class methodsFor: 'configuration' stamp: 'robi 1/26/2011 13:12'!
htmlElementType
	
	^ 'div'! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
addElements

	self add: 
		(OrcaContainer vertical
			add: (OrcaContainer horizontal
				add: self smalltalkCodeBox;
				add: self javascriptCodeBox);
			add: (self createButtonsForInput: self smalltalkCodeBox);
			yourself).! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'hk 4/5/2011 14:54'!
bindInput: anInputTextWidget toOutput: anOutputTextWidget
	
	anInputTextWidget node onkeyup: [ :event | | shouldUpdate |
		shouldUpdate := #(32 13 9 46 190) includes: event keyCode.
		shouldUpdate ifTrue:
			[ self
				updateOutput: anOutputTextWidget
				fromInput: anInputTextWidget ]].! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'sec 2/28/2011 17:31'!
clear

	self smalltalkCodeBox clear.! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createButtonsForInput: anInputWidget
	
	^ OrcaContainer horizontal addAll: {
		OrcaButton doing: [ self printContentOf: anInputWidget ] withText: 'Print'.
		OrcaButton doing: [ self doIt: anInputWidget text ] withText: 'Do it' }! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createJsCodeBox

	^ OrcaTextArea new
		extent: 600 @ 400;
		beReadOnly;
		yourself.! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
createStCodeBox

	^ OrcaTabbyTextArea new
		extent: 600 @ 400;
		yourself.! !

!OrcaWorkspace methodsFor: 'logic' stamp: 'hk 3/31/2011 14:29'!
doIt: aSmalltalkSnippet

	^ Js Global eval value: (self translate: aSmalltalkSnippet).! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'hk 3/31/2011 14:30'!
extent

	^ self smalltalkCodeBox extent + self javascriptCodeBox extent! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'hk 4/4/2011 10:26'!
extent: newExtent

	self smalltalkCodeBox extent: (newExtent x * 0.5 @ newExtent y).
	self javascriptCodeBox extent: (newExtent x * 0.5 @ newExtent y).! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 16:50'!
initialize

	super initialize.
	self smalltalkCodeBox: self createStCodeBox.
	self javascriptCodeBox: self createJsCodeBox.
	self
		addElements;
		bindInput: self smalltalkCodeBox
		toOutput: self javascriptCodeBox.! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:28'!
javascriptCodeBox
	^ javascriptCodeBox! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:28'!
javascriptCodeBox: anObject
	javascriptCodeBox := anObject! !

!OrcaWorkspace methodsFor: 'logic' stamp: 'hk 4/4/2011 10:52'!
printContentOf: anInputWidget

	| stCode |
	stCode := anInputWidget text..
	anInputWidget text: stCode, ' ', (self translate: stCode).! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:25'!
smalltalkCodeBox
	^ smalltalkCodeBox! !

!OrcaWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:25'!
smalltalkCodeBox: anObject
	smalltalkCodeBox := anObject! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'hk 3/31/2011 14:31'!
text

	^ self smalltalkCodeBox text! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'sec 2/22/2011 12:36'!
text: aString

	self smalltalkCodeBox text: aString.
	self updateOutput: self javascriptCodeBox fromInput: self smalltalkCodeBox.! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
translate: aSmalltalkSnippet

	^
	[ :smalltalkCode |
		[ OrcaPrettyCodeFactory codeFor: smalltalkCode ] on: Error do: [ '' ]
		] onServer value: aSmalltalkSnippet.! !

!OrcaWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 14:40'!
updateOutput: aJavascriptCodeBox fromInput: aSmalltalkCodeBox

	| jsCode stCode |
	stCode := aSmalltalkCodeBox text.
	jsCode := aJavascriptCodeBox text
		ifEmpty: self class emptyBoxString.
	jsCode := (self translate: stCode)
		ifEmpty: self class emptyBoxString.
	aJavascriptCodeBox text: jsCode.! !

!HTTPConnection methodsFor: '*Orca' stamp: 'ag 4/6/2011 17:50'!
interact
	"We refine this to bring up the debugger when an error occurs inside the Swazoo."



	"longer description is below method"
	| interactionBlock |
	interactionBlock := 
		[[	[ [true] whileTrue: 
				[self getAndDispatchMessages.
				Processor yield] 
			]
			on: Error
			do: [:ex | 
				
				((Smalltalk at: #OrcaDebugSwazooInternalErrors ifAbsent: [nil]) == true)
					ifTrue: [ (ex class = SwazooStreamNoDataError) | (ex class = SpSocketError) ifFalse: [ self halt ] ]
				] ]
		ifCurtailed: [ 
			(Delay forMilliseconds: 50) wait. "to finish sending, if any"
			self isOpen ifTrue: [self close]] ].
	self server isMultiThreading 
		ifTrue: [self loop: (interactionBlock forkAt: Processor userBackgroundPriority)]
		ifFalse: [interactionBlock value].
	^self

"I represent a specifc connection with an HTTP client (a browser, probably) over which will come an HTTP request.  Here, I fork the handling of the request so that the current thread (which is most likely the HTTP server main loop) can carry on with the next request.  This means that more than one request may being handled in the image at a time, and that means that the application developer must worry about thread safety - e.g the problem of a given business object being updated by more than one HTTP request thread.
For a GemStone implementation of Swazoo, one may want only one request is handled at a time, multi-threadedness being handled by having multiple gems.  This is a nice option because the application developer does not have to worry about thread safety in this case - GemStone handles the hard stuff.
*And* the thing called a loop that was in this method was no such thing.  In all circumstances, >>getAndDispatchMessages handles exactly one requst and then closes the socket!! (very non-HTTP1.1).  Anyway, for now I'm just going to make that explicit.  This needs to be re-visited to support HTTP 1.1."! !

!String methodsFor: '*Orca' stamp: 'ag 4/6/2011 15:52'!
definitionLine
	
	^ OrcaSqueakAstToJsAst stringFunction asString, '(', (OrcaAbstractPrinter asJSString: self), ')'! !

!String methodsFor: '*Orca' stamp: 'sw 3/30/2011 14:24'!
jsEval

	^ Js Global eval value: self! !

!Array methodsFor: '*Orca' stamp: 'ag 4/6/2011 15:52'!
asObject 
	
	^ OrcaSlotObject newFrom: self! !

!Array methodsFor: '*Orca' stamp: 'ag 3/31/2011 10:27'!
fillInstVars: codeLines guardedBy: alreadySerialized
	"The super-call should have no effect, as there are no instance-variables here. Let content serialize themselves, then collect their
	variable names and set the primitive js-array (original$)."
	
	super fillInstVars: codeLines guardedBy: alreadySerialized.
	self do: [ :each | each serializeToJavaScript: codeLines guardedBy: alreadySerialized ].
	codeLines addLast: 
		(alreadySerialized at: self), '.original$=[', 
		((self collect: [ :each | alreadySerialized at: each ]) separatedBy: ', '),
		']'.! !

!UndefinedObject methodsFor: '*Orca' stamp: 'ag 4/6/2011 15:52'!
definitionLine
	
	^ (OrcaSqueakAstToJsAst jsKeywordFor: self asString) key! !

Compiler subclass: #OrcaCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaCompiler methodsFor: 'public access' stamp: 'robi 3/16/2011 16:42'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock
	| code |
	
	(origCode includesSubString:  '<language: #JavaScript>')
		ifTrue: [ code := self stubCodeFor: origCode ]
		ifFalse: [ code := origCode ].

	 ^ super compile: code 
				in: cls 
				classified: aCategory 
				notifying: notify 
				ifFail: failBlock! !

!OrcaCompiler methodsFor: 'code generation' stamp: 'robi 3/16/2011 16:41'!
stubCodeFor: aMethodString

	^ ((aMethodString lineNumber: 1), 
		Character lf, 
		'self error: ''JavaScript code cannot be executed in Squeak environment.''')! !

!Number methodsFor: '*Orca' stamp: 'ag 4/6/2011 15:52'!
definitionLine
	
	^ OrcaSqueakAstToJsAst numberFunction asString, '(', self asString, ')'! !

!Number methodsFor: '*Orca' stamp: 'sec 2/16/2011 17:24'!
 aNumber
	{true. false}  atRandom
		ifTrue: [ ^ self + aNumber ]
		ifFalse: [ ^ self - aNumber ]! !

!Boolean methodsFor: '*Orca' stamp: 'ag 4/6/2011 15:52'!
definitionLine
	
	^ (OrcaSqueakAstToJsAst jsKeywordFor: self asString) key! !

!BlockClosure methodsFor: '*Orca' stamp: 'ag 1/19/2011 18:34'!
onServer
	"This is overridden when executing on the client. On the server, there is no change."
	
	^ self! !

SwazooResource subclass: #OrcaResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

OrcaResource subclass: #OrcaBasicApp
	instanceVariableNames: 'clients repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

OrcaBasicApp class
	instanceVariableNames: 'instance'!

OrcaBasicApp class
	instanceVariableNames: 'instance'!

OrcaBasicApp subclass: #OrcaApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaApp class methodsFor: 'rendering-helpers' stamp: 'ag 1/25/2011 15:49'!
allRequiredClasses
	"Return the requiredClasses together with all their superclasses. Only for this class, not the superclasses."
	
	| allClasses |
	allClasses := OrderedCollection new.
	self requiredClasses do: [ :eachClass |
		eachClass allSuperclasses reverseDo: [ :superClass |
			(allClasses includes: superClass) ifFalse: [ allClasses add: superClass ]].
		(allClasses includes: eachClass) ifFalse: [ allClasses add: eachClass ]].
	^ allClasses! !

!OrcaApp class methodsFor: 'rendering-configuration' stamp: 'ag 4/6/2011 15:52'!
codeFactory
	
	^ OrcaPrettyCodeFactory.! !

!OrcaApp class methodsFor: 'rendering-helpers' stamp: 'SW 1/31/2011 08:35'!
codeForAllClasses

	^ self codeFactory codeForClasses: self collectRequiredClasses! !

!OrcaApp class methodsFor: 'rendering-helpers' stamp: 'ag 4/6/2011 15:52'!
collectPostloadScripts
	"Collect #requiredClasses from all superclasses"
	
	^ self
		collect: [ :eachClass | eachClass postloadScripts ]
		upTo: OrcaApp! !

!OrcaApp class methodsFor: 'rendering-helpers' stamp: 'ag 4/6/2011 15:52'!
collectRequiredClasses
	"Collect #requiredClasses from all superclasses"
	
	^ self
		collect: [ :eachClass | eachClass allRequiredClasses ]
		upTo: OrcaApp! !

!OrcaApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/11/2011 19:46'!
postloadScripts
	
	^ #( 'js/perform.js' 'js/boxing.js' 'js/bootstrap.js'
	
	'js/primitives/Array.js' 'js/primitives/BlockClosure.js' 'js/primitives/Exception.js' 'js/primitives/Float.js' 'js/primitives/Js.js' 'js/primitives/Number.js' 'js/primitives/Object.js'
	'js/primitives/OrcaWidget.js' 'js/primitives/Point.js' 'js/primitives/ProtoObject.js' 'js/primitives/String.js' )! !

!OrcaApp class methodsFor: 'rendering-helpers' stamp: 'srv 1/24/2011 14:04'!
recompileRequiredClasses
	"This causes all required classes of THIS web-app (none of the super-classes) to be invalidated in the code-factory-cache."
	
	^ self allRequiredClasses do: [ :each | each compileAll ]! !

!OrcaApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/5/2011 17:24'!
requiredClasses
	"Return any array of classes, that must be compiled to JS-code to enable this application.
	Classes added by subclasses must also return the classes in this implementation, as these clases are required by the js-bootstrapping-library."
	
	^ { Js. BlockClosure. Float. True. False. Error. ByteString. OrderedCollection. Character. Array. UndefinedObject. Point. WriteStream . Message  }! !

!OrcaApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/11/2011 19:45'!
scripts
	"= preload scripts"
	
	^ #( 'js/classes.js' )! !

!OrcaApp class methodsFor: 'rendering-javascript' stamp: 'ag 1/24/2011 16:35'!
startupClass
	"Return something other than nil to call the static method #start on the class returned here."
	
	^ nil! !

!OrcaApp class methodsFor: 'rendering-css' stamp: 'SW 2/21/2011 15:13'!
styles
	
	^ #( 'styles/default.css' )! !

!OrcaApp class methodsFor: 'rendering-helpers' stamp: 'srv 1/24/2011 14:05'!
writeClassesTo: aDirectoryName
	"Write all classes required by this WebApp (together with their superclasses) to files named '<classname>.txt' in the given directory."
	
	self codeForAllClasses.
	self collectRequiredClasses withIndexDo: [ :cl :index |
		self codeFactory
			printCodeFor: cl
			to: aDirectoryName, index asString, '-', cl name, '.txt' ].! !

!OrcaApp class methodsFor: 'rendering-helpers' stamp: 'srv 1/24/2011 14:05'!
writeClassesToFile: aFileName
	"Write all classes required by this WebApp (together with their superclasses) to files named '<classname>.txt' in the given directory."
	
	^ self codeFactory
		printCodeFor: self collectRequiredClasses
		to: aFileName! !

!OrcaApp class methodsFor: 'rendering-helpers' stamp: 'srv 1/24/2011 14:06'!
writeSiteTo: aLocalFilename
	"Write the website, that would be sent to a client, to a new file named aLocalFilename (overwrites existing)."
	
	^ self codeFactory converterClass
		print: self new render
		to: aLocalFilename! !

!OrcaApp methodsFor: 'hooks' stamp: 'ag 4/6/2011 17:57'!
onloadCode
	
	^ super onloadCode, 'app=startupOrca();'! !

!OrcaApp methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
renderJavascript
	"Render the external javascript resources and the link to the compiled classes code."
	
	^
	super renderJavascript,
	(self renderScriptTag: OrcaClassesHandler pathSuffix),
	(self renderScriptTags: self class collectPostloadScripts),
	self renderStartupCall, String cr! !

!OrcaApp methodsFor: 'rendering' stamp: 'ag 4/6/2011 18:11'!
renderStartupCall
	
	^ 
	'<script type="text/javascript">',
	'var startupOrca = function() {', (self class startupClass
		ifNotNil: [ 'return ', (self class codeFactory codeFor: (self class startupClass name, ' start')) ]
		ifNil: [ '' ]),
			'}',
	'</script>'! !

OrcaApp subclass: #OrcaBallGameApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

!OrcaBallGameApp class methodsFor: 'rendering-javascript' stamp: 'ag 3/29/2011 13:41'!
postloadScripts
	
	^ #( 'misc/canvastoolkit.js' )! !

!OrcaBallGameApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 15:52'!
requiredClasses
	
	^ { Rectangle. OrcaBall. OrcaBallGame }! !

!OrcaBallGameApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 15:52'!
startupClass
	
	^ OrcaBallGame! !

!OrcaBallGameApp class methodsFor: 'configuration' stamp: 'lw 1/12/2011 18:39'!
title

	^ 'Bouncing Balls'! !

!OrcaBallGameApp class methodsFor: 'configuration' stamp: 'hk 2/1/2011 11:48'!
uniquePath 
	
	^ 'balls/'! !

!OrcaBallGameApp methodsFor: 'rendering' stamp: 'LT 1/19/2011 15:22:01.602'!
renderContent
	
	^ '<canvas id="ballCanvas" width="400" height="300" style="background-color: #ffffff;  position: relative; border: solid 1px #000000;"></canvas>'! !

OrcaApp subclass: #OrcaIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

!OrcaIndex class methodsFor: 'configuration' stamp: 'ag 1/12/2011 18:21'!
title

	^ 'Index'! !

!OrcaIndex class methodsFor: 'configuration' stamp: 'hk 2/1/2011 11:48'!
uniquePath

	^ 'index/'! !

!OrcaIndex methodsFor: 'hooks' stamp: 'hk 2/1/2011 11:55'!
linkFor:application
	^ '<a href="/', application uniquePath , '" title="', application title ,'">', application title , '</a>'.
	    
	
	! !

!OrcaIndex methodsFor: 'hooks' stamp: 'hk 4/5/2011 11:13'!
renderContent
	
	^ '<h1>Orca Framework</h1>
	<h3>Installed applications:</h3>', self renderLinks! !

!OrcaIndex methodsFor: 'hooks' stamp: 'ag 4/6/2011 15:52'!
renderLinks

	| result |
	result := '<ul>'.
	OrcaBasicApp allSubclassesDo: [ :application | 
		(application = self class or: [ application uniquePath isNil]) ifFalse: [
			result := result , '<li>', (self linkFor:application) , '</li>'.		
			].
		].
	result := result , '</ul>'.
	^ result
	    
	
	! !

OrcaApp subclass: #OrcaWidgetApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

OrcaWidgetApp subclass: #OrcaBrowserApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OrcaBrowserApp class methodsFor: 'configuration' stamp: 'ag 4/6/2011 15:52'!
requiredClasses
	
	^ { OrcaClassBrowser . OrcaSideSelector . OrcaBrowserPane . OrcaClassPane . OrcaMethodPane . OrcaPackagePane . OrcaProtocolPane . OrcaCodeBox . OrcajQueryButton . OrcaSaveButton . OrcaLoader. OrcaSmartSearch . OrcaTabbyTextArea }! !

!OrcaBrowserApp class methodsFor: 'configuration' stamp: 'hk 4/5/2011 10:45'!
scripts

	^ { 'http://teddevito.com/demos/js/jquery.textarea.js' }! !

!OrcaBrowserApp class methodsFor: 'configuration' stamp: 'ag 4/6/2011 15:52'!
startupClass
	
	^ OrcaClassBrowser! !

!OrcaBrowserApp class methodsFor: 'configuration' stamp: 'ag 1/17/2011 18:27'!
title
	
	^ 'Class Browser'! !

!OrcaBrowserApp class methodsFor: 'configuration' stamp: 'hk 2/1/2011 11:49'!
uniquePath
	
	^ 'browser/'! !

OrcaWidgetApp subclass: #OrcaSystemStatusApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OrcaSystemStatusApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 18:11'!
requiredClasses
	
	^ OrcaWidget allSubclasses asArray! !

!OrcaSystemStatusApp class methodsFor: 'rendering-javascript' stamp: 'hk 3/22/2011 22:28'!
scripts 
	
	^ { 'http://thejit.org/static/v20/Jit/jit.js' }
! !

!OrcaSystemStatusApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 15:52'!
startupClass
	
	^ OrcaSystemStatusTabHolder! !

!OrcaSystemStatusApp class methodsFor: 'configuration' stamp: 'SW 2/7/2011 14:21'!
title
	
	^ 'System Status'! !

!OrcaSystemStatusApp class methodsFor: 'configuration' stamp: 'SW 2/7/2011 14:21'!
uniquePath
	
	^ 'systat/'! !

!OrcaWidgetApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 15:52'!
requiredClasses
	
	^ { OrcaSelectList. OrcaTextArea. Association. OrcaListOption . OrcaButton. OrcaHorizontalContainer. OrcaVerticalContainer . OrcaImage . OrcaLoader . OrcaParagraph . OrcaTable . OrcaTableRow . OrcaTableCell . OrcaAnchor . OrcaListItem . OrcaUnorderedList. OrcaInput . OrcaRadioGroup . OrcaRadioButton. OrcaLabel . OrcaWindow }! !

!OrcaWidgetApp class methodsFor: 'rendering-css' stamp: 'hk 3/21/2011 16:29'!
scripts

	^ { 'https://ajax.googleapis.com/ajax/libs/jquery/1.5.1/jquery.min.js'. 
	'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.11/jquery-ui.min.js' }! !

!OrcaWidgetApp class methodsFor: 'rendering-css' stamp: 'hk 3/4/2011 11:54'!
styles
	
	^ { 'styles/widgets.css' . 'styles/smoothness/jquery-ui-1.8.10.custom.css' }! !

!OrcaWidgetApp methodsFor: 'rendering' stamp: 'hk 3/4/2011 14:30'!
renderContent 
	
	^ '<div id="container"></div>'! !

OrcaWidgetApp subclass: #OrcaWidgetPlayground
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

!OrcaWidgetPlayground class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 15:52'!
requiredClasses
	
	^ OrcaWidget allSubclasses! !

!OrcaWidgetPlayground class methodsFor: 'configuration' stamp: 'hk 3/9/2011 09:07'!
scripts 
	
	^ { 'http://code.jquery.com/jquery-1.5.js'. 
	'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/jquery-ui.js' . 
	'http://thejit.org/static/v20/Jit/jit.js' }! !

!OrcaWidgetPlayground class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 15:52'!
startupClass 

	^ OrcaContainer! !

!OrcaWidgetPlayground class methodsFor: 'configuration' stamp: 'hk 1/24/2011 17:20'!
title

	^ 'Let''s play'! !

!OrcaWidgetPlayground class methodsFor: 'configuration' stamp: 'hk 2/1/2011 11:48'!
uniquePath

	^ 'play/'! !

OrcaWidgetApp subclass: #OrcaWorkspaceApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Workspace'!

!OrcaWorkspaceApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 15:52'!
requiredClasses
	
	^ { OrcaWorkspace . LimitedWriteStream . OrcaTabbyTextArea }! !

!OrcaWorkspaceApp class methodsFor: 'configuration' stamp: 'hk 4/5/2011 10:42'!
scripts

	^ { 'http://teddevito.com/demos/js/jquery.textarea.js' }! !

!OrcaWorkspaceApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 15:52'!
startupClass

	^ OrcaWorkspace! !

!OrcaWorkspaceApp class methodsFor: 'configuration' stamp: 'robi 1/26/2011 11:24'!
title
	^ 'Workspace'! !

!OrcaWorkspaceApp class methodsFor: 'configuration' stamp: 'hk 2/1/2011 12:02'!
uniquePath
	^ 'workspace/'! !

!OrcaBasicApp class methodsFor: 'rendering-javascript' stamp: 'ag 1/24/2011 17:00'!
collect: aBlock upTo: topSuperClass
	"Evaluate aBlock with all relevant superclasses as single argument and collect the resulting collections."
	
	| class result superClasses |
	result := OrderedCollection new.
	superClasses := topSuperClass allSuperclasses.
	class := self.
	[ superClasses includes: class ]
		whileFalse: [
			result addAllFirst: (aBlock value: class).
			class := class superclass ].
	^ result
		inject: OrderedCollection new
		into: [ :all :cl | (all includes: cl) ifFalse: [ all add: cl ]. all ]! !

!OrcaBasicApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 15:52'!
collectScripts
	"Collect #scripts from all superclasses"
	
	^ self
		collect: [ :eachClass | eachClass scripts ]
		upTo: OrcaBasicApp! !

!OrcaBasicApp class methodsFor: 'rendering-css' stamp: 'ag 4/6/2011 15:52'!
collectStyles
	"Collect #styles from all superclasses"
	
	^ (self
		collect: [ :eachClass | eachClass styles ]
		upTo: OrcaBasicApp)! !

!OrcaBasicApp class methodsFor: 'configuration' stamp: 'HK 1/10/2011 16:30'!
htmlDocumentType

	^ '<!!DOCTYPE html>'.! !

!OrcaBasicApp class methodsFor: 'singleton' stamp: 'HK 1/12/2011 10:43'!
instance
	
	instance ifNil: [ instance := self new ].
	^ instance.! !

!OrcaBasicApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/11/2011 19:45'!
scripts
	
	^ #( 'js/console.js' 'js/communication.js' 'js/server.js' )! !

!OrcaBasicApp class methodsFor: 'rendering-css' stamp: 'hk 1/26/2011 12:29'!
styles

	^ #()! !

!OrcaBasicApp class methodsFor: 'configuration' stamp: 'ag 1/24/2011 17:19'!
title
	"Must be implemented by non-abstract subclasses"
	
	^ nil! !

!OrcaBasicApp class methodsFor: 'configuration' stamp: 'ag 1/24/2011 17:20'!
uniquePath
	"Must be implemented by non-abstract subclasses"
	
	^ nil! !

!OrcaBasicApp methodsFor: 'dispatching' stamp: 'ag 1/25/2011 13:41'!
addClient: aClient

	self clients add: aClient.
	aClient application: self.! !

!OrcaBasicApp methodsFor: 'dispatching' stamp: 'ag 1/25/2011 13:41'!
answerNewContentTo: aClient

	aClient increaseRevision.
	^ self
		answerWithStatusCode: 200
		andContent: (self repository contentAtRevision: aClient revision)! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'SW 1/18/2011 11:26'!
answerNoContent

	^ self answerWithStatusCode: 204! !

!OrcaBasicApp methodsFor: 'dispatching' stamp: 'ag 4/6/2011 15:52'!
answerTo: aRequest
	
	| handlerClass |
	handlerClass := OrcaClientHandler subclasses
		detect: [ :eachClass | eachClass canHandle: aRequest ]
		ifNone: [ nil ].
	^ handlerClass
		ifNotNil: [ (handlerClass newFor: self) answerTo: aRequest ]
		ifNil: [ self answerContent: self render withType: 'text/html' ]! !

!OrcaBasicApp methodsFor: 'accessing' stamp: 'hk 3/28/2011 17:12'!
clients
	clients ifNil: [ clients := OrderedCollection new ].
	^ clients! !

!OrcaBasicApp methodsFor: 'accessing' stamp: 'HK 1/12/2011 10:49'!
clients: anObject
	clients := anObject! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
fullUrlFor: aUrl
	^ (aUrl startsWith: 'http')
		ifTrue: [ aUrl ]
		ifFalse: [ OrcaFileRequestHandler pathSuffix , '/' , aUrl ]! !

!OrcaBasicApp methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initialize

	super initialize.
	self
		clients: OrderedCollection new;
		repository: OrcaContentRepository new.! !

!OrcaBasicApp methodsFor: 'hooks' stamp: 'ag 4/11/2011 19:52'!
onloadCode
	
	^ 'st.communication.connect();'! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'HK 1/12/2011 15:13'!
removeAllClients

	self clients
		select: [ :each | each isWebSocketClient ]
		thenDo: [ :each | each close ].
	self clients: OrderedCollection new.! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 11:47'!
removeClient: aClient
	
	self clients remove: aClient ifAbsent: [ ].! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'ag 1/13/2011 20:18'!
render
	
	^ self class htmlDocumentType,
		'<html>',
			self renderHeader, 
			self cr, 
			self renderBody,
		'</html>'! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'ag 1/24/2011 16:45'!
renderBody

	^'<body onload="', self onloadCode, '" onunload="">',
		self renderContent,
	   '</body>'.! !

!OrcaBasicApp methodsFor: 'hooks' stamp: 'ag 1/24/2011 14:31'!
renderContent 
	"Subclasses return custom html-content"
	
	^ ''! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'hk 1/26/2011 12:20'!
renderHeader

	^ '<head>',
		self renderTitle,
		self renderJavascript,
		self renderStyles,
	'</head>'.! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'srv 1/24/2011 14:08'!
renderJavascript
	"Render the external javascript resources."
	
	^ self renderScriptTags: self class collectScripts! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'ag 4/11/2011 19:40'!
renderScriptTag: aFilename
	
	^ '<script type="text/javascript" src="', aFilename, '"></script>', String cr! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'ag 4/11/2011 19:45'!
renderScriptTags: aCollectionOfFilenames
	"aCollectionOfFilenames does not contain absolute Urls, but only the filenames of the js-files. The path (url) will be prepended."
	
	^ self
		renderTags: aCollectionOfFilenames
		collectingFrom: [ :url | self renderScriptTag: url]! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'hk 1/26/2011 12:27'!
renderStyleTag: aFilename
	
	^ '<link href="', aFilename, '" rel="stylesheet" type="text/css" />', String cr! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 15:07'!
renderStyles
	"Render the external javascript resources."
	
	^ self
		renderTags: self class collectStyles
		collectingFrom: [ :url | self renderStyleTag: url]! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 14:55'!
renderTags: aCollectionOfFilenames collectingFrom: aBlock
	"aCollectionOfFilenames does not contain absolute Urls, but only the filenames. The path (url) will be prepended."
	
	^ aCollectionOfFilenames
		inject: ''
		into: [ :string :eachUrl | 
			string, (aBlock value: (self fullUrlFor: eachUrl)) ]! !

!OrcaBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 09:57'!
renderTitle
	
	^'<title>',
	 self class title,
	'</title>',
	String cr! !

!OrcaBasicApp methodsFor: 'accessing' stamp: 'HK 1/12/2011 10:49'!
repository
	^ repository! !

!OrcaBasicApp methodsFor: 'accessing' stamp: 'HK 1/12/2011 10:49'!
repository: anObject
	repository := anObject! !

!OrcaBasicApp methodsFor: 'hooks' stamp: 'ag 4/6/2011 15:52'!
reset 
	
	self
		clients: OrderedCollection new;
		repository: OrcaContentRepository new.! !

!OrcaBasicApp methodsFor: 'sending content' stamp: 'ag 2/3/2011 12:21'!
sendCode: code
	
	| jsCode |
	jsCode := self translateSqueakCode: code.
	self updateRepositoryWith: jsCode.
	self sendCodeToWebSocketClients: jsCode.! !

!OrcaBasicApp methodsFor: 'sending content' stamp: 'SW 1/31/2011 09:25'!
sendCodeToWebSocketClients:jsCode

	self webSocketClients do: [ :each | each receive: jsCode ]
! !

!OrcaBasicApp methodsFor: 'sending content' stamp: 'ag 4/6/2011 15:52'!
translateSqueakCode: code

	| jsCode |
	[ jsCode := OrcaPrinter convertDoIt: code ]
		on: Exception
		do: [ :err | jsCode := 'alert("Could not parse squeak-code: ', Character cr asString, code,
			Character cr asString, 'Error was: ', err asString, '");' ].
	^ jsCode! !

!OrcaBasicApp methodsFor: 'sending content' stamp: 'ag 1/26/2011 11:47'!
updateRepositoryWith: someContent
	
	self repository addContent: someContent.! !

!OrcaBasicApp methodsFor: 'sending content' stamp: 'ag 4/6/2011 15:52'!
updateRepositoryWithSqueakCode: code

	| jsCode |
	[ jsCode := OrcaPrinter convertDoIt: code ]
		on: Exception
		do: [ :err | jsCode := 'alert("Could not parse squeak-code: ', Character cr asString, code,
			Character cr asString, 'Error was: ', err asString, '");' ].
	self updateRepositoryWith: jsCode.! !

!OrcaBasicApp methodsFor: 'dispatching' stamp: 'ag 1/25/2011 14:04'!
webSocketClients
	
	^ self clients select: [ :each | each isWebSocketClient ]! !

OrcaBasicApp subclass: #OrcaEmptyTestApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

!OrcaEmptyTestApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/6/2011 18:03'!
codeForAllClasses
	"This interface is implemented by OrcaApp. We 'steal' the implementation from OrcaApp, but we don't want to inherit from it!!"
	
	^ OrcaApp codeForAllClasses! !

!OrcaEmptyTestApp class methodsFor: 'rendering-javascript' stamp: 'hk 3/29/2011 12:18'!
scripts
	
	^ #( 'squeaky.js' 'test/tests.js' )! !

!OrcaEmptyTestApp class methodsFor: 'rendering-css' stamp: 'lw 2/22/2011 14:01'!
styles
	
	^ #( 'styles/test.css' )! !

!OrcaEmptyTestApp class methodsFor: 'configuration' stamp: 'LT 2/21/2011 15:35:15.929'!
title

	^ 'Tests stub'! !

!OrcaEmptyTestApp class methodsFor: 'configuration' stamp: 'ag 2/3/2011 12:47'!
uniquePath

	^ 'emptyTest/'! !

OrcaEmptyTestApp subclass: #OrcaTestApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

!OrcaTestApp class methodsFor: 'configuration' stamp: 'LT 2/21/2011 15:35:40.754'!
title

	^ 'JavaScript Tests'! !

!OrcaTestApp class methodsFor: 'configuration' stamp: 'ag 2/3/2011 12:47'!
uniquePath

	^ 'test/'! !

!OrcaTestApp methodsFor: 'hooks' stamp: 'ag 4/6/2011 17:57'!
onloadCode
	
	^ super onloadCode, 'OrcaTests.runTests();'! !

OrcaResource subclass: #OrcaClientHandler
	instanceVariableNames: 'application'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

OrcaClientHandler subclass: #OrcaClassesHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaClassesHandler class methodsFor: 'request handling' stamp: 'ag 1/26/2011 09:13'!
pathSuffix
	
	^ 'classes'! !

!OrcaClassesHandler methodsFor: 'request handling' stamp: 'ag 1/26/2011 09:19'!
answerTo: aRequest
	
	^ self answerCode: self application class codeForAllClasses! !

!OrcaClientHandler class methodsFor: 'request handling' stamp: 'ag 1/25/2011 16:29'!
canHandle: aRequest
	
	| segments |
	segments := self pathSegments: aRequest.
	^ segments size >= 2 and: [ segments second = self pathSuffix ]! !

!OrcaClientHandler class methodsFor: 'instance creation' stamp: 'HK 1/11/2011 16:33'!
newFor: anApplication

	^ self new application: anApplication.! !

!OrcaClientHandler class methodsFor: 'request handling' stamp: 'ag 1/25/2011 14:31'!
pathSegments: aRequest
	
	^ (aRequest requestLine requestURI identifier) findTokens: '/'! !

!OrcaClientHandler class methodsFor: 'request handling' stamp: 'ag 1/25/2011 14:07'!
pathSuffix
	
	self subclassResponsibility! !

!OrcaClientHandler methodsFor: 'request handling' stamp: 'ag 1/25/2011 14:08'!
answerTo: aRequest
	
	self subclassResponsibility! !

!OrcaClientHandler methodsFor: 'accessing' stamp: 'HK 1/11/2011 16:33'!
application
	^ application! !

!OrcaClientHandler methodsFor: 'accessing' stamp: 'HK 1/11/2011 16:33'!
application: anObject
	application := anObject! !

OrcaClientHandler subclass: #OrcaCometHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaCometHandler class methodsFor: 'configuration' stamp: 'HK 12/15/2010 15:39'!
identifierRange

	^ 10e10.! !

!OrcaCometHandler class methodsFor: 'configuration' stamp: 'ag 1/25/2011 15:17'!
pathSuffix
	
	^ 'xhr'! !

!OrcaCometHandler methodsFor: 'responding' stamp: 'HK 1/3/2011 20:30'!
answerNewIdentifier: anIdentifier

	^ self
		answerWithStatusCode: 202
		andContent: anIdentifier.! !

!OrcaCometHandler methodsFor: 'request handling' stamp: 'ag 1/25/2011 13:45'!
answerTo: aRequest
	
	| client |
	client := self findClient: aRequest.
	^ client
		ifNil: [ self registerNewClient ]
		ifNotNil: [ 
			aRequest isGet ifTrue: [ client update ] ifFalse: [
			aRequest isPost ifTrue: [ client sent: aRequest ] ]]! !

!OrcaCometHandler methodsFor: 'identification' stamp: 'SW 1/19/2011 10:12'!
extractIdentifierFrom: aRequest

	(self includesIdentifier: aRequest) ifFalse: [ ^ nil ].
	^ (aRequest requestLine requestURI asString subStrings: '=') at: 2.! !

!OrcaCometHandler methodsFor: 'request handling' stamp: 'HK 1/12/2011 15:32'!
findClient: aRequest

	| identifier |
	identifier := self extractIdentifierFrom: aRequest.
	identifier ifNil: [ ^ nil ].
	^ self findClientById: identifier.! !

!OrcaCometHandler methodsFor: 'identification' stamp: 'HK 1/12/2011 10:54'!
findClientById: anIdentifier

	^ self application clients
		detect: [ :uniqueClient |
			uniqueClient isCometClient and:
				[ uniqueClient identifier = anIdentifier ]]
		ifNone: [ nil ].! !

!OrcaCometHandler methodsFor: 'identification' stamp: 'HK 1/3/2011 12:14'!
generateIdentifier

	| randomId |
	[ randomId := self class identifierRange atRandom ] doWhileFalse:
		[ self isIdentifierAvailable: randomId ].
	
	^ randomId asString.! !

!OrcaCometHandler methodsFor: 'identification' stamp: 'HK 1/3/2011 13:29'!
includesIdentifier: aRequest

	^ aRequest requestLine requestURI asString includesSubString: '?id='.! !

!OrcaCometHandler methodsFor: 'identification' stamp: 'hk 3/28/2011 17:14'!
isIdentifierAvailable: anIdentifier

	| allocatedIdentifiers |
	allocatedIdentifiers := self application clients
		select: [ :each | each isCometClient ]
		thenCollect: [ :each | each identifier ].
		
	 ^ (allocatedIdentifiers includes: anIdentifier) not.! !

!OrcaCometHandler methodsFor: 'convenience' stamp: 'ag 4/6/2011 15:52'!
registerNewClient

	| identifier client |
	
	identifier := self generateIdentifier.
	client := (OrcaCometClient new identifier: identifier).
	client revision: self application repository revision.
	self application addClient: client.
	^ self answerNewIdentifier: identifier.! !

OrcaClientHandler subclass: #OrcaFileRequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaFileRequestHandler class methodsFor: 'configuration' stamp: 'ag 1/25/2011 15:17'!
pathSuffix
	
	^ 'file'! !

!OrcaFileRequestHandler class methodsFor: 'configuration' stamp: 'ag 4/6/2011 18:01'!
rootDirectory: aDirectoryName
	"Configure the root-directory, this mini-server is serving. Only required once."
	
	| dir |
	dir := FileDirectory on: aDirectoryName.
	dir exists ifFalse: [ self error: 'Directory does not exist: ', aDirectoryName ].
	^ Smalltalk
		at: #OrcaFileRootDirectory
		put: dir! !

!OrcaFileRequestHandler methodsFor: 'request handling' stamp: 'hk 3/29/2011 11:23'!
answerTo: aRequest
	
	| file |
	file := self extractFile: aRequest.
	^ file
		ifNotNil: [
			file binary.
			"images require binary mode. plain text works regardless of encoding"
			self application
				answerCode: file contents
				withType: (self mimeTypeOf: file) ]
		ifNil: [
			self application
				answerWithStatusCode: 404
				andContent: 'Requested file not found' ]! !

!OrcaFileRequestHandler methodsFor: 'request handling' stamp: 'ag 4/6/2011 18:01'!
extractFile: aRequest
	
	| segments fileRoot |
	segments := self class pathSegments: aRequest.
	segments removeFirst. "The app-name"
	segments removeFirst. "The /file -suffix"
	fileRoot := Smalltalk
		at: #OrcaFileRootDirectory
		ifAbsent: [ 
			| possiblePathName possibleDirectory |

			possiblePathName := FileDirectory default pathName, 
								FileDirectory pathNameDelimiter asString, 'orca'.
			
			possibleDirectory := FileDirectory on: possiblePathName.
			
			possibleDirectory exists 
				ifTrue: [ possibleDirectory ]
				ifFalse: [
					self error: 
'The root-directory name has not been configurd!! 
Execute: OrcaFileRequestHandler rootDirectory: "/absolute/path/to/root/"
or: OrcaInstaller setupFileDirectory'.
				].
			 ].
	^ fileRoot oldFileOrNoneNamed: (segments separatedBy: FileDirectory pathNameDelimiter asString)! !

!OrcaFileRequestHandler methodsFor: 'request handling' stamp: 'hk 3/29/2011 11:21'!
mimeTypeOf: aFile

	^ MIMEDocument guessTypeFromName: aFile name! !

OrcaClientHandler subclass: #OrcaMethodInvocationHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaMethodInvocationHandler class methodsFor: 'configuration' stamp: 'ag 1/25/2011 15:17'!
pathSuffix 
	
	^ 'mi'! !

!OrcaMethodInvocationHandler methodsFor: 'request handling' stamp: 'ag 3/1/2011 17:28'!
answerTo: aRequest

	| code arguments result |
	aRequest ensureFullRead.
	code := (aRequest postDataAt: 'code') value.
	arguments := self retrieveArgumentsFrom: aRequest.
	result := (Compiler evaluate: code) valueWithArguments: arguments asArray.
	^ self application answerContent: result serializeToJavaScript withType: 'text/javascript'! !

!OrcaMethodInvocationHandler methodsFor: 'request handling' stamp: 'LT 2/21/2011 14:47:33.929'!
retrieveArgumentsFrom: aRequest

	| arguments currentArg |
	arguments := OrderedCollection new.
	currentArg := 0.
	[ currentArg isNil ]
		whileFalse: [ 
			| key arg |
			key := 'arg' , currentArg asString.
			arg := (aRequest postDataAt: key) value.
			arg
				ifNil: [ currentArg := nil ]
				ifNotNil: [ 
					arguments add: arg.
					currentArg := currentArg + 1 ] ].
	^ arguments! !

OrcaClientHandler subclass: #OrcaRemoteObjectsHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaRemoteObjectsHandler class methodsFor: 'request handling' stamp: 'lw 4/5/2011 11:55'!
pathSuffix

	^ 'object'! !

!OrcaRemoteObjectsHandler methodsFor: 'request handling' stamp: 'lw 4/5/2011 12:01'!
answerTo: aRequest

	self halt.
! !

OrcaClientHandler subclass: #OrcaWebSocketHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaWebSocketHandler class methodsFor: 'request handling' stamp: 'ag 1/25/2011 16:29'!
canHandle: aRequest
	"This class has an own implementation of this. That's why the abstract method pathSuffix is not implemented."
	
	^ aRequest isWebSocketRequest! !

!OrcaWebSocketHandler class methodsFor: 'configuration' stamp: 'HK 1/4/2011 12:17'!
millisecondsToWaitForHandshake

	^ 200.! !

!OrcaWebSocketHandler class methodsFor: 'client handling' stamp: 'hk 4/5/2011 11:15'!
pathSuffix
	
	^ 'ws'! !

!OrcaWebSocketHandler class methodsFor: 'client handling' stamp: 'SW 1/19/2011 09:45'!
updateAllClients

	self application webSocketClients do: [ :each |
		each update ].! !

!OrcaWebSocketHandler class methodsFor: 'client handling' stamp: 'SW 1/19/2011 09:45'!
updateAllClientsExcept: aClient
	
	aClient increaseRevision.
	self application webSocketClients
		reject: [ :uniqueClient | uniqueClient = aClient ]
		thenDo: [ :each | each update ].! !

!OrcaWebSocketHandler methodsFor: 'request handling' stamp: 'SW 1/17/2011 12:23'!
answerTo: aRequest

	| webSocket |
	webSocket := aRequest webSocket.
		
	(self isNew: webSocket ) ifTrue: 
		[ self setupClientWith: webSocket ].
	^ webSocket answerTo: aRequest.! !

!OrcaWebSocketHandler methodsFor: 'convenience' stamp: 'HK 1/12/2011 16:25'!
isNew: aWebSocket

	| registeredSockets |
	registeredSockets := self application webSocketClients collect:
		[ :each | each socket ].
	
	^ (registeredSockets includes: aWebSocket) not.! !

!OrcaWebSocketHandler methodsFor: 'convenience' stamp: 'ag 4/6/2011 15:52'!
setupClientWith: aWebSocket

	| client |
	client := (OrcaWebSocketClient newWithSocket: aWebSocket).
	self application addClient: client.
	"self updateDelayed: client."! !

!OrcaWebSocketHandler methodsFor: 'convenience' stamp: 'SW 1/18/2011 10:54'!
updateDelayed: aClient

	[ (Delay forMilliseconds: self class millisecondsToWaitForHandshake) wait. 
	aClient update] fork.! !

OrcaResource subclass: #OrcaDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OrcaDispatcher class methodsFor: 'setup' stamp: 'ag 1/25/2011 13:57'!
defaultPort

	^ 8887! !

!OrcaDispatcher class methodsFor: 'setup' stamp: 'lw 2/25/2011 14:07'!
forcedRestart
	"Why is this even necessary?" "Brought to you by UGLYFIX!! :-)"
	
	Transcript show: 'Server restart.';cr.
	SwazooServer initSingleton.
	SwazooServer allInstancesDo: [ :swa | 
		swa stop; initSites].
	HTTPServer allInstancesDo: [ :http |
		http stop; initialize].
	HTTPConnection allInstancesDo: [ :conn |
		conn close].
	SwazooServer singleton start.
	Smalltalk garbageCollect.
	self start.! !

!OrcaDispatcher class methodsFor: 'setup' stamp: 'ag 1/13/2011 20:12'!
install
	
	^ self installOn: self defaultPort! !

!OrcaDispatcher class methodsFor: 'setup' stamp: 'ag 1/25/2011 14:16'!
installOn: aPort
	
	^ (SwazooSite
		newNamed: self name)
		host: '*'
		ip: '*'
		port: aPort;
		addResource: (self uriPattern: '/');
		yourself! !

!OrcaDispatcher class methodsFor: 'setup' stamp: 'ag 1/13/2011 20:12'!
isInstalled
	
	^ self site notNil! !

!OrcaDispatcher class methodsFor: 'setup' stamp: 'ag 1/25/2011 14:16'!
site
	
	^ SwazooServer singleton siteNamed: self name! !

!OrcaDispatcher class methodsFor: 'setup' stamp: 'ag 1/13/2011 20:12'!
start
	
	self isInstalled ifFalse: [ self install ].
	self site start.! !

!OrcaDispatcher class methodsFor: 'setup' stamp: 'ag 1/13/2011 20:13'!
uninstall
	
	self isInstalled ifTrue: [
		self removeAllClients.
		self resetContent.
		SwazooServer singleton removeSite: self site ].! !

!OrcaDispatcher methodsFor: 'dispatching' stamp: 'ag 4/6/2011 15:52'!
answerTo: aRequest 
	
	| application |
	(self hasToBeForwarded: aRequest ) 
		ifTrue: [ ^ self forward: aRequest ].		
	application := self findApplicationNamed: (self identifierOf: aRequest).
	application
		ifNil: [  ^ self redirectTo: '/', OrcaIndex uniquePath ]
		ifNotNil: [ ^ application instance answerTo: aRequest ].! !

!OrcaDispatcher methodsFor: 'dispatching' stamp: 'ag 4/6/2011 15:52'!
findApplicationNamed: aName

	aName ifNil: [ ^ nil ].
	^ OrcaBasicApp allSubclasses
		detect: [ :each | each uniquePath = aName ]
		ifNone: [ nil ]. ! !

!OrcaDispatcher methodsFor: 'dispatching' stamp: 'hk 2/1/2011 12:27'!
forward: aRequest

	| url |
	url:= self identifierOf: aRequest.
	^ self redirectTo: '/', url! !

!OrcaDispatcher methodsFor: 'dispatching' stamp: 'hk 2/1/2011 12:19'!
hasToBeForwarded: aRequest
	
	| url |
	url := aRequest requestLine requestURI identifier.
	^ ( url findTokens: '/') size = 1 and: [ (url endsWith: '/') not ]
	
	
! !

!OrcaDispatcher methodsFor: 'dispatching' stamp: 'hk 2/1/2011 11:54'!
identifierOf: aRequest
	
	((aRequest requestLine requestURI identifier) findTokens: '/') size = 0 
		ifTrue: [ ^ nil  ]
		ifFalse: [ ^ ((aRequest requestLine requestURI identifier) findTokens: '/') first, '/' ].
	
	
! !

!OrcaDispatcher methodsFor: 'dispatching' stamp: 'HK 1/4/2011 15:45'!
redirectTo: aPath

	^HTTPResponse new
		statusCode: 302;
		entity: '';
		location: aPath;
		yourself.! !

!OrcaResource methodsFor: 'responding' stamp: 'hk 1/26/2011 10:51'!
answerCode: code
	
	^ self
		answerCode: code
		withType: 'text/javascript'! !

!OrcaResource methodsFor: 'responding' stamp: 'hk 1/26/2011 10:27'!
answerCode: code withType: aString
	
	^ self
		answerContent: code
		withType: aString! !

!OrcaResource methodsFor: 'responding' stamp: 'HK 12/17/2010 13:57'!
answerContent: data withType: aString

	| response |
	response := HTTPResponse ok.
	^ response
		contentType: aString;
		entity: data;
		yourself.! !

!OrcaResource methodsFor: 'responding' stamp: 'HK 12/15/2010 17:15'!
answerCreated

	^ self answerWithStatusCode: 201.! !

!OrcaResource methodsFor: 'responding' stamp: 'HK 1/10/2011 13:53'!
answerNotModified

	^ self answerWithStatusCode: 304.! !

!OrcaResource methodsFor: 'responding' stamp: 'HK 12/15/2010 17:16'!
answerWithStatusCode: aNumber

	^ self answerWithStatusCode: aNumber andContent: ''.! !

!OrcaResource methodsFor: 'responding' stamp: 'HK 12/15/2010 15:47'!
answerWithStatusCode: aNumber andContent: content

	^ HTTPResponse ok
		statusCode: aNumber;
		entity: content.! !

!OrcaResource methodsFor: 'printing-helpers' stamp: 'ag 1/13/2011 20:19'!
cr

	^ String cr! !

!Collection methodsFor: '*Orca' stamp: 'ag 1/25/2011 16:03'!
separatedBy: aString
	
	| stream |
	stream := TextStream on: ''.
	self asStringOn: stream delimiter: aString.
	^ stream contents! !

TextStream subclass: #OrcaTextStream
	instanceVariableNames: 'printer privateTextStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaTextStream class methodsFor: 'instance creation' stamp: 'ag 4/6/2011 18:04'!
for: anOrcaAbstractPrinter
	
	^ (self
		on: '')
		printer: anOrcaAbstractPrinter;
		yourself! !

!OrcaTextStream methodsFor: 'initialization' stamp: 'ag 1/9/2011 20:08'!
initialize
	
	super initialize.
	self privateTextStream: (TextStream on: '').! !

!OrcaTextStream methodsFor: 'printing' stamp: 'ag 1/10/2011 10:14'!
printBlock: aConditionBlock prependedBy: prependBlock
	"aConditionBlock is evaluated with a 'mock'-stream. if true is returned, prependBlock is evaluated and aConditionBlock is evaluated with the actual self."
	
	(aConditionBlock value: self privateTextStream)
		ifTrue: [
			prependBlock value.
			aConditionBlock value: self].! !

!OrcaTextStream methodsFor: 'accessing' stamp: 'ag 1/9/2011 17:38'!
printer
	
	^ printer! !

!OrcaTextStream methodsFor: 'accessing' stamp: 'ag 4/6/2011 18:10'!
printer: anOrcaAbstractPrinterClass
	
	printer := anOrcaAbstractPrinterClass! !

!OrcaTextStream methodsFor: 'accessing' stamp: 'ag 1/9/2011 20:08'!
privateTextStream
	
	^ privateTextStream! !

!OrcaTextStream methodsFor: 'accessing' stamp: 'ag 1/9/2011 20:08'!
privateTextStream: aStream
	
	privateTextStream := aStream! !

TestCase subclass: #OrcaTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OrcaTestCase subclass: #OrcaAbstractTest
	instanceVariableNames: 'currentRule nilResultAllowed checkResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OrcaAbstractTest subclass: #OrcaAbstractPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaAbstractPrinterTest methodsFor: 'test general' stamp: 'srv 1/10/2011 15:02'!
testExampleMethods
	
	super testExampleMethods.
	
	self class isOnCIServer ifTrue: [
		{ Object. Number. ProtoObject. OrderedCollection }
			do: [ :class | self class converterClass convertClass: class ]].! !

OrcaAbstractPrinterTest subclass: #OrcaPrettyPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaPrettyPrinterTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaPrettyPrinter! !

!OrcaPrettyPrinterTest class methodsFor: 'testing' stamp: 'lw 1/4/2011 11:23'!
defaultCurrentRule
	
	^ #doItSnippet! !

!OrcaPrettyPrinterTest methodsFor: 'test printing' stamp: 'ag 4/11/2011 16:27'!
testCascades

	self 
		assertMatches: 'a b; c' andProduces:  
'            (function () {
                var cascadeReceiver$ = a;
                cascadeReceiver$.b();
                return cascadeReceiver$.c();
            }).apply(this)';

		assertMatches: 'a slot: b; slot: c' andProduces: 
 '            (function () {
                var cascadeReceiver$ = a;
                cascadeReceiver$.slot_(b);
                return cascadeReceiver$.slot_(c);
            }).apply(this)';

		assertMatches: 'a slot: b be: d; slot: c be: d' andProduces: 
 '            (function () {
                var cascadeReceiver$ = a;
                cascadeReceiver$.slot_be_(b, d);
                return cascadeReceiver$.slot_be_(c, d);
            }).apply(this)';

		assertMatches: '^ Object new slot: injection be: ''infovis''; yourself' andProduces: 
 '            return (function () {
                var cascadeReceiver$ = st.Object._new();
                cascadeReceiver$.slot_be_(injection, st.string("infovis"));
                return cascadeReceiver$.yourself();
            }).apply(this)'.! !

!OrcaPrettyPrinterTest methodsFor: 'test nodetypes' stamp: 'ag 4/6/2011 15:52'!
testFunctionCall

	self 
		assertMatches: (OrcaNode functionCall: 
			{OrcaNode identifier: 'b'. 
			#js.
			OrcaNode arguments }) 
		andProduces: 'b.js()';
		
		assertMatches: (OrcaNode functionCall: 
			{OrcaNode identifier: 'b'. 
			#call.
			OrcaNode arguments: { OrcaNode identifier: #b }}) 
		andProduces: 'b.call(b)'.
		! !

!OrcaPrettyPrinterTest methodsFor: 'test printing' stamp: 'ag 4/11/2011 16:27'!
testIndention

	self
		assertMatches: '[:e | Js Global alert value: e. [ :f | f + 1 ]. [ :f | f := f + 2. ^ [Js Global alert value: f ] ]]'
		andProduces:  
'            st.block(function (e) {
                st.Js.Global().alert().value_(e);
                st.block(function (f) {
                    return f._plus(st.number(1));
                });
                return st.block(function (f) {
                    f = f._plus(st.number(2));
                    return st.nonLocalReturn(st.block(function () {
                        return st.Js.Global().alert().value_(f);
                    }));
                });
            })'! !

!OrcaPrettyPrinterTest methodsFor: 'test nodetypes' stamp: 'ag 4/6/2011 15:52'!
testSlotAccess

	self 
		assertMatches: (OrcaNode slotAccess: {OrcaNode identifier: 'a'. #b}) 
		andProduces: 'a.b'.
		
	self
		assertMatches: (OrcaNode slotAccess: {OrcaNode identifier: #'$a'. #'hello_world'})
		andProduces: '$a.hello_world'.! !

!OrcaPrettyPrinterTest methodsFor: 'test nodetypes' stamp: 'ag 4/6/2011 15:52'!
testSlotAssignment

	self 
		assertMatches: (OrcaNode expression: 
			{OrcaNode identifier: 'b'.
			OrcaNode slotAccess: 
				{OrcaNode identifier: 'a'. #slot}. 
			}) 
		andProduces: '        a.slot = b'.
		! !

OrcaAbstractPrinterTest subclass: #OrcaPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaPrinterTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaPrinter! !

!OrcaPrinterTest class methodsFor: 'testing' stamp: 'ag 12/22/2010 13:52'!
defaultCurrentRule
	
	^ #doItSnippet! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'lw 2/19/2011 02:30'!
testCascadedExpression
	
	self
		currentRule: #cascadedExpression;
		
		assertMatches: 'a b; c'
		andProduces: '(function(){var cascadeReceiver$=a;cascadeReceiver$.b();return cascadeReceiver$.c();}).apply(this)';
		
		assertMatches: 'a b: (a b; d); c'
		andProduces: '(function(){var cascadeReceiver$=a;cascadeReceiver$.b_((function(){var cascadeReceiver$=a;cascadeReceiver$.b();return cascadeReceiver$.d();}).apply(this));return cascadeReceiver$.c();}).apply(this)'! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'sec 4/6/2011 20:08'!
testEscapingIdentifiers
	
	self
		currentRule: #doItSnippet;
		
		assertMatches: 'Object new'
		andProduces: 'st.Object._new()';
		
		assertMatches: 'a := true'
		andProduces: 'a=st.true'.
	
	self class isOnCIServer ifTrue: [
		self assert: ((OrcaCodeFactory new codeForClass: Object) beginsWith: 'Class("_Object",').
		self assert: ((OrcaCodeFactory new codeForClass: Point) beginsWith: 'Class("Point",{superclass:_Object')].! !

!OrcaPrinterTest methodsFor: 'test general' stamp: 'srv 1/10/2011 15:02'!
testExampleMethods
	
	super testExampleMethods.! !

!OrcaPrinterTest methodsFor: 'test general' stamp: 'ag 4/6/2011 15:52'!
testJsStringPrinting
	
	self
		assert: [ '"\\\"''"' = (OrcaAbstractPrinter asJSString: '\"''')];
		assert: [ '"abc def ()/&%"' = (OrcaAbstractPrinter asJSString: 'abc def ()/&%')];
		assert: [ '"\r"' = (OrcaAbstractPrinter asJSString: String cr)].! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 4/6/2011 15:52'!
testObjectLiteral

	self 
		assertMatches: (OrcaNode objectLiteral: {})
		andProduces: '{}';

		assertMatches: (
			OrcaNode objectLiteral: {
                    	OrcaNode slotAssignment: 
					{#a. 
					OrcaNode identifier: 'b'}.
                    	OrcaNode slotAssignment:
                       	 	{#b.
                        	OrcaNode functionCall: 
						{OrcaNode functionCall: 
							{OrcaNode identifier: 'a'. 
							#b. 
							OrcaNode arguments}.
						#js.
						OrcaNode arguments}}})
		andProduces: '{a:b,b:a.b().js()}'! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 1/19/2011 19:53'!
testPerformOnServer
	
	self
		assertMatches: '[1] onServer'
		andProduces: 'serverBlock("[1]")';
		
		assertMatches: '[:a|1] onServer'
		andProduces: 'serverBlock("[:a|1]")';
		
		assertMatches: '[ [ 1 ] onServer ] onServer'
		andProduces: 'serverBlock("[ [ 1 ] onServer ]")'.! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 4/11/2011 16:25'!
testPrinting
	
	self
		assert: '1 +/ 2' matches: #binaryExpression andProduces: 'st.number(1)._plus_slash(st.number(2))';
		assert: '{ 1. a b: c. ''s'' }' matches: #braceExpression andProduces: 'st.array([st.number(1), a.b_(c), st.string("s")])';
		assert: 'a :=   12 a: 12' matches: #expression andProduces: 'a=st.number(12).a_(st.number(12))';
		assert: '1 a: 2 b: 3' matches: #keywordExpression andProduces: 'st.number(1).a_b_(st.number(2), st.number(3))';
		assert: '1 a:a b:B. 2 s.' matches: #doItSnippet andProduces: 'st.number(1).a_b_(a, st.B);st.number(2).s()';
		assert: '| a b v |' matches: #temporaries andProduces: 'var a;var b;var v';
		assert: '1 bcd' matches: #unaryExpression andProduces: 'st.number(1).bcd()';
		assert: '(1 2 3 ''d  '')' matches: #array andProduces: 'st.array([st.number(1), st.number(2), st.number(3), st.string("d  ")])';
		assert: '#[ 1 2 3 255]' matches: #byteArray andProduces: 'st.array([st.number(1), st.number(2), st.number(3), st.number(255)])';
		assert: '12.3' matches: #number andProduces: 'st.number(12.3)';
		assert: 'self' matches: #reservedWord andProduces: 'this';
		assert: '#a12' matches: #symbol andProduces: 'st.string("a12")'.! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 4/11/2011 16:24'!
testSuper
	
	self
		assertMatches: 'super a'
		andProduces: 'st.super("a")()';
		
		assertMatches: 'super a: 1 b: d'
		andProduces: 'st.super("a_b_")(st.number(1), d)';
		
		assertMatches: 'a := super'
		andProduces: 'a=this';
		
		assertMatches: '^super'
		andProduces: 'return this'.! !

!OrcaAbstractTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:15'!
converterClass
	
	self subclassResponsibility! !

!OrcaAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultCheckResults
	
	^ true! !

!OrcaAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:24'!
defaultCurrentRule
	
	^ nil! !

!OrcaAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultNilResultsAllowed
	
	^ false! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'lw 2/22/2011 16:58'!
assert: anObject matches: aRule
	"In most cases, throws an error when failing (hard fail)"
	
	| result |
	result := anObject isString 
		ifTrue: [ self class converterClass convert: anObject as: aRule. ] 
		ifFalse: [ self class converterClass convertAst: anObject ].
	
	self nilResultAllowed ifFalse: [ self assert: result notNil ].
	^ result! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'sec 3/23/2011 14:24'!
assert: anObject matches: aRule andProduces: anObjectTree
	"In most cases, throws an error when failing (hard fail). #= Checks collections deeply."
	
	| result |
	result := self assert: anObject matches: aRule.
	result isString ifTrue: [ result := result withSqueakLineEndings ].
	self checkResults ifTrue: [ self assert: result = anObjectTree ].
	^ result! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 4/6/2011 18:03'!
assert: aString matches: aRule andProducesNode: aCollection
	"Matches the string to the rule and compares the result to an OrcaNode containing the given collection and named like the rule.
	(Follows a convention)."
	
	| result |
	result := self assert: aString matches: aRule.
	self checkResults ifTrue: [ self assert: result = (OrcaNode named: aRule asString with: aCollection) ].
	^ result! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:57'!
assertConverting: anInputString containsNodeNamed: aNodeName
	
	^ self assert: 
		(( self assertMatches: anInputString )
			includesChildNamed: aNodeName).! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString
	"Checks against the currentRule"
	
	self
		assertFails: aString
		toMatch: self currentRule.! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString toMatch: aRule
	
	self
		should: [ self assert: aString matches: aRule ]
		raise: OM2Fail
		description: 'Matching should have failed but didn''t!!'.! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:57'!
assertMatches: aString
	"Check against the currentRule"
	
	^ self assert: aString matches: self currentRule! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProduces: anObject
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProduces: anObject! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProducesNode: aCollection
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProducesNode: aCollection! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults
	^ checkResults! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults: aBoolean
	checkResults := aBoolean! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule
	^ currentRule! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule: aSymbol
	currentRule := aSymbol! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:56'!
denyConverting: anInputString containsNodeNamed: aNodeName
	
	self deny: 
		(( self assertMatches: anInputString )
			includesChildNamed: aNodeName).! !

!OrcaAbstractTest methodsFor: 'test general' stamp: 'ag 3/28/2011 17:53'!
exampleMethod1
	
	"Comment"
	self class.
	^ [ Js Global alter: 'example'].! !

!OrcaAbstractTest methodsFor: 'test general' stamp: 'ag 3/28/2011 17:54'!
exampleMethod2
	
	| |
	< primitiveDecl: 1 >
	"Comment"
	self class.
	self
		a: 1;
		b: 2;
		c.
	^ [ Js Global alert: 'example'].! !

!OrcaAbstractTest methodsFor: 'test general' stamp: 'ag 3/28/2011 17:53'!
""exampleMethod3""
	""
	""<"" primitiveDecl: ""1 "">""
	""
	""| ""temporariesAfterPrimitiveDecl"" |""
	"Comment"
	""self"" class"".""
	self""
		""a:"" 1"";""
		""b: ""2"";""
		""c"".""
	""^"" [""Js Global ""alter:"" 'example'""]"".""! !

!OrcaAbstractTest methodsFor: 'initialization' stamp: 'ag 12/13/2010 09:24'!
initialize
	
	super initialize.
	self
		nilResultAllowed: self class defaultNilResultsAllowed;
		checkResults: self class defaultCheckResults;
		currentRule: self class defaultCurrentRule.! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
nilResultAllowed
	^ nilResultAllowed! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
nilResultAllowed: aBoolean
	nilResultAllowed := aBoolean! !

!OrcaAbstractTest methodsFor: 'private' stamp: 'ag 4/6/2011 15:52'!
performTest
	
	self class = OrcaAbstractTest | (self class = OrcaTestCase) | (self class = OrcaAbstractPrinterTest)
		ifTrue: [ "Just ignore the abstract tests" ]
		ifFalse: [ super performTest ].! !

!OrcaAbstractTest methodsFor: 'test general' stamp: 'srv 1/10/2011 15:00'!
testExampleMethods
	
	self class converterClass
		convertMethod: #exampleMethod1 of: self class;
		convertMethod: #exampleMethod2 of: self class;
		convertMethod: #exampleMethod3 of: self class.! !

OrcaAbstractTest subclass: #OrcaParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaParserTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaParser! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testArray
	
	self
		currentRule: #array;
		
		assertMatches: '()' andProducesNode: {};
		assertMatches: '(:)' andProducesNode: { OrcaNode symbol: #: };
		assertMatches: '(  )  ' andProducesNode: {};
		assertMatches: '( 2. 1) ';
		assertMatches: '( 2. 1 [ ] ^ 23 { } ) ';
		assertMatches: '(  1 2   3) ' andProducesNode: {OrcaNode number: 1. OrcaNode number: 2. OrcaNode number: 3};
		assertMatches: '(''aa'' 1 ''b1'' 32)' andProducesNode: 
			{OrcaNode string: 'aa'. OrcaNode number: 1. OrcaNode string: 'b1'. OrcaNode number: 32};
		assertMatches: '(#abc     11    ''a''   )' andProducesNode: 
			{OrcaNode symbol: #abc. OrcaNode number: 11. OrcaNode string: 'a'};
		assertMatches: '(  ( 1 2 3    ''2'')   #a  ''c''   )' andProducesNode: 
			{OrcaNode array: {OrcaNode number: 1. OrcaNode number: 2. OrcaNode number: 3. OrcaNode string: '2'}.
			OrcaNode symbol: #a. OrcaNode string: 'c'};
		assertMatches: '($a     11    ''a''   #a2   #(1 2   $2) )  ' andProducesNode: { OrcaNode character: $a. OrcaNode number: 11. OrcaNode string: 'a'. OrcaNode symbol: #a2. OrcaNode array: {OrcaNode number: 1. OrcaNode number: 2. OrcaNode character: $2}};
		assertMatches: '( a )' andProducesNode: { OrcaNode symbol: #a};
		assertMatches: '( a b )' andProducesNode: {OrcaNode symbol: #a. OrcaNode symbol: #b} ;
		assertMatches: '(d ((b ((a))) (c)))' andProducesNode: {OrcaNode symbol: #d. OrcaNode array: {OrcaNode array: {OrcaNode symbol: #b. 
			OrcaNode array: {OrcaNode array: {OrcaNode symbol: #a}}}. OrcaNode array: {OrcaNode symbol: #c}}};
		assertMatches: '( self a:bc == |? ?!!!! )  ' andProducesNode: {OrcaNode symbol: #self. OrcaNode symbol: #'a:bc'. 
			OrcaNode symbol: #'=='. OrcaNode symbol: #'|'. OrcaNode symbol: #'?'. OrcaNode symbol: #'?!!!!'};
		assertMatches: '( self #( aa 1 ) ( ''a'' #1 #ab: ab:))  ' andProducesNode: { OrcaNode symbol: #self. OrcaNode array: {OrcaNode symbol: #aa. OrcaNode number: 1. }. OrcaNode array: { OrcaNode string: 'a'. OrcaNode number: 1. OrcaNode symbol: #'ab:'. OrcaNode symbol: #'ab:' }} ;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '(';
		assertFails: '#()';
		assertFails: '#(';
		assertFails: '{1}';
		assertFails: ' ( 1 2  )'. "Should not read prepended spaces"! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testBinaryExpression
	
	self
		currentRule: #binaryExpression;
		
		assertMatches: 'a+b' andProducesNode:  (OrcaNode binaryExpression: { OrcaNode identifier: 'a' . #+. OrcaNode identifier: 'b'} );
		assertMatches: '1 * b' andProducesNode: (OrcaNode binaryExpression: 
			{OrcaNode number: 1 .#* . OrcaNode identifier: 'b'});
		assertMatches: '1 \ b / c' andProducesNode: 
			(OrcaNode binaryExpression: 
				{ OrcaNode binaryExpression: {  OrcaNode number: 1.  #\  . 
				OrcaNode identifier: 'b'} . #/ . OrcaNode identifier: 'c'} );
		
		assertFails: 'a 2';
		assertFails: 'a: 2';
		assertFails: '+ 2'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testBinarySelector
	"Would be cool to find all the binary messages in the image and test them..."
	
	self
		currentRule: #binarySelector;
		
		"special cases: single pipe and single minus"
		assertMatches: '|' andProduces: #|;
		assertMatches: '-' andProduces: #-;
		
		"names starting with a minus"
		assertMatches: '-*' andProduces: #-*;
		assertMatches: '-***' andProduces: #-***;
		assertMatches: '-*%&' andProduces: #-*%&;
		assertMatches: '-*/\' andProduces: #-*/\;
		assertMatches: '-!!?' andProduces: #-!!?;
		assertMatches: '-==' andProduces: #-==;
		
		"mixed characters, check each one"
		assertMatches: '*+' andProduces: #*+;
		assertMatches: '/=\' andProduces: #/=\;
		assertMatches: '~,,,<' andProduces: #~,,,<;
		assertMatches: '>@' andProduces: #>@;
		assertMatches: '%&' andProduces: #%&;
		assertMatches: '?!!' andProduces: #?!!;
		assertMatches: '``' andProduces: #``;
		assertMatches: '+??=' andProduces: #+??=;
		assertMatches: ',!!!!,' andProduces: #,!!!!,;
		
		"Not allowed things"
		assertFails: '';
		assertFails: ' ';
		assertFails: 'w';
		assertFails: '2';
		assertFails: '--';
		assertFails: '||';
		assertFails: '|--';
		assertFails: '%--';
		assertFails: '%||';
		assertFails: '&-&-';
		assertFails: '- %';
		assertFails: ' -';
		assertFails: '& &';
		assertFails: 'w a';
		assertFails: '- -';
		assertFails: '#a a';
		assertFails: '#aa 2'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testBlock
	
	self
		currentRule: #block;
		
		assertMatches: '[]' andProducesNode: { };
		assertMatches: '[  ]' andProducesNode: { };
		assertMatches: '[||]' andProducesNode: {OrcaNode temporaries};
		assertMatches: '[:a|||]' andProducesNode: 
			{ OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode temporaries};
		assertMatches: '[||a]' andProducesNode: {OrcaNode temporaries. OrcaNode statements: {OrcaNode expression: {OrcaNode identifier: 'a'}}};
		assertMatches: '[:a|||a]' andProducesNode:
			{ OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode temporaries. OrcaNode statements: { OrcaNode expression: {OrcaNode identifier: 'a'}}};
		assertMatches: '[:a||a|a]' andProducesNode: 
			{ OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode temporaries: { OrcaNode identifier: 'a'}. 
			OrcaNode statements: { OrcaNode expression: { OrcaNode identifier: 'a'}}};
		assertMatches: '[:a|a|a|a]' andProducesNode:
			{ OrcaNode arguments: { OrcaNode identifier: 'a' }. OrcaNode statements:
				{ OrcaNode expression: { OrcaNode binaryExpression: { OrcaNode binaryExpression: 
					{ OrcaNode identifier: 'a'. #|. OrcaNode identifier: 'a' }. #| . 
					OrcaNode identifier: 'a'.  }}}};
		assertMatches: '[ :a ]  ' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'a'}};
		assertMatches: '   [ :a ]  ' andProducesNode: {OrcaNode arguments: { OrcaNode identifier: 'a'}};
		assertMatches: '[ :a :b ]  ' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'a'. OrcaNode identifier: 'b'}};
		assertMatches: '[ :a  :b | ]' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'a'. OrcaNode identifier: 'b'}};
		assertMatches: '  [   :a |   |  a  |   ]  ' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'a'}. 
			OrcaNode temporaries: {OrcaNode identifier: 'a'}};
		assertMatches: '[  :a  | a ]  ' andProducesNode:
			{OrcaNode arguments: {OrcaNode identifier: 'a'}. 
			OrcaNode statements: {OrcaNode expression: {OrcaNode identifier: 'a'}}};
		assertMatches: '[ :a  | a. ^ 1 ]' andProducesNode:
			{OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode statements:
				{OrcaNode expression: {OrcaNode identifier: 'a'}. OrcaNode returnExpression: {OrcaNode number: 1}}};
		assertMatches: '[  :a  |  1  ]' andProducesNode:
			{OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode statements: {OrcaNode expression: {OrcaNode number: 1}}};
		assertMatches: '[  :b  |   []  ]' andProducesNode:
			{OrcaNode arguments: {OrcaNode identifier: 'b'}. OrcaNode statements: {OrcaNode expression: { OrcaNode block}}};
		
		"Can also leave spaces between : and the argument-name !!"
		assertMatches: '[ :  i | ]' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'i'}};
		assertMatches: '[ :  i :  d | ]' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'i'. OrcaNode identifier: 'd'}};
		
		assertFails: '[]]';
		assertFails: '[[]';
		assertFails: '[::a]';
		assertFails: '[ :a | b';
		assertFails: '[ :a |||| b]';
		assertFails: '[ | :a | b]';
		assertFails: '[ || :a | b]';
		assertFails: '[ :a || b]';
		assertFails: '[ :a | :b  ]';
		assertFails: '[ :a || :b|]';
		assertFails: '[ :a | b| :a]';
		assertFails: '[ :a :1 | b]';
		assertFails: '[ aaaa"] ';
		assertFails: '[ "aaa"a"] ';
		assertFails: '[ "aaaa] '.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testBraceExpression
	
	self
		currentRule: #braceExpression;
		
		assertMatches: '{}' andProducesNode: { };
		assertMatches: '  {  }   ' andProducesNode: { };
		assertMatches: '{1}' andProducesNode: {OrcaNode expression: {OrcaNode number: 1}};
		assertMatches: '  {  11 }  ' andProducesNode: {OrcaNode expression: {OrcaNode number: 11}};
		assertMatches: '  {  11. }  ' andProducesNode: {OrcaNode expression: { OrcaNode number: 11}};
		assertMatches: '{ 1.   2}' andProducesNode: {OrcaNode expression: 
			{OrcaNode number: 1}. OrcaNode expression: { OrcaNode number: 2 }};
		assertMatches: '{1.2}' andProducesNode: { OrcaNode expression: { OrcaNode number: 1.2 }};
		assertMatches: '{1. 2}' andProducesNode: { OrcaNode expression: { OrcaNode number: 1 }. 
			OrcaNode expression: { OrcaNode number: 2 }};
		assertMatches: '{1. ''.'' .}' andProducesNode: { OrcaNode expression: { OrcaNode number: 1}. 
			OrcaNode expression: { OrcaNode string: '.' }};
		assertMatches: '{1  .  2  .}' andProducesNode: { OrcaNode expression: { OrcaNode number: 1}. 
			OrcaNode expression: { OrcaNode number: 2 }};		
		
		assertFails: '.{}.';
		assertFails: '{1 .. 2}';
		assertFails: '{ 1  . 2 ..}';
		assertFails: '{.1.2}';
		assertFails: '{..1.}';
 		assertFails: '{ "bb}';
 		assertFails: '{ "b "   .  b"}'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testByteArray
	
	self
		currentRule: #byteArray;
		
		assertMatches: '#[1]' andProducesNode: {1};
		assertMatches: '#  [  1  ]  ' andProducesNode: {1};
		assertMatches: '#[]' andProducesNode: {};
		assertMatches: '#   [1 2 3 ]' andProducesNode: {1. 2. 3.};
		assertMatches: '#[255 000 000 123 255]' andProducesNode: {255. 0. 0. 123. 255};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#[ 1';
		assertFails: '  #[ 1 ]';
		assertFails: '# [ 1.2 ]';
		assertFails: '#[ 256 1 00]';
		assertFails: '#[ -1 ]';
		assertFails: '#[ +1 ]';
		assertFails: '#[ #[ 1 ] ]  ';
		assertFails: '#( 255 )'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testCascadedExpression
	
	self
		currentRule: #cascadedExpression;
		assertMatches: 'Transcript  show:2;cr' andProducesNode: (OrcaNode cascadedExpression:
				{ OrcaNode identifier: 'Transcript'.  OrcaNode keywordExpression: {#show: . OrcaNode number: 2}. OrcaNode unaryExpression: {#cr}});
		"assertMatches: 'Transcript  show:2 ""Comment"";cr' andProducesNode: (self node: 'cascadedExpression' with:
				{self node: 'identifier:' with:{'Transcript'}. self node: 'keywordExpression' with: {#show: . self node: 'number' with: {2}} .self node:'unarayExpression' with:{self node:'comment' with:{'Comment'} . #cr} } );" "comments are not yet stored correctly"

		assertFails: 'Transcript  show:2 "Comment;cr';				
		assertFails: 'Transcript show:1'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testCharacter
	
	self
		currentRule: #character;
		
		assertMatches: '$c' andProducesNode: { $c };
		assertMatches: '$&' andProducesNode: { $& };
		assertMatches: '$ ' andProducesNode: { $ };
		assertMatches: '$`' andProducesNode: { $` };
		assertMatches: 'Character space' andProducesNode: { $  };
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'a';
		assertFails: '`';
		assertFails: ' $a';
		assertFails: '$$$';
		assertFails: '$  a';
		assertFails: '$av';
		assertFails: '$ a'.! !

!OrcaParserTest methodsFor: 'test general' stamp: 'lw 4/6/2011 18:05'!
testComments
	true ifTrue: [ ^ self ].
	self
		
		currentRule: #block;
		
		assertMatches: '"aaaaa" "aaa"[]'  andProducesNode: { OrcaNode comments: {OrcaNode comment: 'aaaaa'}. OrcaNode comments: {OrcaNode comment: 'aaa'}. OrcaNode block: {}};
		assertMatches: '"aaaaa" ["a aa"]'  andProducesNode: { OrcaNode comments: {OrcaNode comment: 'aaaaa'}. OrcaNode block: {OrcaNode comments: {OrcaNode comment: 'a aa'}} };
		assertMatches: '[ "a aaa"] '  andProducesNode: { OrcaNode block: {OrcaNode comments: {OrcaNode comment: 'a aaa'}} };
		assertMatches: '"aaa"{ "bbb"}' andProducesNode: { OrcaNode comments: {OrcaNode comment: 'aaa'}. OrcaNode braceExpression: { OrcaNode comments: {OrcaNode comment: 'bbb'}}};
		assertMatches: '# "adsd" eins "asdads"' andProducesNode: { OrcaNode symbol: {OrcaNode comments: {OrcaNode comment: 'adsd'}. #eins}. OrcaNode comments: {OrcaNode comment: 'asdads'}};

		
		currentRule: #binaryExpression;
		assertMatches: '1 "Comment "* b' andProducesNode: (OrcaNode binaryExpression: 
			{  OrcaNode number: 1. OrcaNode comments: {OrcaNode comment: 'Comment '}. #*. 
			OrcaNode identifier: 'b'}).! !

!OrcaParserTest methodsFor: 'test general' stamp: 'lw 4/6/2011 18:05'!
testExampleMethods
	
	super testExampleMethods! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testExpressionAssignment
	
	self
		currentRule: #expression;
		
		assertMatches: 'a' andProducesNode: { OrcaNode identifier: 'a'};
		assertMatches: 'a := b' andProducesNode: { OrcaNode identifier: 'b'. 
			 OrcaNode identifier: 'a'};
		assertMatches: '  a   :=   b  ' andProducesNode: { OrcaNode identifier: 'b'. 
			 OrcaNode identifier: 'a'};
		assertMatches: 'a := b := c := 1' andProducesNode: { OrcaNode number: 1. 
			 OrcaNode identifier: 'a'. OrcaNode identifier: 'b'. OrcaNode identifier: 'c'};
		assertMatches: '  a    :=  b  :=  c :=   1' andProducesNode: {OrcaNode number: 1. 
			 OrcaNode identifier: 'a'. OrcaNode identifier: 'b'. OrcaNode identifier: 'c'};
		assertMatches: 'a _ b' andProducesNode: { OrcaNode identifier: 'b'. 
			 OrcaNode identifier: 'a'};
		assertMatches: 'a := 1';
		assertMatches: 'a := b := 1';
		assertMatches: 'a := b := c := d';
		assertMatches: '   a     :=      a     ';
		assertMatches: '   a     _   1 ';
		assertMatches: 'a:=1';
		assertMatches: 'a:=1.0';
		assertMatches: 'a:=b:=1.0';
		assertMatches: 'a_v_1';
		
		assertFails: 'a : = b';
		assertFails: ' := b';
		assertFails: 'a := ';
		assertFails: 'a := b :=';
		assertFails: 'a := b := 1 := a';
		assertFails: 'a := := b   ';
		assertFails: 'a _ _ b';
		assertFails: 'a __ b';
		assertFails: 'a :=:= b';
		assertFails: 'a := b v := a';
		assertFails: 'a  b := a ';
		assertFails: 'a := 1 := b';
		assertFails: 'a: := b';
		assertFails: 'a: _ b';
		assertFails: 'a :_ b';
		assertFails: 'a := 1 := 2:=f';
		assertFails: 'a __ b';
		assertFails: 'a : = b'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testIdentifier
	
	self
		currentRule: #identifier;
		
		assertMatches: 'abc' andProducesNode: {'abc'};
		assertMatches: 'a1' andProducesNode: {'a1'};
		assertMatches: '1' andProducesNode: {'1'};
		assertMatches: 'aaaaaaaa1233333' andProducesNode: {'aaaaaaaa1233333'};
		assertMatches: '' andProducesNode: {''};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testKeywordSelector
	
	self
		currentRule: #keyword;
		
		assertMatches: 'abc:' andProduces: #abc:;
		assertMatches: 'a1:' andProduces: #a1:;
		assertMatches: '1:' andProduces: #1:;
		assertMatches: 'aaaaaaaa1233333:' andProduces: #aaaaaaaa1233333:;
		assertMatches: ':' andProduces: #:;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc';
		assertFails: 'abc<<'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testMethod
	
	self
		currentRule: #method;
		
		assertFails: 'a |a| <p> |a|'. "Don't allow two temporaries-declarations"! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testNumber
	
	self
		currentRule: #number;
		
		assertMatches: '1' andProducesNode: {1};
		assertMatches: '0' andProducesNode: {0};
		assertMatches: '123' andProducesNode: {123};
		assertMatches: '112345678' andProducesNode: {112345678};
		assertMatches: '000' andProducesNode: {0};
		assertMatches: '-000' andProducesNode: {0};
		assertMatches: '-1' andProducesNode: {-1};
		assertMatches: '-1.22' andProducesNode: {-1.22};
		assertMatches: '1.22e23' andProducesNode: {1.22e23};
		assertMatches: '122e23' andProducesNode: {12200000000000000000000000};
		assertMatches: '35r35' andProducesNode: {35r35};
		assertMatches: '-35r35' andProducesNode: {-35r35};
		assertMatches: '22r12.12' andProducesNode: {22r12.12};
		assertMatches: '22r12.12e12' andProducesNode: {22r12.12e12};
		assertMatches: '-22r-12.12e12' andProducesNode: {-22r-12.12e12};
		assertMatches: '22r-12.12e12' andProducesNode: {22r-12.12e12};
		assertMatches: '-22r12.12e12' andProducesNode: {-22r12.12e12};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '+1';
		assertFails: '+1.2';
		assertFails: '+23r23.3';
		assertFails: '+23r+233.3';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: 'abc';
		assertFails: '<<'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testPrimitiveDeclaration
	
	self
		currentRule: #primitiveDeclaration;
		
		assertMatches: '<a:1b:1>';
		assertMatches: '<a>';
		assertMatches: '<  a>';
		assertMatches: '  <  a  >';
		assertMatches: '< | 1>';
		assertMatches: '< == 2>';
		assertMatches: '<  var: ''anc'' >';
		assertMatches: '< & ''add''>';
		assertMatches: '< abc: 22 dfe: 23>';
		
		assertFails: '<1>';
		assertFails: '< 1 2 >';
		assertFails: '<a: 1 1>';
		"assertFails: '<v: d>';" "These should not match, but match currently. Never mind, is not allowed by the compiler"
		"assertFails: '<d: 2 d: e>';"
		"assertFails: '< | d >';"
		assertFails: '<''2''>';
		assertFails: '<| 1>';
		assertFails: '<< 2>';
		assertFails: '< > 2>';
		assertFails: '<> 2>';
		assertFails: '< a: 2 ';
		assertFails: '< a ';
		assertFails: '< | 2 '.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testReservedWord
	
	self
		currentRule: #statements;
		
		assertConverting: '1 a; b: self; c' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. self}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. nil}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{true|nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil.{true}}' containsNodeNamed: 'reservedWord';
		denyConverting: '{1. self2. true12}' containsNodeNamed: 'reservedWord';
		denyConverting: '{1. aNself}' containsNodeNamed: 'reservedWord';
		denyConverting: '#(1 self super)' containsNodeNamed: 'reservedWord';
		assertConverting: '#(true)' containsNodeNamed: 'reservedWord';
		
		currentRule: #primary;
		
		assertConverting: '(self)' containsNodeNamed: 'reservedWord';
		assertConverting: '(self/1)' containsNodeNamed: 'reservedWord';
		assertConverting: '([self])' containsNodeNamed: 'reservedWord';
		assertConverting: '([self.])' containsNodeNamed: 'reservedWord';
		assertMatches: '(self2)' andProduces: (OrcaNode paranthesizedExpression: { OrcaNode identifier: 'self2' });
		denyConverting: '([self2])' containsNodeNamed: 'reservedWord'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testStatements

	"TODO Not complete test !! Write more !! " 
	
	self
		currentRule: #statements;
		nilResultAllowed: true;
		
		assertMatches: '...';
		assertMatches: 'a. b. ^ c';
		assertMatches: 'a.b.c';
		assertMatches: '1 a. b d: d d: 1. 2. ^ a d: d f: 2';
		assertMatches: '  a  .  b   .. . . . .. . . . .   c.  ^ 1.';
		
		assertFails: ' a. ^ 1...';
		assertFails: ' 1. a ^ 1';
		assertFails: '^ d d. 1';
		assertFails: '^ .';
		assertFails: '^....';
		assertFails: '^^'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testString
	
	self
		currentRule: #string;
		
		assertMatches: '''a''' andProduces: (OrcaNode string: 'a');
		assertMatches: '''''' andProduces: (OrcaNode string: '');
		assertMatches: '''123''' andProduces: (OrcaNode string: '123');
		assertMatches: ''' '''' '''' ''' andProduces: (OrcaNode string: ' '' '' ');
		assertMatches: '''''''123''' andProduces: (OrcaNode string: '''123');
		assertMatches: '''    ''' andProduces: (OrcaNode string: '    ');
		assertMatches: '''"$%&''' andProduces: (OrcaNode string: '"$%&');
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: ''' ''a';
		assertFails: ' ''''';
		assertFails: 'a''''';
		assertFails: '''as';
		assertFails: 'as''';
		assertFails: ''' '' ''';
		assertFails: '''a '' a''';
		assertFails: '''/'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'ag 4/6/2011 18:09'!
testSymbol
	
	"TODO extend test, if stringS2 J gets extended to support '' inside of a string"
	"Edit -- no idea what that comment means and what strinS2 J is"
	
	self
		currentRule: #symbol;
		
		assertMatches: '#abc' andProducesNode: {#abc};
		assertMatches: '# ''''' andProducesNode: {#''};
		assertMatches: '#   abc' andProducesNode: {#  abc};
		assertMatches: '#abc1' andProducesNode: {#abc1};
		assertMatches: '#a' andProducesNode: {#a};
		assertMatches: '#''a''' andProducesNode: {#a};
		assertMatches: '#''a b c''' andProducesNode:  {#'a b c'};
		assertMatches: '#''''' andProducesNode: {#''};
		assertMatches: '#''123''' andProducesNode:  {#'123'};
		assertMatches: '#''    ''' andProducesNode: {#'    '};
		assertMatches: '#''"$%&''' andProducesNode: {#'"$%&'};
		assertMatches: '#abc1:' andProducesNode: {#abc1:};
		assertMatches: '#|' andProducesNode: {#|};
		assertMatches: '#-&&' andProducesNode: {#-&&};
		assertMatches: '#-' andProducesNode: {#-};
		assertMatches: '#a:b:c1' andProducesNode: {#a:b:c1};
		assertMatches: '#:' andProducesNode: {#:};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'abc';
		assertFails: '#1abc';
		assertFails: '#""';
		assertFails: '#'' ''a';
		assertFails: '#a''''';
		assertFails: '#''as';
		assertFails: '#as''';
		assertFails: '#'' '' ''';
		assertFails: '#''a '' a''';
		assertFails: '#123';
		assertFails: '###';
		assertFails: '#''/'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testUnaryExpression
	
	self
		currentRule: #unaryExpression;
		
		assertMatches: 'a b' andProducesNode: { OrcaNode identifier: 'a'. #b };
		assertMatches: '1 b' andProducesNode: { OrcaNode number: 1. #b };
		assertMatches: 'a b c' andProducesNode: { OrcaNode unaryExpression: { OrcaNode identifier: 'a'. #b }. #c };
		assertMatches: ' a  b c d ' andProducesNode: { OrcaNode unaryExpression: { OrcaNode unaryExpression: { OrcaNode identifier: 'a'. #b }. #c }. #d };
		assertMatches: '   ''abc''    b1     ' andProducesNode: { OrcaNode string: 'abc'. #b1 };
		
		assertFails: '';
		assertFails: '  ';
		assertFails: 'a';
		assertFails: '  a  ';
		assertFails: 'a  1';
		assertFails: 'a b 1';
		assertFails: 'a || b';
		assertFails: 'a % b';
		assertFails: 'a -|';
		assertFails: 'a b > a';
		assertFails: 'a unary>'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testUnarySelector
	"Would be cool to find all the unary messages in the image and test them..."
	
	self
		currentRule: #unarySelector;
		
		assertMatches: 'abc' andProduces: #abc;
		assertMatches: 'a1' andProduces: #a1;
		assertMatches: '1' andProduces: #1;
		assertMatches: 'aaaaaaaa1233333' andProduces: #aaaaaaaa1233333;
		assertMatches: '' andProduces: #;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

OrcaAbstractTest subclass: #OrcaSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaSerializationTest methodsFor: 'testing' stamp: 'ag 3/31/2011 10:04'!
assert: objectTree isSerializedTo: jsCode
	
	self assert: jsCode = objectTree serializeToJavaScript.! !

!OrcaSerializationTest methodsFor: 'testing' stamp: 'sec 4/6/2011 20:12'!
testNestedObjectSerialization
	
	| var1 var2 var3 |
	var1 := OrcaSerializationTestObject new.
	var2 := OrcaSerializationTestObject new.
	var3 := OrcaSerializationTestObject new.
	var1 otherObject: var2.
	var2 otherObject: var3.
	var3 otherObject: var1.
	self
		assert: var1
		isSerializedTo: 
			'(function(){var obj3=st.OrcaSerializationTestObject._newInstance();',
			'var obj2=st.OrcaSerializationTestObject._newInstance();',
			'var obj1=st.OrcaSerializationTestObject._newInstance();',
			'obj3.$otherObject=obj1;',
			'obj2.$otherObject=obj3;',
			'obj1.$otherObject=obj2;',
			'return obj1;})()'.! !

!OrcaSerializationTest methodsFor: 'testing' stamp: 'ag 4/11/2011 16:24'!
testObjectSerialization
	
	self
		assert: (1)
		isSerializedTo: '(function(){var obj1=st.number(1);return obj1;})()';
		
		assert: ({})
		isSerializedTo: '(function(){var obj1=st.Array._newInstance();obj1.original$=[];return obj1;})()';
		
		assert: ({1. 'a'})
		isSerializedTo: '(function(){var obj3=st.string("a");var obj2=st.number(1);var obj1=st.Array._newInstance();obj1.original$=[obj2, obj3];return obj1;})()';
		
		assert: (nil)
		isSerializedTo: '(function(){var obj1=nil;return obj1;})()'.! !

!OrcaSerializationTest methodsFor: 'testing' stamp: 'ag 4/11/2011 16:24'!
testSlotObjectSerialization
	
	self
		assert: ({} asObject)
		isSerializedTo: '(function(){var obj1={};st.unboxSlotObject(obj1);return obj1;})()';
		
		assert: ({#a -> 1. #b -> 2} asObject)
		isSerializedTo: '(function(){var obj3=st.number(2);var obj2=st.number(1);var obj1={};obj1.a=obj2;obj1.b=obj3;st.unboxSlotObject(obj1);return obj1;})()'.! !

OrcaAbstractTest subclass: #OrcaSqueakAstToJsAstTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaSqueakAstToJsAstTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaSqueakAstToJsAst! !

!OrcaSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:35'!
testBlockArgument
	
	self
		currentRule: #block;
		
		assertMatches: '[]' 
		andProduces: (OrcaNode functionCall: 
			{nil. 'st.block'. OrcaNode arguments: 
				{OrcaNode functionDeclaration: {OrcaNode arguments. OrcaNode functionContent: {}}}});
		
		assertMatches: '[1]' 
		andProduces: (OrcaNode functionCall:  
			{nil. 'st.block'. OrcaNode arguments: 
				{OrcaNode functionDeclaration: 
					{ OrcaNode arguments. 
					OrcaNode functionContent: 
						{ OrcaNode returnExpression: 
							{ OrcaNode functionCall: 
								{ nil. 'st.number'. 
								OrcaNode arguments: { OrcaNode number: 1 }}}}}}});
								
		assertMatches: '[^''1'']' 
		andProduces: (OrcaNode functionCall:  
			{nil. 'st.block'. OrcaNode arguments: 
				{OrcaNode functionDeclaration: 
					{ OrcaNode arguments. 
					OrcaNode functionContent: 
						{ OrcaNode returnExpression: 
							{ OrcaNode functionCall: 
								{ nil.
								'st.nonLocalReturn'.
								OrcaNode arguments: 
									{ OrcaNode functionCall: 
										{ nil.
										'st.string'. 
										OrcaNode arguments: {OrcaNode string:  '1' }}}}}}}}});
		
		assertMatches: '[:a]' 
		andProduces: (OrcaNode functionCall: 
			{nil. 'st.block'. OrcaNode arguments: 
				{OrcaNode functionDeclaration: {OrcaNode arguments: { OrcaNode identifier: 'a' }. OrcaNode functionContent: {}}}}).! !

!OrcaSqueakAstToJsAstTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:15'!
testExampleMethods
	
	super testExampleMethods! !

!OrcaSqueakAstToJsAstTest methodsFor: 'test treequality' stamp: 'ag 4/6/2011 15:52'!
testNestedExpressions

	self 
		currentRule: #expression;
		
		assertMatches: (OrcaNode expression) 
		andProduces: (OrcaNode expression);
		
		assertMatches: (OrcaNode expression: {OrcaNode expression}) 
		andProduces: (OrcaNode expression);
		
		assertMatches: (OrcaNode expression: 
			{OrcaNode expression. OrcaNode identifier: 'a'}) 
		andProduces: (OrcaNode expression: {OrcaNode identifier: 'a'});
			
		assertMatches: (OrcaNode expression: {OrcaNode returnExpression: {}}) 
		andProduces: (OrcaNode returnExpression: {})! !

!OrcaSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:35'!
testNonLocalReturn
	
	self
		currentRule: #block;
		
		assertMatches: 
			'[ [^ ''returned nonlocally''] value ]'
		 andProduces: (OrcaNode functionCall: 
			{nil.
			'st.block'.
			OrcaNode arguments: 
				{OrcaNode functionDeclaration: 
					{ OrcaNode arguments.
					OrcaNode functionContent: 
						{OrcaNode returnExpression: 
						{OrcaNode functionCall: 
							{ OrcaNode functionCall: 
								{nil. 
								'st.block'.
								OrcaNode arguments: 
									{OrcaNode functionDeclaration: 
										{OrcaNode arguments.
										OrcaNode functionContent:
											{ OrcaNode returnExpression:  
												{ OrcaNode functionCall: 
													{nil. 
													'st.nonLocalReturn'. 
													OrcaNode arguments: 
														{ OrcaNode functionCall: 
															{ nil. 
															'st.string'. 
															OrcaNode arguments: {OrcaNode string: 'returned nonlocally'}}}}}}}}}.
							'value'. OrcaNode arguments}}}}}})
		
		
	"expected JavaScript: st.block(function(){return st.block(function(){st.nonLocalReturn('returned nonlocally')}).value() }, this)"! !

OrcaAbstractTest subclass: #OrcaTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaTranslatorTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaPrinter! !

!OrcaTranslatorTest class methodsFor: 'testing' stamp: 'lw 2/21/2011 13:17'!
defaultCurrentRule
	
	^ #doItSnippet! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:20'!
testAddition
	
	self
		assertMatches: '3+4'
		andProduces: 'st.number(3)._plus(st.number(4))'.! !

!OrcaTranslatorTest methodsFor: 'test branch' stamp: 'ag 4/11/2011 16:20'!
testCascades

	self 
		assertMatches: 'a b; c' andProduces:  
'(function(){var cascadeReceiver$=a;cascadeReceiver$.b();return cascadeReceiver$.c();}).apply(this)';

		assertMatches: 'a slot: b; slot: c' andProduces: 
 '(function(){var cascadeReceiver$=a;cascadeReceiver$.slot_(b);return cascadeReceiver$.slot_(c);}).apply(this)';

		assertMatches: 'a slot: b be: d; slot: c be: d' andProduces: 
 '(function(){var cascadeReceiver$=a;cascadeReceiver$.slot_be_(b, d);return cascadeReceiver$.slot_be_(c, d);}).apply(this)';

		assertMatches: '^ Object new slot: injection be: ''infovis''; yourself' andProduces: 
 'return (function(){var cascadeReceiver$=st.Object._new();cascadeReceiver$.slot_be_(injection, st.string("infovis"));return cascadeReceiver$.yourself();}).apply(this)'.! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:19'!
testLoop
	
	self
		assertMatches: '{1. 2. 3} do: [:elem | Js Global alert value: elem]'
		andProduces: 'st.array([st.number(1), st.number(2), st.number(3)]).do_(st.block(function(elem){return st.Js.Global().alert().value_(elem);}))';
		
		assertMatches: 'arr do: [:elem | Js Global alert value: elem ]'
		andProduces: 'arr.do_(st.block(function(elem){return st.Js.Global().alert().value_(elem);}))';
		
		assertMatches: 'arr do: block'
		andProduces: 'arr.do_(block)'.! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:18'!
testNonLocalReturn
	
	self
		assertMatches: '
			[ Js Global alert value: ''outer''.
			[Js Global alert value: ''inner''.
			 ^self].
			Js Global alert value: ''end'' ]'
		andProduces: 
'st.block(function(){st.Js.Global().alert().value_(st.string("outer"));st.block(function(){st.Js.Global().alert().value_(st.string("inner"));return st.nonLocalReturn(this);});return st.Js.Global().alert().value_(st.string("end"));})'! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/6/2011 15:52'!
testSelectorTranslation
	
	| assertBlock |
	assertBlock := [ :squeakSelector :jsFunctionname  | 
		self assert: jsFunctionname equals: (OrcaSqueakAstToJsAst jsFunctionNameFor: squeakSelector).].
	
	assertBlock
		value: 'do:forDuration:' value: 'do_forDuration_';
		value: 'do:' value: 'do_';
		value: 'do' value: '_do';
		value: '*+' value: '_times_plus';
		value: '++' value: '_plus_plus'.! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:05'!
testTrueFalse

	self 
		assertMatches: '10 < 5 ifTrue: [ Js Global alert value: ''small'' ] ifFalse: [ Js Global alert value: ''big'' ]'
		andProduces:
'st.number(10)._less(st.number(5)).ifTrue_ifFalse_(st.block(function(){return st.Js.Global().alert().value_(st.string("small"));}), st.block(function(){return st.Js.Global().alert().value_(st.string("big"));}))'! !

!OrcaTranslatorTest methodsFor: 'test printing' stamp: 'LT 2/24/2011 15:45:50.248'!
testVarDeclaration
	
	self 
		assertMatches: '|a b c|'
		andProduces: 'var a;var b;var c'! !

OrcaTestCase subclass: #OrcaCodeCleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaCodeCleanTest methodsFor: 'tests' stamp: 'ag 2/3/2011 12:05'!
testNoDirtyCategories
	
	self assert: (Utilities classesWithDirtyCategories isEmpty)! !

!OrcaCodeCleanTest methodsFor: 'tests' stamp: 'ag 2/3/2011 12:04'!
testNoEmptyCategories
	
	self assert: (Utilities classesWithEmptyCategories isEmpty)! !

OrcaTestCase subclass: #OrcaCodeFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaCodeFactoryTest methodsFor: 'test methods' stamp: 'ag 12/16/2010 11:21'!
aTestMethod
	
	"Empty method for tests"! !

!OrcaCodeFactoryTest methodsFor: 'test methods' stamp: 'ag 12/16/2010 11:23'!
aTestMethod2
	
	"Empty method for tests"! !

!OrcaCodeFactoryTest methodsFor: 'test methods' stamp: 'LT 3/16/2011 14:48:46.253'!
aTestMethod3
	
	self error: 'testMethod: do not call'.
	self this is only a test message.
	
	"used in testTranslatedMethodContainsAllUsedMessages" ! !

!OrcaCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 4/6/2011 15:52'!
codeFactory
	"Skip the singleton-pattern"
	
	^ OrcaCodeFactory new! !

!OrcaCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 4/6/2011 15:52'!
getTestMethod: aSymbol
	
	^ OrcaOMeta2 method: aSymbol of: self class! !

!OrcaCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 1/5/2011 22:57'!
methodNumIn: aClass
	
	^ aClass methodDict size + aClass class methodDict size! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 1/6/2011 11:06'!
testCaching
	
	| factory |
	factory := self codeFactory.
	self assert: factory codeCache size == 0.
	factory codeForMethod: #aTestMethod of: self class.
	self assert: factory codeCache size == 1.
	factory codeForMethod: #aTestMethod of: self class.
	self assert: factory codeCache size == 1.
	factory codeForMethod: #aTestMethod2 of: self class.
	self assert: factory codeCache size == 2.
	factory codeForClass: self class.
	factory codeFor: self class. "If already cached, this works, too"
	self assert: factory codeCache size == ((self methodNumIn: self class) + 1).
	
	factory := self codeFactory.
	factory codeFor: '1 a'.
	self assert: factory codeCache size == 1.
	factory codeFor: '1 a'.
	factory codeFor: '1 a'.
	self assert: factory codeCache size == 1.
	factory codeFor: '1 a; b'.
	factory codeFor: '1 a; b'.
	self assert: factory codeCache size == 2.! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 4/6/2011 15:52'!
testCachingClasses
	
	| factory |
	factory := self codeFactory.
	factory codeForClass: self class.
	self assert: factory codeCache size = (self class methodDict size + 1).
	factory codeForClasses: { self class. OrcaNode }.
	self assert: 
		factory codeCache size = 
		((self methodNumIn: self class) + (self methodNumIn: OrcaNode) + 3). "Methods + 2 classes + 1 class-array"! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 12/16/2010 21:20'!
testCachingWithRecompile
	
	| factory size |
	factory := self codeFactory.
	factory codeForClass: self class.
	size := factory codeCache size.
	self class compileAll.
	factory codeForClass: self class.
	self assert: size == factory codeCache size.! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 4/6/2011 15:52'!
testEqualsBlock
	
	| factory block antiBlock method1 method2 |
	factory := self codeFactory.
	block := [ :o1 :o2 | self assert: (factory compareCacheKey: o1 to: o2)].
	antiBlock := [ :o1 :o2 | self deny: (factory compareCacheKey: o1 to: o2)].
	
	block
		value: 'abc' value: 'abc';
		value: (self getTestMethod: #aTestMethod) value: (self getTestMethod: #aTestMethod);
		value: self class value: self class.
	antiBlock
		value: 'abc1' value: 'abc2';
		value: self class value: Object;
		value: 1 value: 2;
		value: 1 value: '1';
		value: (self getTestMethod: #aTestMethod) value: (OrcaOMeta2 method: #asString of: Object);
		value: (self getTestMethod: #aTestMethod) value: (self getTestMethod: #aTestMethod2).
	
	method1 := (self getTestMethod: #aTestMethod).
	self class compileAll.
	method2 := (self getTestMethod: #aTestMethod).
	self deny: method1 == method2. "Should be new objects after recompiling!!"
	block value: method1 value: method2.! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 4/11/2011 16:36'!
testTranslatedMethodContainsAllUsedMessages

	| codeFactory cacheEntry |
	codeFactory := self codeFactory.
	cacheEntry := codeFactory cacheObjectForMethod: (self getTestMethod: #aTestMethod3).
	self assert: cacheEntry calledFunctions size = 8.
	self assert: (cacheEntry calledFunctions includesAllOf: { #'error_'. #'_this'. #'_is'. #only. #a. #test. #message. #'st.string'}).
	self assert: (cacheEntry calledFunctions keys includesAllOf: { #'error:'. #'this'. #'is'. #only. #a. #test. #message. #'st.string'})
! !

OrcaTestCase subclass: #OrcaJavascriptTest
	instanceVariableNames: 'semaphore clientTestResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OrcaJavascriptTest class
	instanceVariableNames: 'currentTestCase'!

!OrcaJavascriptTest commentStamp: 'ag 1/26/2011 15:16' prior: 0!
This Test starts the browser with the url of the S2JTestApp.
Then it waits for the test-results from the browser.!

OrcaJavascriptTest class
	instanceVariableNames: 'currentTestCase'!

!OrcaJavascriptTest class methodsFor: 'accessing' stamp: 'ag 1/31/2011 12:31'!
currentTestCase
	^ currentTestCase! !

!OrcaJavascriptTest class methodsFor: 'accessing' stamp: 'ag 1/31/2011 12:31'!
currentTestCase: anObject
	currentTestCase := anObject! !

!OrcaJavascriptTest class methodsFor: 'waiting' stamp: 'lw 2/19/2011 19:51'!
reportJSResult: aString
	"If we currently are executing a test-case, it gets notified."
	
	self currentTestCase notNil & self isOnCIServer ifTrue: [ self currentTestCase clientResponded: aString ].
	^ ''! !

!OrcaJavascriptTest class methodsFor: 'waiting' stamp: 'srv 1/31/2011 22:35'!
reportJSResults: aString
	"If we currently are executing a test-case, it gets notified."
	
	self currentTestCase notNil & self isOnCIServer ifTrue: [ self currentTestCase clientResponded: aString ].
	^ ''! !

!OrcaJavascriptTest class methodsFor: 'waiting' stamp: 'lw 2/19/2011 19:53'!
reportJSResults: failed and: errors
	"If we currently are executing a test-case, it gets notified."
	
	self currentTestCase notNil & self isOnCIServer ifTrue: [ self currentTestCase clientResponded: { failed. errors} ].
	^ ''! !

!OrcaJavascriptTest class methodsFor: 'accessing' stamp: 'ag 1/31/2011 12:30'!
retryTime
	" in seconds "
	
	^ 120! !

!OrcaJavascriptTest methodsFor: 'helpers' stamp: 'ag 2/3/2011 13:00'!
clientResponded: aString
	
	self clientTestResult: aString.
	self semaphore signal.! !

!OrcaJavascriptTest methodsFor: 'accessing' stamp: 'ag 2/3/2011 13:00'!
clientTestResult
	^ clientTestResult! !

!OrcaJavascriptTest methodsFor: 'accessing' stamp: 'ag 2/3/2011 13:00'!
clientTestResult: anObject
	clientTestResult := anObject! !

!OrcaJavascriptTest methodsFor: 'helpers' stamp: 'srv 1/27/2011 16:48'!
killFireFox
	
	CommandShell command: 'pkill firefox;exit'! !

!OrcaJavascriptTest methodsFor: 'testing' stamp: 'ag 2/3/2011 12:57'!
performTest: url tryAgain: tryAgain
	
	^ self performTest: url tryAgain: tryAgain doing: []! !

!OrcaJavascriptTest methodsFor: 'testing' stamp: 'ag 2/3/2011 16:00'!
performTest: url tryAgain: tryAgain doing: aBlock
	
	self runFireFox: url.
	(Delay forSeconds: 3) wait.
	aBlock value.
	(self semaphore waitTimeoutSeconds: self class retryTime) 
		ifTrue: [
			self killFireFox.
			tryAgain ifTrue: [ self performTest: url tryAgain: false doing: aBlock] ] "have a second try, because sometimes the bodys onload is not evaluated"
		ifFalse: [ ^ self clientTestResult ].
	self error: 'No answer from the Javascript-side'.! !

!OrcaJavascriptTest methodsFor: 'helpers' stamp: 'ag 2/3/2011 12:48'!
runFireFox: url

	CommandShell command: 'firefox -P JSTests ', url, ';exit'! !

!OrcaJavascriptTest methodsFor: 'accessing' stamp: 'lw 1/27/2011 05:07'!
semaphore
	^ semaphore! !

!OrcaJavascriptTest methodsFor: 'accessing' stamp: 'lw 1/27/2011 05:07'!
semaphore: anObject
	semaphore := anObject! !

!OrcaJavascriptTest methodsFor: 'running' stamp: 'ag 4/6/2011 15:52'!
setUp
	
	self class isOnCIServer ifTrue: [
		OrcaDispatcher forcedRestart.
		self clientTestResult: nil.
		self semaphore: Semaphore new.
		self class currentTestCase: self ].! !

!OrcaJavascriptTest methodsFor: 'running' stamp: 'ag 1/31/2011 12:32'!
tearDown
	
	self class isOnCIServer ifTrue: [
		self killFireFox.
		self class currentTestCase: nil ].! !

!OrcaJavascriptTest methodsFor: 'testing' stamp: 'lw 2/19/2011 20:00'!
testClientside
	
	self class isOnCIServer ifTrue: [ | result |
		result := (self performTest: 'http://localhost:8887/test' tryAgain: true ).
		(result at: 2) = '0' ifFalse: [ self error: 'One of the JS-Tests ended with an error. For more details visit http://localhost:8887/test/'].
		self assert: 0 = (result at: 1) asInteger ].! !

!OrcaJavascriptTest methodsFor: 'testing' stamp: 'ag 4/6/2011 18:06'!
testOnServerBlock
	
	"TODO test commented out, because communication required bootstrap.js and classes, which are not loaded yet"
	
	false & (self class isOnCIServer) ifTrue: [
		self assert: 
			'abc123' =
			(self
				performTest: 'http://localhost:8887/emptyTest'
				tryAgain: true
				doing: [ OrcaEmptyTestApp sendCode: '[ OrcaJavascriptTest js reportJSResults: OrcaMockTestResult ] onServer value' ] ) ].! !

!OrcaJavascriptTest methodsFor: 'testing' stamp: 'ag 4/6/2011 18:07'!
testSendCode
	
	"TODO test commented out, because communication required bootstrap.js and classes, which are not loaded yet"
	
	false & (self class isOnCIServer) ifTrue: [
		self assert: 
			'abc123' =
			(self
				performTest: 'http://localhost:8887/emptyTest'
				tryAgain: true
				doing: [ OrcaEmptyTestApp sendCode: 'OrcaServer js performOnServer: '' OrcaJavascriptTest js reportJSResults: OrcaMockTestResult ''' ] ) ].! !

OrcaTestCase subclass: #OrcaSwazooTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OrcaSwazooTests subclass: #OrcaCometHandlerTests
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaCometHandlerTests methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:57'!
client
	^ client! !

!OrcaCometHandlerTests methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:57'!
client: anObject
	client := anObject! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
killClient

	self client timeStampOfLatestRequest: TimeStamp now - OrcaCometClient defaultMaximumAge! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
setUp

	self client: OrcaCometClient new.
	self client application: (OrcaTestApp instance reset );
			    identifier: (OrcaCometHandler newFor: self client application ) generateIdentifier.
	self client application addClient: self client.
		
! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testClientMatchingAtCometHandler

	client := (OrcaCometHandler newFor: (OrcaTestApp instance)) findClientById: self client identifier.
	self assert: ( client = self client).
	! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testCreateNewId
	| oldCount newCount response path |
	
	oldCount := self client application clients size.
	path := OrcaTestApp uniquePath, OrcaCometHandler pathSuffix.	
	response := OrcaDispatcher new answerTo: (self basicGetFor: path).
	self assert: response notNil.
	self assert: (response statusCode = 202).
	newCount := self client application clients size.
	self assert: newCount = (oldCount + 1)! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/25/2011 11:23'!
testDeathAfterMaximumAge 

	self killClient.
	self deny: self client isAlive ! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testDispatchApplicationAndCreateCometClient
	
	| clientId response path |

	path := OrcaTestApp uniquePath,'/', OrcaCometHandler pathSuffix.
	response := OrcaDispatcher new answerTo: (self basicGetFor: path).
	clientId := response body asString.
	
	self client: ((OrcaCometHandler newFor: OrcaTestApp instance ) findClientById: clientId).
	self assert: (self client notNil).
	self assert: (self client isAlive).
! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testForwardingCometHandler

	| request path response |
	
	path := OrcaTestApp uniquePath, OrcaCometHandler pathSuffix, '?id=', self client identifier.
	request :=  self basicGetFor: path. 
	
	self client application repository addContent: 'test'.
	response := (OrcaCometHandler newFor: (OrcaTestApp instance)) answerTo: request. 

	self assert: (response body asString = 'test').
! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/19/2011 10:17'!
testIsInitiallyAlive


	self assert: self client isAlive! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testQueriesKeepAlive
	| path response |
	
	self client timeStampOfLatestRequest: (TimeStamp now - (Duration seconds: 2)).
	path := OrcaTestApp uniquePath, OrcaCometHandler pathSuffix , '?id=', self client identifier.

	[ response := OrcaDispatcher new answerTo: (self basicGetFor: path) ] fork.
	(Delay forSeconds: 2) wait.
	self assert: self client isAlive.
	self killClient.
	! !

!OrcaCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testRemoveDeadClient

	| clientId response path |
	
	path := OrcaTestApp uniquePath, '/', OrcaCometHandler pathSuffix , '?id=', self client identifier.
	[ (Delay forSeconds: 1) wait.
		 self killClient.
	] fork.
	response := OrcaDispatcher new answerTo: (self basicGetFor: path).
	self assert: (response statusCode = OrcaCometClient HTTPStatusCodeTimeOut).
	self assert: ((OrcaCometHandler newFor: (OrcaTestApp instance)) findClientById: clientId) isNil.! !

OrcaSwazooTests subclass: #OrcaDispatcherTests
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaDispatcherTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testDispatchVirginCometRequest

	| response path httpRequest |
	
	path := OrcaTestApp uniquePath, OrcaCometHandler pathSuffix.
	httpRequest :=	(self basicGetFor: path).
	response := OrcaDispatcher new answerTo: httpRequest.
	
	self assert: (response body asString isAllDigits ).! !

!OrcaDispatcherTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testDispatchVirginWebSocketRequest

	| response path httpRequest |
	
	path := OrcaTestApp uniquePath, OrcaWebSocketHandler pathSuffix.
	httpRequest :=	(self basicWSFor: path).
	response := OrcaDispatcher new answerTo: httpRequest.
	
	self assert: (response body asString isAllDigits).! !

!OrcaSwazooTests methodsFor: 'as yet unclassified' stamp: 'SW 1/31/2011 08:52'!
arrayFromHexString: aString
	| array stream lookup |
	lookup := '123456789ABCDEF'.
	array := ByteArray new: aString size // 2.
	stream := aString readStream.
	1 to: array size do: [ :i || h l |
		h := stream next.
		h := h = $0 ifTrue: [0] ifFalse: [lookup indexOf: h].
		l := stream next.
		l := l = $0 ifTrue: [0] ifFalse: [lookup indexOf: l].
		array at: i put: ((h bitShift: 4) bitOr: l) ].
	^array! !

!OrcaSwazooTests methodsFor: 'as yet unclassified' stamp: 'ag 2/16/2011 18:29'!
basicGetFor: aPath

	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET localhost:8887/', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: localhost';
		nextPutLine: 'Connection: Keep-Alive';
		crlf.
	^ HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).! !

!OrcaSwazooTests methodsFor: 'as yet unclassified' stamp: 'SW 1/31/2011 09:08'!
basicWSFor: aPath

	| requestStream request|
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET ', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: example.com';
		nextPutLine: 'Connection: Upgrade';
		nextPutLine: 'Sec-WebSocket-Key2: 8 1 8 6    7 ]   8476';
		nextPutLine: 'Sec-WebSocket-Protocol: sample';
		nextPutLine: 'Upgrade: WebSocket';
		nextPutLine: 'Sec-WebSocket-Key1: 2  __4 ''79  #  9"; +K 67  -655';
		nextPutLine: 'Origin: http://example.com';
		nextPutLine: 'Content-Length: 8';
		crlf;
		nextPutLine: (self arrayFromHexString: '598F6AEF77E67CBE') asString.
		
	request := HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).
	request task: (SwazooTask newOn: request).
	request task connection: HTTPConnection new.
	^ request! !

!OrcaSwazooTests methodsFor: 'as yet unclassified' stamp: 'HK 1/12/2011 17:17'!
upgradeGetFor: aPath

	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET ', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: localhost';
		nextPutLine: 'Upgrade: WebSocket';
		crlf.
	^ HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).! !

OrcaSwazooTests subclass: #OrcaWebSocketHandlerTests
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaWebSocketHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testOpenConnection

	| oldCount response request |

	oldCount := OrcaTestApp instance clients size.

	request := self basicWSFor: OrcaTestApp uniquePath, '/ws'..
	response := (OrcaWebSocketHandler newFor: (OrcaTestApp instance)) answerTo: request.	
	self assert: response isWebSocketHandshake.
	
	self assert: (OrcaTestApp instance clients size = (oldCount +1)).! !

!OrcaTestCase class methodsFor: 'testing' stamp: 'ag 4/6/2011 17:58'!
isOnCIServer
	
	^ true == (Smalltalk at: #OrcaIsOnCIServer ifAbsent: [ nil ])! !

!OrcaTestCase class methodsFor: 'testing' stamp: 'ag 2/3/2011 13:08'!
setIsOnCIServer
	
	^ self setIsOnCIServer: true! !

!OrcaTestCase class methodsFor: 'testing' stamp: 'ag 4/6/2011 17:58'!
setIsOnCIServer: aBoolean
	
	Smalltalk at: #OrcaIsOnCIServer put: aBoolean.! !

!OrcaTestCase methodsFor: 'private' stamp: 'srv 1/5/2011 11:09'!
timeoutForTest
	"remove test-timeout on the CI-server"
	
	^ self class isOnCIServer
		ifTrue: [ 15 * 60 * 1000 ]
		ifFalse: [ ^ super timeoutForTest ]! !

ProtoObject subclass: #Js
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Stubs'!

!Js commentStamp: 'ag 4/5/2011 17:21' prior: 0!
This is a place, where programmers can define global shortcuts to access or execute common functions with long names.
The superclass of this class is set to nil to remove unnecessary methods.
Code inside this class should be short and is pure client-side code.!

!Js class methodsFor: 'shortcuts' stamp: 'ag 4/5/2011 17:47'!
@ aString
	"This shortcuts calling the jQuery-$-function with one string as parameter.
	This is client-side code."
	
	^ (self Global perform: '$') value: aString! !

!Js class methodsFor: 'stubs' stamp: 'hk 4/5/2011 13:02'!
Document

	self clientSideResposibility.! !

!Js class methodsFor: 'stubs' stamp: 'hk 4/5/2011 13:03'!
Global

	self clientSideResposibility.! !

!Js class methodsFor: 'shortcuts' stamp: 'ag 4/5/2011 17:48'!
jit
	
	^ self Global perform: '$jit'! !

ProtoObject subclass: #OrcaFutureResult
	instanceVariableNames: 'computationCompleted result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-RemoteObjects'!

!OrcaFutureResult class methodsFor: 'instance creation' stamp: 'lw 4/5/2011 12:25'!
newFrom: aBlock

	^ self new
		xxxStartComputation: aBlock;
		yourself! !

!OrcaFutureResult methodsFor: 'error handling' stamp: 'lw 4/5/2011 12:19'!
doesNotUnderstand: aMessage

	computationCompleted wait.
	self become: result.
	^ aMessage sendTo: result.! !

!OrcaFutureResult methodsFor: 'error handling' stamp: 'lw 4/5/2011 12:24'!
initialize

	computationCompleted := Semaphore new.! !

!OrcaFutureResult methodsFor: 'error handling' stamp: 'lw 4/5/2011 12:51'!
xxxStartComputation: aBlock

	[ result := aBlock value.
	computationCompleted signal ] fork! !

ProtoObject subclass: #OrcaRemoteObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-RemoteObjects'!

!OrcaRemoteObject methodsFor: 'error handling' stamp: 'ag 4/6/2011 15:52'!
doesNotUnderstand: aMessage

	"Query on Client/Server and answer the result as a Future"
	"In order to reduce the selector footprint of this class, most selectors starts with xxx, alike the objectTracer"
	
	| aBlock aClient |
	aClient := nil.
	aBlock := [ aClient perform ].
	^ OrcaFutureResult newFrom: aBlock.! !

!ProtoObject methodsFor: '*Orca' stamp: 'sec 4/7/2011 09:05'!
definitionLine
	
	^ (OrcaSqueakAstToJsAst escapeReservedWordOrGlobal: self class name),
		'._newInstance()'! !

!ProtoObject methodsFor: '*Orca' stamp: 'ag 4/6/2011 15:52'!
fillInstVars: codeLines guardedBy: alreadySerialized
	
	self class allInstVarNames withIndexDo: [ :varName :i | | varValue |
		varValue := self instVarAt: i. "This really works :D"
		varValue serializeToJavaScript: codeLines guardedBy: alreadySerialized.
		codeLines addLast: 
			(alreadySerialized at: self), '.', (OrcaSqueakAstToJsAst jsInstVarNameFor: varName), 
			'=', (alreadySerialized at: varValue) ].! !

!ProtoObject methodsFor: '*Orca' stamp: 'ag 3/1/2011 18:07'!
serializeToJavaScript
	
	| code objectIds |
	code := OrderedCollection new.
	objectIds := Dictionary new.
	self serializeToJavaScript: code guardedBy: objectIds.
	code addLast: 'return ', (objectIds at: self).
	code := code separatedBy: ';'.
	^ '(function(){', code, ';})()'! !

!ProtoObject methodsFor: '*Orca' stamp: 'ag 3/31/2011 10:02'!
serializeToJavaScript: codeLines guardedBy: alreadySerialized
	
	(alreadySerialized includesKey: self) ifFalse: [
		alreadySerialized at: self put: 'obj', (alreadySerialized size + 1) asString.
		codeLines addFirst:  'var ', (alreadySerialized at: self), '=', self definitionLine.
		self fillInstVars: codeLines guardedBy: alreadySerialized ].! !

OrderedCollection subclass: #OrcaNode
	instanceVariableNames: 'name originalCode jsArgumentValue originalMethodName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaNode commentStamp: 'ag 11/18/2010 13:09' prior: 0!
This is only a named collection, that is supposed to hold further collections or strings to form a tree!

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:31'!
arguments
	
	^ self arguments: {}! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:26'!
arguments: aCollection
	
	^ self named: 'arguments' with: aCollection! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:59'!
array: aCollection

	^ self named: 'array' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:27'!
assignment: aCollection

	^ self named: 'assignment' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:15'!
binaryExpression: aCollection

	^ self named: 'binaryExpression' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:31'!
block

	^ self block: {}.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:26'!
block: aCollection

	^ self named: 'block' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'LT 2/24/2011 13:34:07.814'!
braceExpression: aCollection

	^ self named: 'braceExpression' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:37'!
byteArray: aCollection

	^ self named: 'byteArray' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:12'!
cascadedExpression: aCollection

	^ self named: 'cascadedExpression' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:05'!
character: aCharacter

	aCharacter isCharacter ifFalse: [ self error: 'need a Character' ].
	^ self named: 'character' with: { aCharacter }.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'LT 4/5/2011 13:50:00.746'!
comment: aString

	aString isString ifFalse: [ self error: 'need a String' ].
	^ self named: 'comment' with: { aString }! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'LT 4/5/2011 13:49:56.145'!
comments: anOrderedCollection

	^ self named: 'comments' with: anOrderedCollection! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/25/2011 13:57'!
expression

	^ self named: 'expression' with: {}.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:27'!
expression: aCollection

	^ self named: 'expression' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:27'!
functionCall: aCollection
	"aCollection = { receiver. aMessageNameString. argumentsNode }"
	
	^ self named: 'functionCall' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:27'!
functionContent: aCollection

	^ self named: 'functionContent' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:28'!
functionDeclaration: aCollection

	^ self named: 'functionDeclaration' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:28'!
identifier: aString

	aString isString ifFalse: [ self error: 'need a String' ].
	^ self named: 'identifier' with: { aString }.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'robi 3/22/2011 13:47'!
javaScriptMethod: aCollection
	"aCollection = { header. statements }"
	^ self named: 'javaScriptMethod' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:11'!
keywordExpression: aCollection

	^ self named: 'keywordExpression' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'robi 3/22/2011 13:48'!
method: aCollection
	"aCollection = { header. statements }"
	^ self named: 'method' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation' stamp: 'lw 2/22/2011 17:45'!
named: aString
	
	^ self named: aString with: {}! !

!OrcaNode class methodsFor: 'instance creation' stamp: 'ag 11/18/2010 13:08'!
named: aString with: anOrderedCollection
	
	^ self new
		name: aString;
		addAll: anOrderedCollection;
		yourself! !

!OrcaNode class methodsFor: 'instance creation' stamp: 'ag 11/18/2010 13:58'!
named: aString withoutNils: anOrderedCollection
	
	anOrderedCollection ifNil: [ ^ nil ].
	^ self
		named: aString
		with: (anOrderedCollection reject: [ :each | each isNil])! !

!OrcaNode class methodsFor: 'instance creation' stamp: 'ag 11/21/2010 19:15'!
named: aString withoutNilsNotEmpty: anOrderedCollection
	"Returns nil, if resulting node would be empty"
	
	| result |
	result := self named: aString withoutNils: anOrderedCollection.
	^ (result isNil or: [result isEmpty])
		ifTrue: [ nil ]
		ifFalse: [ result ]! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 19:05'!
newExpression: aCollection

	^ self named: 'newExpression' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:28'!
number: aNumber

	aNumber isNumber ifFalse: [ self error: 'need a Number' ].
	^ self named: 'number' with: { aNumber }.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'LT 2/24/2011 13:34:59.983'!
objectLiteral: aCollection

	^ self named: 'objectLiteral' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:51'!
paranthesizedExpression: aCollection

	^ self named: 'paranthesizedExpression' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:28'!
reservedWord: aString

	aString isString ifFalse: [ self error: 'need a String' ].
	^ self named: 'reservedWord' with: { aString }.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
returnExpression: aCollection

	^ self named: 'returnExpression' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
slotAccess: aCollection

	^ self named: 'slotAccess' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
slotAssignment: aCollection

	^ self named: 'slotAssignment' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:31'!
statements

	^ self statements: {}.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:24'!
statements: aCollection

	^ self named: 'statements' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
string: aString

	aString isString ifFalse: [ self error: 'need a String' ].
	^ self named: 'string' with: { aString }.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:06'!
symbol: aSymbol

	aSymbol isSymbol ifFalse: [ self error: 'need a Symbol' ].
	^ self named: 'symbol' with: { aSymbol }.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:32'!
temporaries
	
	^ self temporaries: {}! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:24'!
temporaries: aCollection
	
	^ self named: 'temporaries' with: aCollection! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:48'!
unaryExpression: aCollection

	^ self named: 'unaryExpression' with: aCollection.! !

!OrcaNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
variableDeclaration: aCollection

	^ self named: 'variableDeclaration' with: aCollection.! !

!OrcaNode methodsFor: 'comparing' stamp: 'ag 11/21/2010 19:19'!
= anObject
	
	^ super = anObject and: 
		[ name = anObject name ]! !

!OrcaNode methodsFor: 'adding' stamp: 'lw 4/5/2011 18:19'!
addAllWhitoutNils: aCollection
	
	aCollection do: [ :each | each ifNotNil: [self add: each]]
! !

!OrcaNode methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
includesChildNamed: aString
	
	^ self name = aString
		or: [ self anySatisfy: [ :node | 
			(node isKindOf: OrcaNode) and: [
			node includesChildNamed: aString ] ] ]! !

!OrcaNode methodsFor: 'testing' stamp: 'LT 12/1/2010 14:06:25.154'!
isArrayNode

	^ name = 'array' or: [name = 'byteArray' or: [name = 'braceExpression']]! !

!OrcaNode methodsFor: 'testing' stamp: 'LT 2/24/2011 13:54:04.347'!
isAssociationNode

	^ (self name = 'binaryExpression' and: [ (self at: 2) = #-> ])
	or: [ self name = 'expression' and: [ self size = 1 ] and: [ (self at: 1) isAssociationNode ]]! !

!OrcaNode methodsFor: 'accessing' stamp: 'ag 2/7/2011 19:20'!
jsArgumentValue
	^ jsArgumentValue! !

!OrcaNode methodsFor: 'accessing' stamp: 'ag 4/6/2011 18:11'!
jsArgumentValue: anOrcaNode
	"The ast-to-ast-step stores an additional info here: The value of this node, if it would act as a argument to a js-function-call.
	E.g. a number-literal is stored directly as a number-node here, without wrapping it as squeak-object and calling js() on it.
	This is important, as for boolean-value the js()-mechanism has been found to be non-functional!!"
	
	jsArgumentValue := anOrcaNode! !

!OrcaNode methodsFor: 'accessing' stamp: 'ag 1/25/2011 14:45'!
name
	
	^ name! !

!OrcaNode methodsFor: 'accessing' stamp: 'ag 1/25/2011 14:45'!
name: aString
	
	name := aString! !

!OrcaNode methodsFor: 'accessing' stamp: 'lw 3/28/2011 17:40'!
originalCode
	^ originalCode! !

!OrcaNode methodsFor: 'accessing' stamp: 'ag 1/19/2011 19:17'!
originalCode: anObject
	"This is only set on 'block'-nodes. Never mind. :-)"
	
	originalCode := anObject! !

!OrcaNode methodsFor: 'printing' stamp: 'ag 11/19/2010 00:39'!
printString
	
	| result first |
	first := true.
	result := name, ' ('.
	self do: [ :each |
		first ifTrue: [first := false] ifFalse: [result := result, ', '].
		result := result,  each printString].
	^ result, ')'! !

OMeta2 subclass: #OrcaOMeta2
	instanceVariableNames: 'currentMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

OrcaOMeta2 subclass: #OrcaAstReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

OrcaAstReader subclass: #OrcaAbstractPrinter
	instanceVariableNames: 'indentation'
	classVariableNames: 'ClassTextOutputStream JavascriptPrintStream TextOutputStream'
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaAbstractPrinter class methodsFor: 'converting' stamp: 'robi 1/17/2011 16:17'!
asJSString: aString
	"Use the squeak-library to encode the string.. if not found, use an easy escaping-algorithm."
	
	^ (aString respondsTo: #javascriptOn:)
		ifTrue: [
			JavascriptPrintStream ifNil: [ JavascriptPrintStream := TextStream on: '' ] ifNotNil: [ JavascriptPrintStream reset ].
			aString javascriptOn: JavascriptPrintStream.
			JavascriptPrintStream contents ]
		ifFalse: [ | tokens |
			tokens := aString findTokens: self jsEscapeChars keep: self jsEscapeChars.
			'"', (tokens inject: '' into: [ :all :each |
				all, 
				((self jsEscapeChars includes: each asCharacter) ifTrue: [ '\' ] ifFalse: [ '' ]), 
				each]), '"' ]! !

!OrcaAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/9/2011 20:23'!
convert: aBlock to: output
	
	aBlock value:
		output reset; yourself.
	^ output contents! !

!OrcaAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 1/5/2011 21:22'!
convertClass: aClass
	
	^ self
		convertClass: aClass
		retrievingFrom: [ :methodSelector |
			self convertCompiledMethod: methodSelector ]! !

!OrcaAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 4/6/2011 15:52'!
convertClass: aClass retrievingFrom: aBlock
	"Return the converted version of the whole class. aBlock takes one parameter (a CompiledMethod) and returns
	the code for the method as string. A static (reused) output-stream is used to print the code."
	
	^ self
		convert: [ :output | self convertClass: aClass to: output retrievingFrom: aBlock ]
		to: (TextOutputStream ifNil: [ TextOutputStream := OrcaTextStream for: self ])! !

!OrcaAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 4/11/2011 19:48'!
convertClass: aClass to: output retrievingFrom: aBlock
	
	| firstPrinted firstPrintedMemorizer |
	firstPrinted := false.
	firstPrintedMemorizer := [ :nextPartValid | nextPartValid and: [ firstPrinted or: [ firstPrinted := true. false ] ] ]. "Pretty complex. Remember, whether first line has been printed."
	output << 'Class(' << (self asJSString: (OrcaSqueakAstToJsAst escapeReservedWord: aClass)) << ',' << self space << '{' << self newline.
	self
		printPart: 'superclass' with: (self printSuperclass: aClass) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'instanceVariables' with: (self printVariables: aClass instVarNames) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'classInstanceVariables' with: (self printVariables: aClass class instVarNames) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'classVariables' with: (self printVariables: aClass classVarNames) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'classMethods' with: (self printMethodsOf: aClass class retrievingFrom: aBlock) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'instanceMethods' with: (self printMethodsOf: aClass retrievingFrom: aBlock) to: output guardedBy: firstPrintedMemorizer.
	output << self newline << '})'.! !

!OrcaAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 1/5/2011 19:59'!
convertClasses: anArrayOfClasses
	
	^ self
		convertClasses: anArrayOfClasses
		retrievingFrom: [ :class |
			self convertClass: class ]! !

!OrcaAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 4/6/2011 15:52'!
convertClasses: anArrayOfClasses retrievingFrom: aBlock
	"Return the code for all the classes in anArrayOfClasses. aBlock takes on parameter (a class) and returns the code for the class."
	
	^ self
		convert: [ :output | output << (self
							printEach: [ :class | aBlock value: class ]
							of: anArrayOfClasses
							separatedBy: (';', self newline))]
		to: (ClassTextOutputStream ifNil: [ ClassTextOutputStream := OrcaTextStream for: self ])! !

!OrcaAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 4/6/2011 15:52'!
doesNotUndestandClasswithMethods: aDictionaryOfMethodNames

	| cr functions crr |
	cr := self newline, self indentation.
	crr := cr, self indentation.
	functions := TextStream with: ''.
	aDictionaryOfMethodNames keysAndValuesDo: 
		[ :aSTFunctionCallName :aJSFunctionCallName | 
			functions << aJSFunctionCallName << ':' << self space << 'function(){' << crr << 
			'return this.doesNotUnderstand_(Message.selector_arguments_(string("' << aSTFunctionCallName << '"), array(_toArray(arguments)))); ' << '},' << crr].
	functions := functions contents.
	^ ((TextStream with: 'Class("') << OrcaAbstractCodeFactory doesNotUnderstandClass 
			<< '", {' << cr <<
		'instanceMethods: {' << cr <<
			self indentation << functions << cr <<
		'}, ' << cr <<
		'classMethods: {' << cr <<
			self indentation << functions << cr <<
		'}' << self newline << 
		'})' << self newline) contents! !

!OrcaAbstractPrinter class methodsFor: 'pretty-print' stamp: 'ag 1/5/2011 20:01'!
indentation
	
	self subclassResponsibility! !

!OrcaAbstractPrinter class methodsFor: 'converting' stamp: 'ag 4/6/2011 15:52'!
inputConverter

	^ OrcaSqueakAstToJsAst! !

!OrcaAbstractPrinter class methodsFor: 'converting' stamp: 'ag 1/17/2011 10:39'!
jsEscapeChars
	
	^ #($" $\)! !

!OrcaAbstractPrinter class methodsFor: 'pretty-print' stamp: 'ag 1/5/2011 20:01'!
newline
	
	self subclassResponsibility! !

!OrcaAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/10/2011 08:01'!
printEach: aBlock of: aCollection separatedBy: aString
	
	| result isFirst |
	isFirst := true.
	result := ''.
	aCollection do: [ :each | 
		isFirst
			ifTrue: [ isFirst := false ]
			ifFalse: [ result := result, aString ].
		result := result, (aBlock value: each)].
	^ result! !

!OrcaAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/10/2011 10:16'!
printMethodsOf: aClass retrievingFrom: aBlock
	
	| methods |
	methods := aClass methodDict values.
	^ methods 
		ifEmpty: [ false ]
		ifNotEmpty: [
			'{', self newline,
			(self
				printEach: [ :eachmethod | | code |
					code := aBlock value: eachmethod.
					self indentation, self indentation, code key, ':', self space, code value ]
				of: methods
				separatedBy: ',', self newline),
			self newline, self indentation, '}' ].! !

!OrcaAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/10/2011 10:43'!
printPart: aString with: aValue to: output guardedBy: aGuardBlock
	"Print a slot. If aValue is a String (should return false then), this is skipped.
	aGuardBlock is called with whether this part will be printed and returns, whether we have to prepend a colon + newline ('guards' whether we are the first line)."
	
	(aGuardBlock value: aValue isString)
		ifTrue: [ output << ',' << self newline ].
	aValue isString ifTrue: [
		output << self indentation << aString << ':' << self space << aValue ]! !

!OrcaAbstractPrinter class methodsFor: 'converting classes private' stamp: 'sec 4/7/2011 09:05'!
printSuperclass: aClass
	
	^ aClass superclass
		ifNil: [ OrcaAbstractCodeFactory doesNotUnderstandClass ]
		ifNotNil: [ OrcaSqueakAstToJsAst escapeReservedWordOrGlobal: aClass superclass name ]! !

!OrcaAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 4/6/2011 15:52'!
printVariables: aCollection
	"Print a collection containing all members of aCollection separated by colons"
	
	^ aCollection
		ifEmpty: [ false ]
		ifNotEmpty: [
			'[', self space,
			(self
				printEach: [ :each | '"', OrcaSqueakAstToJsAst escapeCharForIdentifier, each, '"' ]
				of: aCollection
				separatedBy: ',', self space),
			self space, ']' ]! !

!OrcaAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 1/10/2011 09:10'!
resetTextStreams
	"These helper-TextStreams are recreated lazily"
	
	ClassTextOutputStream := TextOutputStream := JavascriptPrintStream := nil.! !

!OrcaAbstractPrinter class methodsFor: 'pretty-print' stamp: 'ag 1/5/2011 20:01'!
space
	
	self subclassResponsibility! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
arguments =
	
	translate*:identifiers
	-> [ self functionParameters: identifiers ]! !

!OrcaAbstractPrinter methodsFor: 'translate tokens' stamp: 'lw 4/6/2011 17:59'!
array = 
	
	translateWith(#expressionBase)*:contents
	-> [ '[', (contents separatedBy: ', '), ']' ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
assignment =
	
	translate! !

!OrcaAbstractPrinter methodsFor: 'pretty print' stamp: 'lw 4/6/2011 17:59'!
cSpace
	
	^ self class space! !

!OrcaAbstractPrinter methodsFor: 'translate tokens' stamp: 'lw 4/6/2011 17:59'!
comment =
	
	^string:comment
	-> [ self createComment: comment ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
comments =
	
	translateNamed('comment')*:commentStrings
	-> [commentStrings
		ifNil: [''] 
		ifNotNil: 
			[commentStrings separatedBy: '']]! !

!OrcaAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
createComment: aString

	| result |
	self indent.
	result := TextStream with: ''.
	result << self indentation << '// '.
	aString do: 
			[ :each |
			each = Character cr
				ifTrue: [result << self newline << self indentation <<  '//']
				ifFalse: [
					each = Character lf
						ifFalse: [result << each]]].
	result << self newline.
	self unindent.
	^ result contents! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
expression =
	
	expressionBase:expr
	-> [ self indentation, expr ]! !

!OrcaAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
expression: anExpressionBodyString withAssignments: aStringCollection
	
	^ ((aStringCollection isNil or: [ aStringCollection isEmpty ])
			ifTrue: [ '' ]
			ifFalse: [
				(aStringCollection separatedBy: self cSpace, '=', self cSpace),
				self cSpace, '=', self cSpace ])
					, anExpressionBodyString! !

!OrcaAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
expression: anExpressionBodyString withAssignments: aStringCollection withComments: aStringOfComments
	
	^ (aStringOfComments ifNil: ['']),
		((aStringCollection isNil or: [ aStringCollection isEmpty ])
			ifTrue: [ '' ]
			ifFalse: [
				(aStringCollection separatedBy: self cSpace, '=', self cSpace),
				self cSpace, '=', self cSpace ])
					, anExpressionBodyString! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
expressionBase =
	
	translateNamed('comments')?:comments translate:expressionBody translate*:assignments
	-> [ self expression: expressionBody withAssignments: assignments withComments: comments ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
functionCall =
	// Can be either an invokation of a named function of an object OR an invokation of a anonymous function
	
	&anything:receiverNode (nil | translate):receiver (^string | translate):functionName translate:arguments
	-> [ self
			functionCall: functionName
			to: ((receiverNode notNil and: [ receiverNode name = 'functionDeclaration' ])
					ifTrue: [ '(', receiver, ')' ]
					ifFalse: [ receiver ] )
			withArguments: arguments ]! !

!OrcaAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
functionCall: aFunctionNameOrDeclarationString to: aReceiverString withArguments: anArgumentsString
	
	| function |
	function := (aFunctionNameOrDeclarationString startsWith: 'function') "no test yet, necessary?"
		ifTrue: ['(', aFunctionNameOrDeclarationString, ')'] 
		ifFalse: [ aFunctionNameOrDeclarationString].
	
	^ (aReceiverString
		ifNotNil: [ aReceiverString, '.' ]
		ifNil: [ '' ]), function, anArgumentsString! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
functionContent =
	// This is intentionally not named 'statements', to deny all nested statements-nodes
	// The ast-to-ast step must flatten all statements into one list of expressions here
	
	[ self indent ]
	translate*:expressions
	[ self unindent ]
	-> [ expressions separatedBy: ';', self newline ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
functionDeclaration =
	
	translate:arguments
	translate:statements
	-> [ self functionDeclaration: arguments withBody: statements ]! !

!OrcaAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
functionDeclaration: aParameterString withBody: aStatementsString
	"aParameterString already contains the parantheses; #functionParameters: should be used."
	
	^ 'function', self cSpace, aParameterString, self cSpace, '{', self newline,
			(aStatementsString ifEmpty: [ '' ] ifNotEmpty: [ aStatementsString, ';' ]),
		self newline, self indentation, '}'! !

!OrcaAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
functionDeclaration: aParameterString withComment: aCommentString withBody: aStatementsString

	"aParameterString already contains the parantheses; #functionParameters: should be used."
	^ 'function', self cSpace, aParameterString, self cSpace, '{', self newline,
			(aCommentString ifNil: [ '' ]),
			(aStatementsString ifEmpty: [ '' ] ifNotEmpty: [ aStatementsString, ';' ]),
		self newline, self indentation, '}'! !

!OrcaAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
functionParameters: aStringCollection

	^ '(', ((aStringCollection collect: [ :aString | aString trimLeft ]) separatedBy: ', '), ')'! !

!OrcaAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
hasSelector: aSymbol
	"Adding the superclass method dictionary to the searcharea for matching methods is required because the printers don't implement all the methods on their own"
	
	^ ((super hasSelector: aSymbol) or: [ self class superclass includesSelector: aSymbol ])
		ifTrue: [ true ]
		ifFalse: [ self error: 'Unknown selector: ', aSymbol asString. false ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
header =
	
	^string:functionName arguments:arguments
	-> [ functionName -> arguments ]! !

!OrcaAbstractPrinter methodsFor: 'translate tokens' stamp: 'lw 4/6/2011 17:59'!
identifier =
	
	^string:identifier
	-> [ identifier ]! !

!OrcaAbstractPrinter methodsFor: 'pretty print' stamp: 'lw 4/6/2011 17:59'!
indent
	
	self indentation: self indentation, self class indentation! !

!OrcaAbstractPrinter methodsFor: 'accessing' stamp: 'lw 4/6/2011 17:59'!
indentation
	^ indentation! !

!OrcaAbstractPrinter methodsFor: 'accessing' stamp: 'lw 4/6/2011 17:59'!
indentation: anObject
	indentation := anObject! !

!OrcaAbstractPrinter methodsFor: 'initialization' stamp: 'lw 4/6/2011 17:59'!
initialize

	super initialize.
	self 
		indentation: ''.! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
javaScriptMethod =
	// This does not return a string, but an association from the method-name to the method-declaration
	
	translate:functionNameAndArguments
	translate:statements
	-> [ functionNameAndArguments key -> 
		(self
			functionDeclaration: functionNameAndArguments value
			withBody: statements) ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
method =
	// This does not return a string, but an association from the method-name to the method-declaration
	
	translate:functionNameAndArguments
	translateNamed('comments')?:comment
	translate:statements
	-> [ functionNameAndArguments key -> 
		(self
			functionDeclaration: functionNameAndArguments value
			withComment: comment
			withBody: statements) ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
newExpression =
	
	// Here is a function-call, which is handled a little bit differently. Code copied from functionCall.
	
	{ &anything:receiverNode (nil | translate):receiver (^string | translate):functionName translate:arguments }
	-> [ 'new (', (self
			functionCall: functionName, ')'
			to: ((receiverNode notNil and: [ receiverNode name = 'functionDeclaration' ])
					ifTrue: [ '(', receiver, ')' ]
					ifFalse: [ receiver ] )
			withArguments: arguments) ]! !

!OrcaAbstractPrinter methodsFor: 'pretty print' stamp: 'lw 4/6/2011 17:59'!
newline
	
	^ self class newline! !

!OrcaAbstractPrinter methodsFor: 'translate tokens' stamp: 'lw 4/6/2011 17:59'!
number =
	
	^number:number
	-> [ number asString ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
objectLiteral =

	translateNamed(#slotAssignment)*:result
	-> [ '{', (result separatedBy: ',', self cSpace) , '}' ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
paranthesizedExpression =
	
	expressionBase:value
	-> [ '(', value, ')' ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
reservedWord =
	
	^string! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
returnExpression =
	
	expressionBase:expr
	-> [ self indentation, 'return ', expr ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
slotAccess =
	
	(nil | translate):object ^symbol:slotName
	-> [ (object ifNotNil: [ object, '.' ] ifNil: [ '' ]), slotName asString ]! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
slotAssignment =
	
	^symbol:slotname translate:value
	-> [  slotname, self cSpace, ':', self cSpace, value ]! !

!OrcaAbstractPrinter methodsFor: 'translate tokens' stamp: 'lw 4/6/2011 17:59'!
string =
	
	^string:string
	-> [ self class asJSString: string ]! !

!OrcaAbstractPrinter methodsFor: 'pretty print' stamp: 'lw 4/6/2011 17:59'!
unindent
	
	self indentation: (self indentation allButLast: self class indentation size)! !

!OrcaAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/6/2011 17:59'!
variableDeclaration =
	
	translateNamed('identifier')+:variableNames translateNamed('assignment')?:assignment
	-> [ self variableDeclaration: variableNames withAssignment: assignment ]! !

!OrcaAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
variableDeclaration: variableNames withAssignment: assignment
	"Acts as an expression, not terminated by a semi colon"
	
	| oneVar firstLine |
	firstLine := self indentation, 'var ', ((oneVar := variableNames size = 1)
		ifTrue: [ variableNames first ]
		ifFalse: [ (variableNames separatedBy: ';', self cSpace, 'var ')]).
	^ assignment 
		ifNil: [ firstLine ]
		ifNotNil: [
			oneVar
				ifTrue: [ self expression: assignment withAssignments: { firstLine } ]
				ifFalse: [ 
					firstLine, ';', self newline, self indentation, (self expression: assignment withAssignments: variableNames) ]]! !

OrcaAbstractPrinter subclass: #OrcaPrettyPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaPrettyPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:37'!
indentation

	^ '    '! !

!OrcaPrettyPrinter class methodsFor: 'pretty-print' stamp: 'sec 3/2/2011 16:08'!
newline
	
	^ Character lf asString! !

!OrcaPrettyPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:37'!
space

	^ ' '! !

!OrcaPrettyPrinter methodsFor: 'initialization' stamp: 'lw 4/6/2011 17:59'!
initialize
	"Do everything indented x2 from the start, to have json-like pretty-print for the whole js-file."
	
	super initialize.
	self
		indent;
		indent.! !

OrcaAbstractPrinter subclass: #OrcaPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:37'!
indentation

	^ ''! !

!OrcaPrinter class methodsFor: 'pretty-print' stamp: 'ag 1/5/2011 20:02'!
newline
	
	^ ''! !

!OrcaPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:30'!
space

	^ ''! !

!OrcaAstReader class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:20'!
applyRule: aRule on: aMatcher
	
	^ super applyRule: #translate on: aMatcher! !

!OrcaAstReader class methodsFor: 'converting private' stamp: 'ag 4/6/2011 18:12'!
convertAst: anOrcaNodeTree

	| matcher result |
	matcher := self matcherOn: {anOrcaNodeTree} readStream.
	matcher currentMethod: nil.
	result := self applyRule: #translate on: matcher.
	^ result! !

!OrcaAstReader class methodsFor: 'converting private' stamp: 'lw 3/28/2011 17:50'!
createInputFrom: aString as: aRule insideMethod: aCompiledMethod
	
	| input |
	input := (self inputConverter convert: aString as: aRule insideMethod: aCompiledMethod).
	" The outermost node is alike an expression or statements node. Because OMeta uses this first node to iterate over, it's node name is not base for translation: it will be consumed without effect and therefore lost. To not lose any nodes, we add a generic one."
	input value: { input value }. 
	^ input! !

!OrcaAstReader class methodsFor: 'converting private' stamp: 'ag 12/8/2010 22:13'!
inputConverter
	"An AstReader should know, which converter-class can provide the ast wants to read"
	
	self subclassResponsibility! !

!OrcaAstReader methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
hasSelector: aSymbol
	"Offers a hook to catch, if an unknown node occurs"
	
	^ self class includesSelector: aSymbol! !

!OrcaAstReader methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
translate =
	// Translate the next node using it's name as rule
	
	translateNamed(nil)! !

!OrcaAstReader methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
translateNamed :nodeName =
	// Assert, that the next node has the name nodeName and translate it using it's name as rule
	
	translateNamedWith(nodeName. nodeName)! !

!OrcaAstReader methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
translateNamedWith :nodeName :targetRule =
	// Assert, that the next node has the name nodeName and translate it with targetRule
	
	translateNamedWithArgument(nodeName. targetRule. nil)! !

!OrcaAstReader methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
translateNamedWithArgument :nodeName :targetRule :argument =
	// Assert, that the next node has the name nodeName, use targetRule to convert the node and pass argument when calling targetRule
	
	// Lookahead for one node
	&anything:node
	
	// Some assertions, e.g. about the nodeName
	?[ node class = OrcaNode ]
	?[ nodeName isNil | (node name = nodeName )]
	[ targetRule ifNil: [ node name asSymbol ] ifNotNil: [ targetRule asSymbol ]]:appliedRule
	?[ self hasSelector: appliedRule ]
	
	// If an argument is given, call the targetRule with that argument. Else, call the targetRule without arguments
	(( ?[ argument notNil ] { apply(appliedRule. argument):result } )
	| { apply(appliedRule):result })
	
	// Return the parsed content of the node
	-> [ result ]! !

!OrcaAstReader methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
translateWith :aRule =
	// Translate the next node with aRule, regardless of it's name
	
	translateNamedWith(nil. aRule)! !

!OrcaAstReader methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
translateWithArgument :aRule :argument =
	// Translate the next node with aRule, regardless of it's name, and pass aRule the argument
	
	translateNamedWithArgument(nil. aRule. argument)! !

OrcaAstReader subclass: #OrcaAstToAst
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaAstToAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
passThroughAndTranslate =
	
	// TODO add all primitive values?..
	
	^symbol
|	string
|	number
|	char
|	nil
	
|	({ translate*:children }:node
	-> [ OrcaNode named: node name with: children ])! !

!OrcaAstToAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
renameTo :nodeName =
	
	translate*:contents
	-> [ OrcaNode named: nodeName with: contents ]! !

!OrcaAstToAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
translate = 
	
	^translate
|	passThroughAndTranslate! !

OrcaAstToAst subclass: #OrcaJsAstOptimizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaJsAstOptimizer class methodsFor: 'converting' stamp: 'ag 4/6/2011 18:12'!
inputConverter
	
	self error: 'The Js-Ast-Optimizer is not yet functional!!'.
	^ OrcaSqueakAstToJsAst! !

!OrcaJsAstOptimizer methodsFor: 'convert special cases' stamp: 'lw 4/6/2011 17:59'!
forLoop =
	// Special case of keywordExpression
	

	translate:receiver symbol:selector translate*:arguments
	?[ selector = #do: ]
	?[ arguments size = 1 ]
	[ arguments first ]:block
	?[ block size >= 1 ]
	?[ block first name = 'arguments' ]
	?[ block first size = 1 ]
	-> [ self forLoopOver: receiver do: block ]! !

!OrcaJsAstOptimizer methodsFor: 'convert special cases' stamp: 'lw 4/6/2011 17:59'!
forLoopOver: anArrayNode do: aBlockNode

	| arrayName statements aStatementsNode aTemporariesNode loopVariableName |
	arrayName := 'arr$'.
	loopVariableName := aBlockNode first first.
	aStatementsNode := aBlockNode detect: [:each | each name = 'statements'] ifNone: [ nil ].
	aTemporariesNode := aBlockNode detect: [:each | each name = 'temporaries'] ifNone: [ nil ].
	aStatementsNode ifNotNil: [ statements := self apply: #translate withArgs: aStatementsNode].
	^ OrcaNode statements:
		{OrcaNode variableDeclaration:
			{OrcaNode identifier: arrayName.
			  OrcaNode expression: anArrayNode}.
		 OrcaNode forLoop:
			{OrcaNode identifier: arrayName.
			loopVariableName.
			aTemporariesNode.
			statements}}! !

!OrcaJsAstOptimizer methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
keywordExpression = 
	
	forLoop
|	messageSendExpression // ...not correct ...
! !

OrcaAstToAst subclass: #OrcaSqueakAstToJsAst
	instanceVariableNames: 'calledFunctions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OrcaSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 4/11/2011 16:06'!
arrayFunction
	
	^ self prefixForGlobals, 'array'! !

!OrcaSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 4/11/2011 16:06'!
blockFunction
	
	^ self prefixForGlobals, 'block'! !

!OrcaSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 4/11/2011 16:10'!
charFunction
	
	^ self prefixForGlobals, 'char'! !

!OrcaSqueakAstToJsAst class methodsFor: 'escaping' stamp: 'robi 1/4/2011 15:21'!
escapeCharForIdentifier
	
	^ '$'! !

!OrcaSqueakAstToJsAst class methodsFor: 'escaping' stamp: 'robi 1/4/2011 15:21'!
escapeCharForMethod
	
	^ '_'! !

!OrcaSqueakAstToJsAst class methodsFor: 'escaping' stamp: 'ag 4/11/2011 20:07'!
escapeReservedWord: aStringOrSymbol
	
	aStringOrSymbol ifNil: [ ^nil ].
	^ ((self jsReservedWords includes: aStringOrSymbol asString)
		ifTrue: [ self escapeCharForMethod ]
		ifFalse: [ '' ]), aStringOrSymbol asString! !

!OrcaSqueakAstToJsAst class methodsFor: 'escaping' stamp: 'ag 4/11/2011 16:01'!
escapeReservedWordOrGlobal: aStringOrSymbol
	
	^
	((aStringOrSymbol asString first isUppercase
	or: [#('true' 'false' 'nil') includes: aStringOrSymbol asString])
		ifTrue: [ self prefixForGlobals ]
		ifFalse: [ '' ]),
			(self escapeReservedWord: aStringOrSymbol).! !

!OrcaSqueakAstToJsAst class methodsFor: 'converting' stamp: 'LT 3/1/2011 10:10:30.562'!
ignoredPrimitives
	"This returns an array of CompiledMethod. All primitive-declarations in these methods are ignored.
	This means, these methods must have a correct software-fallback-implementation."
	
	^ {
	self method: #@ of: Number.
	self method: #replaceFrom:to:with:startingAt: of: String.
	self method: #replaceFrom:to:with:startingAt: of: Symbol.
	self method: #replaceFrom:to:with:startingAt: of: Array.
	self method: #replaceFrom:to:with:startingAt: of: ByteString.
	self method: #atEnd of: PositionableStream.
	self method: #next of: ReadStream.
	self method: #species of: Object
	}! !

!OrcaSqueakAstToJsAst class methodsFor: 'converting' stamp: 'ag 4/6/2011 15:52'!
inputConverter
	
	^ OrcaParser! !

!OrcaSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 3/29/2011 10:27'!
isKeywordLiteral: aString

	^ { 'true'. 'false' } includes: aString! !

!OrcaSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 1/5/2011 09:43'!
jsFunctionNameFor: aStringOrSymbol
	
	| result |
	result := ''.
	aStringOrSymbol asString do: [ :each | | jsIdentifier |
		jsIdentifier := self squeakCharacterToJsIdentifier at: each ifAbsent: [each asString].
		result := result, jsIdentifier].
	^ self escapeReservedWord: result! !

!OrcaSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'sec 4/7/2011 09:05'!
jsIdentifierFor: aString inMethod: aCompiledMethod
	"Escape reserved js-words and instance variables."
	
	^ (aCompiledMethod notNil and: [ aCompiledMethod methodClass allInstVarNames includes: aString ])
			ifTrue: [
				OrcaNode named: 'slotAccess' with: { 
					OrcaNode named: 'reservedWord' with: { 'this' }. 
					(self jsInstVarNameFor: aString) asSymbol } ]
			ifFalse: [	
				OrcaNode named: 'identifier' with: { self escapeReservedWordOrGlobal: aString } ]! !

!OrcaSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 3/29/2011 10:46'!
jsInstVarNameFor: aString
	
	^ self escapeCharForIdentifier asString, aString! !

!OrcaSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'sec 4/7/2011 09:05'!
jsKeywordFor: aString
	"thisContext is not covered, just a stub leading to a not-defined-error.
	The returned association maps from the literal evaluating to the squeak-object to the literal evaluating to the underlying js-object."
	
	^ aString
		caseOf: {
			[ 'self' ] -> [ 'this' -> 'this' ].
			[ 'true' ] -> [ (self escapeReservedWordOrGlobal: 'true') -> 'true' ].
			[ 'false' ] -> [ (self escapeReservedWordOrGlobal: 'false') -> 'false' ].
			[ 'nil' ] -> [ 'nil' -> 'null' ].
			"In Squeak, using super as identifier (e.g. a := super. ) without calling functions on it, seems to have the same effect as using self."
			"Calling super-functions is not handled here"
			[ 'super' ] -> [ 'this' -> 'this' ].
			"thisContext is not implemented in any way"
			[ 'thisContext' ] -> [ 'THIS_CONTEXT' -> 'THIS_CONTEXT' ].
		}
		otherwise: [ self error: 'Cannot translate keyword to JS: ', aString ]! !

!OrcaSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 4/11/2011 16:03'!
jsReservedWords
	"http://javascript.about.com/library/blreserved.htm"
	
	^ #('abstract' 'as' 'boolean' 'break' 'byte' 'case' 'catch' 'char' 'class' 'continue' 'const' 'debugger' 'default' 'delete' 'do' 'double' 'else' 'enum' 'export' 'extends' 'final' 'finally' 'float' 'for' 'function' 'goto' 'if' 'implements' 'import' 'in' 'instanceof' 'int' 'interface' 'is' 'long' 'namespace' 'native' 'new' 'null' 'package' 'private' 'protected' 'public' 'return' 'short' 'static' 'super' 'switch' 'synchronized' 'this' 'throw' 'throws' 'transient' 'try' 'typeof' 'use' 'var' 'void' 'volatile' 'while' 'with' 'arguments'
	) 
	asOrderedCollection
		add: self namespaceForGlobals;
		yourself! !

!OrcaSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 4/11/2011 16:01'!
namespaceForGlobals

	^ 'st'! !

!OrcaSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 4/11/2011 16:09'!
nonLocalReturnFunction
	
	^ self prefixForGlobals, 'nonLocalReturn'! !

!OrcaSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 4/11/2011 16:06'!
numberFunction
	
	^ self prefixForGlobals, 'number'! !

!OrcaSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 4/11/2011 16:01'!
prefixForGlobals

	^ self namespaceForGlobals, '.'! !

!OrcaSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 4/11/2011 16:06'!
primitiveCallFunction
	
	^ self prefixForGlobals, 'primitiveDeclaration'! !

!OrcaSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'lw 2/17/2011 16:33'!
squeakCharacterToJsIdentifier
	"Several characters can be used for selectors in squeak but
	are not allowed for JavaScript functionname"
	
	"TODO check, if one of these might be a reserved word (would cause conflicts with unary message named that way). Builds exception-rule."
	
	^ (Dictionary newFrom:
		{$: -> ''.  
		$+ -> 'plus'.
		$- -> 'minus'.
		$* -> 'times'.
		$/ ->  'slash'.
		$\ -> 'backslash'.
		$~ -> 'tilde'.
		$< ->  'less'.
		$> -> 'greater'.
		$= -> 'equals'.
		$@ -> 'at'.
		$% -> 'percent'.
		$& -> 'and'.
		$? -> 'question'.
		$!! -> 'exclamation'.
		$` -> 'backtick'.
		$, -> 'comma'.
		$ -> 'plusminus'.
		$| -> 'pipe'})
			collect: [ :string | self escapeCharForMethod, string ]! !

!OrcaSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 4/11/2011 16:01'!
stringFunction
	
	^ self prefixForGlobals, 'string'! !

!OrcaSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 4/11/2011 16:05'!
superFunction
	
	^ self prefixForGlobals, 'super'! !

!OrcaSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 4/11/2011 16:23'!
unboxSlotObjectFunction
	
	^ self prefixForGlobals, 'unboxSlotObject'! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
addReturnExpression: statements
	
	(statements isEmpty or: [(statements last name = 'returnExpression') not])
		ifTrue: [
			statements add: (OrcaNode returnExpression: { OrcaNode reservedWord: 'this' })].! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
arguments =
	
	renameTo('arguments')! !

!OrcaSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 4/6/2011 17:59'!
array =
	// Pack inner nodes in expression-nodes
	
	translate*:elements
	arrayBase(elements collect: [ :each | OrcaNode expression: { each }])! !

!OrcaSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
arrayBase :collection =
	
	wrapAsPrimitive(
		self class arrayFunction.
		'array'.
		collection)! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
binaryExpression =
	
	messageSendExpression! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
block =
	
	translateNamed('arguments')?:arguments
	methodContent:statements
	
	// All return-statements in the block are nonlocal returns. After that, the last expression into a return-expression like in a method.
	// Nonlocal returns are function calls in JS: nonLocalReturn()
	[ self renameNonLocalReturns: statements ]
	renameLastExpression(statements)
	
	[OrcaNode named: 'functionDeclaration' withoutNils: 
		{( arguments 
			ifNotNil: [ arguments ] 
			ifNil: [ OrcaNode arguments ] ).
		statements }]:blockContent
	
	-> [(OrcaNode functionCall: 
		{ nil.
		self class blockFunction.
		OrcaNode arguments: {blockContent}}) ]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
braceExpression =
	// take the contents of the expression as it's js-arg-value. In a brace-expression, there is no assigment.
	
	translate*:expressions
	[ expressions do: [ :each | each first jsArgumentValue ifNotNil: [ each jsArgumentValue: each first jsArgumentValue ] ] ]
	arrayBase(expressions)! !

!OrcaSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 4/6/2011 17:59'!
byteArray =
	
	array! !

!OrcaSqueakAstToJsAst methodsFor: 'accessing' stamp: 'lw 4/6/2011 17:59'!
calledFunctionNamesAt: aStringOrSymbol put: anotherStringOrSymbol

	(aStringOrSymbol isString or: [ aStringOrSymbol isSymbol ]) ifTrue: [ ^ self calledFunctions at: aStringOrSymbol asSymbol put: anotherStringOrSymbol asSymbol ]! !

!OrcaSqueakAstToJsAst methodsFor: 'accessing' stamp: 'lw 4/6/2011 17:59'!
calledFunctions
	^ calledFunctions! !

!OrcaSqueakAstToJsAst methodsFor: 'accessing' stamp: 'lw 4/6/2011 17:59'!
calledFunctions: anObject
	calledFunctions := anObject! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
cascadeReceiver
	
	^ OrcaNode identifier: ('cascadeReceiver', self class escapeCharForIdentifier)! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
cascadedExpression =
	
	translate:receiver
	translateWithArgument(#keywordExpression. self cascadeReceiver)*:functions
	-> [ self cascadedExpression: functions to: receiver ]! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
cascadedExpression: functions to: receiver
	"The statements-node created here is later flattened into one flat list of expressions."
	
	| statements |
	statements := OrcaNode functionDeclaration:
		{ OrcaNode arguments. 
		OrcaNode functionContent: 
			{ OrcaNode variableDeclaration: 
				{ self cascadeReceiver. 
				OrcaNode assignment: { receiver }}}}.
	functions do: [ :each | statements last add: (self expression: (OrcaNode expression) add: each)].
	statements last last name: 'returnExpression'.
	^ self
		functionCall: 'apply'
		to: statements
		withArguments: { OrcaNode reservedWord: 'this' }! !

!OrcaSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 4/6/2011 17:59'!
character =
	
	char:char
	wrapAsPrimitive(self class charFunction. 'string'. char asString) // the 'string' here is the node inside the character()-function call. The Printer does not know about characters.
	! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
checkSingleArgumentSelector: aSymbol
	"Answer, whether aSymbol is a selector for a keyword-message with one argument.
	aSymbol is already is keyword-selector.
	TODO Please implement a better way to do this."
	
	| tokens |
	tokens := aSymbol findTokens: $:.
	^ tokens size = 1 and: [ tokens first = (aSymbol asString subStrings: ':') first ]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
comment =
	//Neccessary to avoid packing String into calls to the string-wrapper function
	^string:string
	
	-> [ OrcaNode comment: string asString ]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
comments =
	
	anything:comments
	?[ comments name = 'comments' ]
	(?[comments isEmpty] -> [nil]
|	-> [ comments ])
	! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
doItSnippet =
	// No need to turn the last expression into a returnExpression, like in a method
	
	methodContent! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
expression =

	comments?:comments
	translate*:nodes
	->[ (comments
			ifNil: [ nodes ]
			ifNotNil: [ {comments}, nodes  ])
		inject: OrcaNode expression 
		into: [ :newCollection :each | self expression: newCollection add: each ]]! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
expression: newCollection add: each
	"kein double dispatch, da Nodes namen haben und nicht nach klassen aufgeteilt sind."
	
	each name = 'returnExpression'
		ifTrue: 
			[ ^each ].
	each name = 'expression'
		ifTrue: 
			[ ^ newCollection 
				addAllLast: each;
				yourself ].
	^ newCollection 
		addLast: each; 
		yourself ! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 4/11/2011 20:05'!
functionCall: selector to: receiver withArguments: arguments
	"In case of a super-call: the functionName is a _super-function-call itself: _super('field')() "
	
	| functionName |
	functionName := selector isString ifTrue: [ self class jsFunctionNameFor: selector ] ifFalse: [ selector ].
	^ OrcaNode functionCall: {
		receiver.
		functionName.
		OrcaNode arguments: arguments }.
	
	! !

!OrcaSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 4/6/2011 17:59'!
identifier =
	
	^string:name
	-> [ self class jsIdentifierFor: name inMethod: self currentMethod ]! !

!OrcaSqueakAstToJsAst methodsFor: 'initialization' stamp: 'lw 4/6/2011 17:59'!
initialize

	super initialize.
	self calledFunctions: Dictionary new.! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 4/11/2011 15:46'!
keywordExpression =

	messageSendExpression! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
messagePattern =
	
	^symbol:selector translate*:arguments
	-> [ OrcaNode named: 'header' with: { self class jsFunctionNameFor: selector }, arguments ]! !

!OrcaSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'ag 4/11/2011 20:06'!
messageSendExpression =
	
	superCall
	
|	(translate:receiver ^symbol:selector translate*:arguments
	
	// TODO refactor; copied from #functionCall:to:withArguments:
	[ 
	self calledFunctionNamesAt: selector put: 
			(selector isString ifTrue: [ self class jsFunctionNameFor: selector ] ifFalse: [ selector ]) ]
	
	-> [ self functionCall: selector to: receiver withArguments: arguments ])! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
method =
	
	translateWith(#messagePattern):header
	comments?:comments
	methodContent:statements
	[ self addReturnExpression: statements ]
	
	-> [ OrcaNode named: 'method' withoutNils: { header. comments. statements }]! !

!OrcaSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
methodContent  =
	// This can also be used in a place, where primitive-declarations are not allowed: the parser already handles that correctly
	// This flattens all expressions (cascaded expressions in the first place) into one flat collection of expressions

	translateNamed('temporaries')?:temporaries
	translateNamed('primitiveDeclaration')*:primitives
	translate?:statements
	-> [ self statements: statements withTemps: temporaries andPrimitives: primitives ]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 4/6/2011 17:59'!
number =
	// Number-literals are packed into a 'primitive' number-function-call
	
	^number:number
	wrapAsPrimitive(self class numberFunction. 'number'. number)! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
paranthesizedExpression =
	// I just found this method empty (without comment), don't really remember, why this works, but it does.
	
	translate:content
	-> [ content
		jsArgumentValue: content jsArgumentValue;
		yourself ]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
primitiveDeclaration =
	// Some primitive-declarations are just ignored, because the software implementation is perfectly fine.
	
	(?[ self class ignoredPrimitives includes: self currentMethod ]
	anything*
	-> [ nil ])
|	
	(anything // ignored for now. No need to remember the primitive-number, the js-implementation will know which method this is in
	-> [ OrcaNode expression:
		{ self functionCall: self class primitiveCallFunction to: nil withArguments: {} } ])! !

!OrcaSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
renameLastExpression :statements =
	
	[ statements ifNotEmpty: [ 
		(statements last name = 'expression'
			and: [statements last first name = 'functionCall']
				and: [statements last first second = 'nonLocalReturn'])
		 			ifFalse: [ statements last name: 'returnExpression' ] ] ]! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 4/11/2011 16:12'!
renameNonLocalReturns: statements
	
	^ statements doWithIndex: [ :st :index |
		st name = 'returnExpression' 
			ifTrue: [ | contents |
				st name: 'expression'.
				contents := st first.
				st removeAll; add: (
					self
						functionCall: self class nonLocalReturnFunction
						to: nil
						withArguments: { contents }) ]]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 4/6/2011 17:59'!
reservedWord =
	
	^string:keyword
	[ self class jsKeywordFor: keyword ]:jsAndSqueakKeyword
	-> [ self reservedWordNodeFor: jsAndSqueakKeyword ]! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
reservedWordNodeFor: anAssociation
	
	| result |
	result := OrcaNode reservedWord: anAssociation key.
	(self class isKeywordLiteral: anAssociation value) 
		ifTrue: [
			result jsArgumentValue: (OrcaNode reservedWord: anAssociation value)].
	^ result! !

!OrcaSqueakAstToJsAst methodsFor: 'accessing' stamp: 'lw 4/6/2011 17:59'!
returnExpression =

	comments?:comment
	translate*:nodes
	-> [ OrcaNode returnExpression: nodes ]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'lw 4/6/2011 17:59'!
serverBlock =
	
	&anything:block
	translateNamed('block') ^symbol:selector
	?[ selector = #onServer ]
	-> [ self
		functionCall: 'serverBlock'
		to: nil
		withArguments: { OrcaNode string: block originalCode } ]! !

!OrcaSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
statements: aNode withTemps: anElement andPrimitives: anElementCollection
	"All nils in the primitives-collection are removed (can occur, see #primitiveDeclaration)"
	
	| result |
	result := aNode ifNil: [ OrcaNode statements ] ifNotNil: [ aNode ].
	anElement ifNotNil: [ result addFirst: anElement; yourself ].
	anElementCollection ifNotNil: [
		result addAllFirst: (anElementCollection reject: [ :each | each isNil ]); yourself ].

	^ result name: 'functionContent'; yourself! !

!OrcaSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 4/6/2011 17:59'!
string =
	// String/Symbol-literals are packed into a 'primitive' string-function-call
	
	^string:string // Also covers symbols
	wrapAsPrimitive(self class stringFunction. 'string'. string asString)! !

!OrcaSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'lw 4/6/2011 17:59'!
superCall =
	// An exception to a message-send-expression: super-calls are translated in this way.
	
	{ ^string:superKeyword }:superNode ^symbol:selector translate*:arguments
	?[ superNode name = 'reservedWord' & superKeyword = 'super' ]
	-> [ 
		self
			functionCall: 
				(self
					functionCall: self class superFunction
					to: nil
					withArguments: { OrcaNode string: (self class jsFunctionNameFor: selector asString) })
			to: nil
			withArguments: arguments ]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 4/6/2011 17:59'!
symbol =
	
	string! !

!OrcaSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 4/6/2011 17:59'!
symbolNode =
	
	^anything:symbolNode
	?[ symbolNode name  = 'symbol']
	-> [symbolNode at: 1]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
temporaries =
	
	renameTo('variableDeclaration'):temporaries
	[ temporaries ifEmpty: [ nil ] ifNotEmpty: [ temporaries ] ]! !

!OrcaSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/6/2011 17:59'!
unaryExpression =

	serverBlock // [ 'a + b' ] onServer value   -->   onServer("a + b").value()
|	messageSendExpression! !

!OrcaSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'lw 4/6/2011 17:59'!
wrapAsPrimitive :functionName :nodeName :wrappedObject =
	// Wrap an object into a node, that will result in a function-call to functionName with the object as argument
	
	[ OrcaNode
		named: nodeName
		with: ( wrappedObject isCollection & wrappedObject isString not
			ifTrue: [ wrappedObject ]
			ifFalse: [ { wrappedObject } ]) ]:primitiveObject
	[ self
		functionCall: functionName
		to: nil
		withArguments: { primitiveObject } ]:result
	
	-> [ result
		jsArgumentValue: primitiveObject;
		yourself ]! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'ag 2/1/2011 10:34'!
allMethodsDo: aBlock
	"Execute aBlock with each parsable method in the image and return the sum of visited methods and classes."
	
	| numberOfObjects |
	numberOfObjects := 0.
	Smalltalk allClasses do: [ :eachClass |
		eachClass methodDict notEmpty  ifTrue: [
			numberOfObjects := numberOfObjects + 1.
			eachClass methodDict do: [ :eachMethod |
				numberOfObjects := numberOfObjects + 1.
				aBlock value: eachMethod ]]].
	^ numberOfObjects! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/15/2010 16:25'!
allMethodsDoAndReport: aBlock
	"Execute aBlock for each method in the image, print which methods have failed
	and notify each 500 methods. Print status-report at the end."
	
	| converted succeeded total |
	converted := -1.
	succeeded := 0.
	total := Smalltalk allClasses inject: 0 into: [ :sum :each | sum + each methodDict size].
	Transcript cr; show: 'Total methods in image: ', total asString.
	[
		self allMethodsDo: 
			[ :eachMethod |
				[ converted := converted + 1. aBlock value: eachMethod. succeeded := succeeded + 1.
				(converted \\ 500 = 0) ifTrue: [ Transcript cr; show: 'Converted ', converted asString, ' methods.' ]
				]
					on: Exception do: [ :err | Transcript cr; show: '	', converted asString, ': ', eachMethod name, ' (', err, ')' ]].
	]
		ensure: [ Transcript cr; show: 'Finished!! ', succeeded asString, ' of ', converted asString, ' operations succeeded!!' ].! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'lw 4/7/2011 09:52'!
applyRule: aRule on: aMatcher

	^ aMatcher apply: aRule! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/13/2010 14:34'!
classNamed: aClassOrClassname
	
	^ Smalltalk classNamed: aClassOrClassname asString! !

!OrcaOMeta2 class methodsFor: 'converting' stamp: 'LT 3/16/2011 14:13:51.508'!
convert: aString as: aRule
	
	^ (self convert: aString as: aRule insideMethod: nil) value! !

!OrcaOMeta2 class methodsFor: 'converting' stamp: 'lw 4/7/2011 09:50'!
convert: aString as: aRule insideMethod: aCompiledMethod
	"Returns both the matcher and the result as an association."
	
	| matcher result input |
	input := self createInputFrom: aString as: aRule insideMethod: aCompiledMethod.
	matcher := self matcherOn: input value readStream.
	matcher
		currentMethod: aCompiledMethod;
		apply: #empty.
	result := self applyRule: aRule on: matcher.
	matcher finalize.
	^(input key isNil and: [ matcher respondsTo: #calledFunctions ]) 
		ifTrue: [ matcher calledFunctions -> result ]
		ifFalse: [ input key -> result ]! !

!OrcaOMeta2 class methodsFor: 'tests' stamp: 'ag 12/15/2010 16:26'!
convertAllMethods
	"Convert all methods in this image."
	
	self allMethodsDoAndReport: [ :eachMethod | 
		self convertCompiledMethod: eachMethod].! !

!OrcaOMeta2 class methodsFor: 'tests' stamp: 'LT 3/16/2011 14:07:52.228'!
convertAllMethodsOf: aClass
	
	^ aClass methodDict notEmpty
		ifTrue: [ | methods |
			methods := Dictionary new.
			aClass methodDict valuesDo:
				[ :method | | result |
					[ result := self convertCompiledMethod: method ]
						on: Exception do: [ :err | self error: 'Failed to convert ', method printString, ': ', err ].
					methods at: result key put: result value].
			methods]
		ifFalse: [ self error: 'Cannot convert class ', aClass name ]! !

!OrcaOMeta2 class methodsFor: 'converting' stamp: 'LT 3/16/2011 14:13:42.27'!
convertCompiledMethod: aCompiledMethod
	
	^ (self
		convert: (
			(aCompiledMethod methodClass compilerClass == Compiler)
				ifTrue: [ self sourceOf: aCompiledMethod ]
				ifFalse: [ self decompiledSourceOf: aCompiledMethod ])
		as: #method
		insideMethod: aCompiledMethod) value! !

!OrcaOMeta2 class methodsFor: 'converting' stamp: 'ag 12/13/2010 16:06'!
convertDoIt: aString
	
	^ self convert: aString as: #doItSnippet! !

!OrcaOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:19'!
convertMethod: aString
	
	^ self convert: aString as: #method! !

!OrcaOMeta2 class methodsFor: 'converting' stamp: 'ag 1/19/2011 15:57'!
convertMethod: aStringOrSymbol of: aClassOrClassname
	
	| method |
	method := self method: aStringOrSymbol of: aClassOrClassname.
	^ method
		ifNotNil: [ self convertCompiledMethod: method ]
		ifNil: [  ]! !

!OrcaOMeta2 class methodsFor: 'tests' stamp: 'ag 4/6/2011 15:52'!
convertRandomMethods: aNumber
	"Match some random methods from the image. Return a String summarizing the result.
	Failed methods are printed to the Transcript."
	
	| runs successes |
	runs := successes := 0.
	aNumber timesRepeat: 
		[ | method |
			method := self randomMethod.
			method ifNotNil: [
				[ runs := runs + 1. OrcaParser convertCompiledMethod: method. successes := successes + 1 ]
					on: Error do: [ :err | Transcript cr; cr; show: 'Failed to parse: ', method name, '. ', err ]]].
	^ runs asString, ' runs, ', successes asString, ' successes'! !

!OrcaOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:08'!
convertStatements: aString
	
	^ self convert: aString as: #statements! !

!OrcaOMeta2 class methodsFor: 'converting' stamp: 'LT 3/16/2011 14:37:35.181'!
convertTranslatedMethod: aTranslatedMethod
	
	| compiledMethod |
	compiledMethod := aTranslatedMethod squeakObject.
	^ self
		convert: (
			(compiledMethod methodClass compilerClass == Compiler)
				ifTrue: [ self sourceOf: compiledMethod ]
				ifFalse: [ self decompiledSourceOf: compiledMethod ])
		as: #method
		insideMethod: compiledMethod.! !

!OrcaOMeta2 class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:12'!
createInputFrom: aString as: aRule insideMethod: aCompiledMethod
	
	self subclassResponsibility! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'ag 2/1/2011 10:31'!
decompiledSourceOf: aCompiledMethod
	
	^ aCompiledMethod decompile decompileString! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'ag 1/19/2011 15:59'!
method: aStringOrSymbol of: aClassOrClassname
	
	^ self
		method: aStringOrSymbol
		of: aClassOrClassname 
		ifAbsent: [ self error: 'Method ', aStringOrSymbol asString, ' not found in class ', aClassOrClassname asString ]! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'ag 1/19/2011 15:59'!
method: aStringOrSymbol of: aClassOrClassname ifAbsent: aBlock
	
	^ ((self classNamed: aClassOrClassname)
		lookupSelector: aStringOrSymbol asSymbol)
			ifNil: [ aBlock value ]! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'ag 1/10/2011 08:58'!
print: aString to: aFilename
	"Create new file aFilename (or override) and write aString in it"
	
	^ aString squeakToUtf8 putOn: (FileStream forceNewFileNamed: aFilename)! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'ag 2/1/2011 10:33'!
randomMethod
	
	| class result |
	result := nil.
	[ result isNil ] whileTrue: [
		class := Smalltalk allClasses atRandom.
		class methodDict notEmpty
			ifTrue: [ result := class methodDict atRandom ]].
	^ result! !

!OrcaOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 18:18'!
sourceOf: aCompiledMethod
	
	^ aCompiledMethod getSource asString! !

!OrcaOMeta2 methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
H =
	
	[ self halt ]! !

!OrcaOMeta2 methodsFor: 'accessors' stamp: 'lw 4/6/2011 17:59'!
currentMethod
	
	^ currentMethod! !

!OrcaOMeta2 methodsFor: 'accessors' stamp: 'lw 4/6/2011 17:59'!
currentMethod: aCompiledMethod
	
	currentMethod := aCompiledMethod! !

!OrcaOMeta2 methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
fail =
	
	?[ false ]! !

!OrcaOMeta2 methodsFor: 'helpers' stamp: 'lw 4/7/2011 09:50'!
finalize

	"Do nothing. Is overwritten in OrcaParser"
	self apply: #end.
! !

!OrcaOMeta2 methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
nil =
	
	anything:object ?[ object isNil ]
	-> [ object ]! !

!OrcaOMeta2 methodsFor: 'helpers' stamp: 'lw 4/6/2011 17:59'!
node: aString
	
	^ self node: aString with: {}! !
